searchNodes=[{"doc":"Compute the hash of a file or multiple files in directory.example:mix scenic.hash mix.exs &gt;&gt; File hash using :sha &gt;&gt; mix.exs -&gt; &quot;SjGBfd6TiDy7kbknjxt1uFbui6Q&quot;Options--hash hash_typeYou can specify which hash algorithm to use with the --hash switch. The valid hash types you can specify are [ sha, sha224, sha256, sha384, sha512, ripemd160 ]mix scenic.hash mix.exs --hash sha256 &gt;&gt; File hash using :sha256 &gt;&gt; mix.exs -&gt; &quot;Svs-U3-UaMvp5i_Okpj9v92oX5uQmGIp0WHn_aRWt2w&quot;You can also point it at a directory to have it hash the files withinmix scenic.hash guides &gt;&gt; File hash using :sha &gt;&gt; guides/overview_graph.md -&gt; &quot;xu6ihkVwAX7W8-Rzr2U769DR46w&quot; &gt;&gt; guides/overview_general.md -&gt; &quot;UNcd84guRIEBK5a0tWdp5MYmJpI&quot; &gt;&gt; guides/overview_driver.md -&gt; &quot;zsTJ_xDQGrXLBtQk80hSUt-wZYE&quot; &gt;&gt; guides/scene_lifecycle.md -&gt; &quot;jNcP7dPNXon0zEMtyCqL2z-A7FY&quot; &gt;&gt; guides/overview_scene.md -&gt; &quot;apxgZRkCBHZeNNzCMpxgQRytHLA&quot; &gt;&gt; guides/getting_started.md -&gt; &quot;v1So-K14iPs_mGQZqr237TPah8I&quot; &gt;&gt; guides/overview_viewport.md -&gt; &quot;3TpXIFxcwG54N2bb0O-86aznSS4&quot; &gt;&gt; guides/mix_tasks.md -&gt; &quot;CWp9l8tDfHf5czjJqpbKtPqaqlc&quot;","ref":"Mix.Tasks.Scenic.Hash.html","title":"Mix.Tasks.Scenic.Hash","type":"task"},{"doc":"Starts the applicationThe --no-halt flag is automatically added.","ref":"Mix.Tasks.Scenic.Run.html","title":"Mix.Tasks.Scenic.Run","type":"task"},{"doc":"The Scenic module itself is a supervisor that manages all the machinery that makes the Scenes, ViewPorts, and Drivers run.In order to run any Scenic application, you will need to start the Scenic supervisor in your supervision tree.Load a configuration for one or more ViewPorts, then add Scenic to your root supervisor.defmodule MyApp do def start(_type, _args) do import Supervisor.Spec, warn: false # load the viewport configuration from config main_viewport_config = Application.get_env(:my_app :viewport) # start the application with the viewport children = [ supervisor(Scenic, [viewports: [main_viewport_config]]), ] Supervisor.start_link(children, strategy: :one_for_one) end endNote that you can start the Scenic supervisor without any ViewPort Configurations. In that case, you are responsible for supervising the ViewPorts yourself. This is not recommended for devices as Scenic should know how to restart the main ViewPort in the event of an error.","ref":"Scenic.html","title":"Scenic","type":"module"},{"doc":"Return the current Mix env","ref":"Scenic.html#mix_env/0","title":"Scenic.mix_env/0","type":"function"},{"doc":"Return the current version of scenic","ref":"Scenic.html#version/0","title":"Scenic.version/0","type":"function"},{"doc":"About ComponentsComponents are small scenes that are referenced, and managed, by another scene. They are useful for reusing bits of UI and containing the logic that runs them.Helper FunctionsThis module contains a set of helper functions to make it easy to add, or modify, the standard components in a graph.In general, each helper function is of the form:def name_of_component(graph, data, options \\\\ [])Unlike primitives, components are scenes in themselves. Each component is run by a GenServer and adding a basic component does two things.A new component GenServer is started and supervised by the owning scene's dynamic scene supervisor.A reference to the new scene is added to the graph.This doesn't happen all at once. These helper functions simply add a reference to a to-be-started component to your graph. When you push a graph, the ViewPort then manages the life cycle of the components.You can also supervise components yourself, but then you should add the scene reference yourself via the scene_ref/3 function, which is in the Scenic.Primitives module.When adding components to a graph, each helper function accepts a graph as the first parameter and returns the transformed graph. This makes is very easy to build a complex graph by piping helper functions together.@graph Graph.build() |&gt; button(&quot;Press Me&quot;, id: :sample_button)When modifying a graph, you can again use the helpers by passing in the component to be modified. The transformed component will be returned.Graph.modify(graph, :sample_button, fn(p) -&gt; button(p, &quot;Continue&quot;) end) # or, more compactly... Graph.modify(graph, :sample_button, &amp;button(&amp;1, &quot;Continue&quot;))In each case, the second parameter is a data term that is specific to the component being acted on. See the documentation below. If you pass in invalid data for the second parameter an error will be thrown along with some explanation of what it expected.The third parameter is a keyword list of options that are to be applied to the component. This includes setting the id, styles, transforms and such.@graph Graph.build() |&gt; button(&quot;Press Me&quot;, id: :sample_button, rotate: 0.4)Event messagesMost basic or input components exist to collect data and/or send messages to the host scene that references.For example, when a button scene decides that it has been &quot;clicked&quot;, the generic button component doesn't know how to do anything with that information. So it sends a {:click, id} to the host scene that referenced it.That scene can intercept the message, act on it, transform it, and/or send it up to the host scene that references it. (Components can be nested many layers deep)To do this, the host scene should implement the filter_event callback.Examples: def filter_event({:click, :sample_button}, _, state) do {:halt, state} end def filter_event({:click, :sample_button}, _, state) do {:cont, {:click, :transformed}, state} endInside a filter_event callback you can modify a graph, change state, send messages, transform the event, stop the event, and much more.","ref":"Scenic.Components.html","title":"Scenic.Components","type":"module"},{"doc":"Add a Button to a graphA button is a small scene that is pretty much just some text drawn over a rounded rectangle. The button scene contains logic to detect when the button is pressed, tracks it as the pointer moves around, and when it is released.Datatitletitle - a bitstring describing the text to show in the buttonMessagesIf a button press is successful, it sends an event message to the host scene in the form of:{:click, id}StylesButtons honor the following standard styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :primaryAdditional StylesButtons honor the following list of additional styles.:width - pass in a number to set the width of the button.:height - pass in a number to set the height of the button.:radius - pass in a number to set the radius of the button's rounded rectangle.:alignment - set the alignment of the text inside the button. Can be one of :left, :right, :center. The default is :center.:button_font_size - the size of the font in the buttonButtons do not use the inherited :font_size style as they should look consistent regardless of what size the surrounding text is.ThemeButtons work well with the following predefined themes: :primary, :secondary, :success, :danger, :warning, :info, :text, :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text in the button:background - the normal background of the button:active - the background while the button is pressedExamplesThe following example creates a simple button and positions it on the screen.graph |&gt; button(&quot;Example&quot;, id: :button_id, translate: {20, 20})The next example makes the same button as before, but colors it as a warning button. See the options list above for more details.graph |&gt; button(&quot;Example&quot;, id: :button_id, translate: {20, 20}, theme: :warning)","ref":"Scenic.Components.html#button/3","title":"Scenic.Components.button/3","type":"function"},{"doc":"Generate an uninstantiated button spec, parallel to the concept of primitive specs. This allows buttons to be treated as data.","ref":"Scenic.Components.html#button_spec/2","title":"Scenic.Components.button_spec/2","type":"function"},{"doc":"Add a Checkbox to a graphData{text, checked?}text - must be a bitstringchecked? - must be a boolean and indicates if the checkbox is set.MessagesWhen the state of the checkbox, it sends an event message to the host scene in the form of:{:value_changed, id, checked?}StylesButtons honor the following standard styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkThemeCheckboxes work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text in the button:background - the background of the box:border - the border of the box:active - the border of the box while the button is pressed:thumb - the color of the check mark itselfExamplesThe following example creates a checkbox and positions it on the screen.graph |&gt; checkbox({&quot;Example&quot;, true}, id: :checkbox_id, translate: {20, 20})","ref":"Scenic.Components.html#checkbox/3","title":"Scenic.Components.checkbox/3","type":"function"},{"doc":"Generate an uninstantiated checkbox spec, parallel to the concept of primitive specs. See Components.checkbox for data and options values.","ref":"Scenic.Components.html#checkbox_spec/2","title":"Scenic.Components.checkbox_spec/2","type":"function"},{"doc":"Add a Dropdown to a graphData{items, initial_item}items - must be a list of items, each of which is: {text, id}. See below...initial_item - the id of the initial selected item. It can be any term you want, however it must be an item_id in the items list. See below.Per item data:{text, item_id}text - a string that will be shown in the dropdown.item_id - any term you want. It will identify the item that is currently selected in the dropdown and will be passed back to you during event messages.MessagesWhen the state of the checkbox, it sends an event message to the host scene in the form of:{:value_changed, id, selected_item_id}OptionsDropdowns honor the following list of options.StylesButtons honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkAdditional StylesButtons honor the following list of additional styles.:width - pass in a number to set the width of the button.:height - pass in a number to set the height of the button.:direction - what direction should the menu drop. Can be either :down or :up. The default is :down.ThemeDropdowns work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text:background - the background of the component:border - the border of the component:active - the background of selected item in the dropdown list:thumb - the color of the item being hovered overExamplesThe following example creates a dropdown and positions it on the screen.graph |&gt; dropdown({[ {&quot;Dashboard&quot;, :dashboard}, {&quot;Controls&quot;, :controls}, {&quot;Primitives&quot;, :primitives} ], :controls}, id: :dropdown_id, translate: {20, 20})","ref":"Scenic.Components.html#dropdown/3","title":"Scenic.Components.dropdown/3","type":"function"},{"doc":"Generate an uninstantiated dropdown spec, parallel to the concept of primitive specs. See Components.dropdown for data and options values.","ref":"Scenic.Components.html#dropdown_spec/2","title":"Scenic.Components.dropdown_spec/2","type":"function"},{"doc":"Add a RadioGroup to a graphDataradio_buttonsradio_buttons must be a list of radio button data. See below.Radio button data:{text, radio_id, checked? \\\\ false}text - must be a bitstringbutton_id - can be any term you want. It will be passed back to you as the group's value.checked? - must be a boolean and indicates if the button is selected. checked? is not required and will default to false if not supplied.MessagesWhen the state of the radio group changes, it sends an event message to the host scene in the form of:{:value_changed, id, radio_id}OptionsRadio Buttons honor the following list of options.:theme - This sets the color scheme of the button. This can be one of pre-defined button schemes :light, :dark, or it can be a completely custom scheme like this: {text_color, box_background, border_color, pressed_color, checkmark_color}.StylesRadio Buttons honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkThemeRadio buttons work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text:background - the background of the component:border - the border of the component:active - the background of the circle while the button is pressed:thumb - the color of inner selected-markExamplesThe following example creates a radio group and positions it on the screen.graph |&gt; radio_group([ {&quot;Radio A&quot;, :radio_a}, {&quot;Radio B&quot;, :radio_b, true}, {&quot;Radio C&quot;, :radio_c}, ], id: :radio_group_id, translate: {20, 20})","ref":"Scenic.Components.html#radio_group/3","title":"Scenic.Components.radio_group/3","type":"function"},{"doc":"Generate an uninstantiated radio_group spec, parallel to the concept of primitive specs. See Components.radio_group for data and options values.","ref":"Scenic.Components.html#radio_group_spec/2","title":"Scenic.Components.radio_group_spec/2","type":"function"},{"doc":"Add a Slider to a graphData{ extents, initial_value}extents gives the range of values. It can take several forms...{min, max} If min and max are integers, then the slider value will be an integer.{min, max} If min and max are floats, then the slider value will be an float.[a, b, c] A list of terms. The value will be one of the termsinitial_value Sets the initial value (and position) of the slider. It must make sense with the extents you passed in.MessagesWhen the state of the slider changes, it sends an event message to the host scene in the form of:{:value_changed, id, value}OptionsSliders honor the following list of options.StylesSliders honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkThemeSliders work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::border - the color of the slider line:thumb - the color of slider thumbExamplesThe following example creates a numeric slider and positions it on the screen.graph |&gt; slider({{0,100}, 0}, id: :num_slider, translate: {20,20})The following example creates a list slider and positions it on the screen.graph |&gt; slider({[ :white, :cornflower_blue, :green, :chartreuse ], :cornflower_blue}, id: :slider_id, translate: {20,20})","ref":"Scenic.Components.html#slider/3","title":"Scenic.Components.slider/3","type":"function"},{"doc":"Generate an uninstantiated slider spec, parallel to the concept of primitive specs. See Components.slider for data and options values.","ref":"Scenic.Components.html#slider_spec/2","title":"Scenic.Components.slider_spec/2","type":"function"},{"doc":"Add a TextField input to a graphDatainitial_valueinitial_value - is the string that will be the starting valueMessagesWhen the text in the field changes, it sends an event message to the host scene in the form of:{:value_changed, id, value}StylesText fields honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkAdditional StylesText fields honor the following list of additional styles.:filter - Adding a filter option restricts which characters can be entered into the text_field component. The value of filter can be one of::all - Accept all characters. This is the default:number - Any characters from &quot;0123456789.,&quot;&quot;filter_string&quot; - Pass in a string containing all the characters you will acceptfunction/1 - Pass in an anonymous function. The single parameter will be the character to be filtered. Return true or false to keep or reject it.:hint - A string that will be shown (greyed out) when the entered value of the component is empty.:type - Can be one of the following options::all - Show all characters. This is the default.:password - Display a string of '*' characters instead of the value.:width - set the width of the control.ThemeText fields work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text:background - the background of the component:border - the border of the component:focus - the border while the component has focusExamplesgraph |&gt; text_field(&quot;Sample Text&quot;, id: :text_id, translate: {20,20}) graph |&gt; text_field( &quot;&quot;, id: :pass_id, type: :password, hint: &quot;Enter password&quot;, translate: {20,20} )","ref":"Scenic.Components.html#text_field/3","title":"Scenic.Components.text_field/3","type":"function"},{"doc":"Generate an uninstantiated text_field spec, parallel to the concept of primitive specs. See Components.text_field for data and options values.","ref":"Scenic.Components.html#text_field_spec/2","title":"Scenic.Components.text_field_spec/2","type":"function"},{"doc":"Add Toggle to a Scenic graph.Dataon?on? - true if the toggle is on, pass false if not.StylesToggles honor the following styles. The :light and :dark styles look nice. The other bundled themes...not so much. You can also supply your own theme.:hidden - If false the toggle is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkAdditional StylesToggles also honor the following additional styles.:border_width - the border width. Defaults to 2.:padding - the space between the border and the thumb. Defaults to 2:thumb_radius - the radius of the thumb. This determines the size of the entire toggle. Defaults to 10.ThemeTo pass in a custom theme, supply a map with at least the following entries::border - the color of the border around the toggle:background - the color of the track when the toggle is off.:text - the color of the thumb.:thumb - the color of the track when the toggle is on.Optionally, you can supply the following entries::thumb_pressed - the color of the thumb when pressed. Defaults to :gainsboro.ExamplesThe following example creates a toggle.graph |&gt; toggle(true, translate: {20, 20})The next example makes a larger toggle.graph |&gt; toggle(true, translate: {20, 20}, thumb_radius: 14)","ref":"Scenic.Components.html#toggle/3","title":"Scenic.Components.toggle/3","type":"function"},{"doc":"Generate an uninstantiated toggle spec, parallel to the concept of primitive specs. See Components.toggle for data and options values.","ref":"Scenic.Components.html#toggle_spec/2","title":"Scenic.Components.toggle_spec/2","type":"function"},{"doc":"Please see Graph Overview for a high-level description.What is a GraphThere are many types of graphs in the field of Computer Science. There are graphs that show data to a user. There are graphs that give access to databases. Graphs that link people to a social network.In Scenic, a Graph is a graph in same way that the DOM in HTML is a graph. It is a hierarchical tree of data that describes a set of things to draw on the screen.You build a graph by appending primitives (individual things to draw) to the current node in the tree. Nodes are represented by the Group primitive in Scenic.The following example builds a simple graph that displays some text, creates a group, then adds more text and a rounded rectangle to it.@graph Scenic.Graph.build() |&gt; text( &quot;This is some text&quot;, translate: {20, 20} ) |&gt; group( fn(graph) -&gt; graph |&gt; text( &quot;This text is in a group&quot;, translate: {200, 24} ) |&gt; rounded_rectangle( {400, 30}, stroke: {2, :blue}) end, translate: {20, 100}, text_align: :center)There is a fair amount going on in the example above, we will break it down line by line. The first line@graph Scenic.Graph.build()builds an empty graph with only one group as the root node. By assigning it to the compile directive @group, we know that this group will be built once at compile time and will be very fast to access later during runtime.The empty graph that is returned from build() is then passed to text(...), which adds a text primitive to the root group. The graph returned from that call is then passed again into the group(...) call. This creates a new group and then calls an anonymous function that you can use to add primitives to the newly created group.Notice that the anonymous &quot;builder&quot; function receives a graph as its only parameter. This is the same graph that we are building, except that it has a marker indicating that new primitives added to it are inserted into the new group instead of the root of the graph.Finally, when the group is finished, a translation matrix and a :text_align style are added to it. These properties are inherited by the primitives in the group.InheritanceAn important concept to understand is that both styles and transforms are inherited down the graph. This means that if you apply a style or transform to any group (including the root), then all primitives contained by that group will have those properties applied to them too. This is true even if the primitive is nested in several groups at the same time.@graph Scenic.Graph.build(font: :roboto_mono) |&gt; text( &quot;This text inherits the font&quot;, translate: {20, 20} ) |&gt; group( fn(graph) -&gt; graph |&gt; text( &quot;This text also inherits the font&quot;, translate: {200, 24} ) |&gt; text( &quot;This text overrides the font&quot;, font: :roboto ) end, translate: {20, 100}, text_align: :center)Transforms, such as translate, rotate, scale, also inherit down the graph, but do so slightly differently than the styles. With a style, when you set a specific value on a primitive, that overrides the inherited value of the same type.With a transform, the values multiply together. This allows you to position items within a group relative to the origin {0,0}, then move the group as a whole, keeping the interior positions unchanged.Modifying a GraphScenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data.As such, once you make a graph, it stays in memory unchanged - until you transform it via Graph.modify/3. Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it.Graph.modify/3 is the single Graph function that you will use the most.For example, lets go back to our graph with the two text items in it.@graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}, id: :small_text) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, scale: 1.5, id: :big_text)This time, we've assigned ids to both of the text primitives. This makes it easy to find and modify that primitive in the graph.graph = @graph |&gt; Graph.modify( :small_text, &amp;text(&amp;1, &quot;Smaller Hello&quot;, font_size: 16)) |&gt; Graph.modify( :big_text, &amp;text(&amp;1, &quot;Bigger Hello&quot;, font_size: 60))Notice that the graph is modified multiple times in the pipeline. The push_graph/1 function is relatively heavy when the graph references other scenes. The recommended pattern is to make multiple changes to the graph .Accessing PrimitivesWhen using a Graph, it is extremely common to access and modify primitives. The way you do this is by putting an id on the primitives you care about in a graph.@graph Graph.build() |&gt; text(&quot;small text&quot;, id: :small_text) |&gt; text(&quot;bit text&quot;, id: :big_text)When you get primitives, or modify a graph, you specify them by id. This happens quickly, but at a cost of using a little memory. If you aren't going to access a primitive, then don't assign an id to them.One interesting note: There is nothing saying you have to use an atom as the id. In fact you can use any Erlang term you want. This can be very powerful, especially when used to identify components...","ref":"Scenic.Graph.html","title":"Scenic.Graph","type":"module"},{"doc":"Add a pre-built primitive to the current group in the graph.This is usually called during graph construction. When a new Group primitive is added to a Graph, it marks the new group as the current one before calling the group's builder function. This is what allows you to add primitives to the correct place in the new Group.Note: All primitives added to a group are appended to the draw order.","ref":"Scenic.Graph.html#add/2","title":"Scenic.Graph.add/2","type":"function"},{"doc":"Build and add a primitive to the current group in the graph.This is usually called during graph construction. When a new Group primitive is added to a Graph, it marks the new group as the current one before calling the group's builder function. This is what allows you to add primitives to the correct place in the new Group.Note: All primitives added to a group are appended to the draw order.","ref":"Scenic.Graph.html#add/4","title":"Scenic.Graph.add/4","type":"function"},{"doc":"Add to a specified group in a graph.Similar to adding a group during graph construction, the add_to function accepts a builder function that adds to a graph under the identified group.Primitives with the id that are not groups are ignored.If multiple groups have the given id, then the builder is run against each of them.","ref":"Scenic.Graph.html#add_to/3","title":"Scenic.Graph.add_to/3","type":"function"},{"doc":"Builds and returns an empty graph.Just like any primitive, you can pass in an option list of styles and transforms. These will be applied to the otherwise empty root group in the new graph.","ref":"Scenic.Graph.html#build/1","title":"Scenic.Graph.build/1","type":"function"},{"doc":"Returns a count of all the primitives in a graph.The root Group counts as a primitive, so an empty graph should have a count of 1.","ref":"Scenic.Graph.html#count/1","title":"Scenic.Graph.count/1","type":"function"},{"doc":"Returns a count of all the primitives in a graph with a specific id.","ref":"Scenic.Graph.html#count/2","title":"Scenic.Graph.count/2","type":"function"},{"doc":"Permanently delete a primitive from a group by id.This will remove a primitive (or many if they have the same id) from a graph. It then returns the modified graph.If you delete a group from a graph, then all primitives contained by that group are deleted as well.","ref":"Scenic.Graph.html#delete/2","title":"Scenic.Graph.delete/2","type":"function"},{"doc":"Find one or more primitives in a graph via a filter function.Pass in a function that accepts a primitive and returns a boolean.Returns a list of tuples containing the matching id at the primitive.[{id, primitive}]Warning: This function crawls the entire graph and is thus slower than accessing items via a fully-specified id.","ref":"Scenic.Graph.html#find/2","title":"Scenic.Graph.find/2","type":"function"},{"doc":"Returns a list of primitives from a graph with a specific id.","ref":"Scenic.Graph.html#get/2","title":"Scenic.Graph.get/2","type":"function"},{"doc":"Returns a single primitive from a graph with a specific id.This will raise an error if either none or multiple primitives are found with the specified id.","ref":"Scenic.Graph.html#get!/2","title":"Scenic.Graph.get!/2","type":"function"},{"doc":"Map all primitives in a graph into a new graph.Crawls through the entire graph, passing each primitive to the callback function. The result of the callback replaces that primitive in the graph. The updated graph is returned.","ref":"Scenic.Graph.html#map/2","title":"Scenic.Graph.map/2","type":"function"},{"doc":"Map all primitives in a graph that match a specified id into a new graph.Crawls through the entire graph, passing each primitive to the callback function. The result of the callback replaces that primitive in the graph. The updated graph is returned.This is so similar to the modify function that it may be deprecated in the future. For now I recommend you use Graph.modify/3 instead of this.","ref":"Scenic.Graph.html#map/3","title":"Scenic.Graph.map/3","type":"function"},{"doc":"Modify one or more primitives in a graph.Retrieves the primitive (or primitives) specified by id and passes them to a callback function. The result of the callback function is stored as the new version of that primitive in the graph.If multiple primitives match the specified id, then each is passed, in turn, to the callback function.The id can be eithera term to match against (fast)a filter function that returns a boolean (slower)Examples:graph |&gt; Graph.modify( :explicit_id, &amp;text(&amp;1, &quot;Updated Text 1&quot;) ) |&gt; Graph.modify( {:id, 123}, &amp;text(&amp;1, &quot;Updated Text 2&quot;) ) |&gt; Graph.modify( &amp;match?({:id,_},&amp;1), &amp;text(&amp;1, &quot;Updated Text 3&quot;) )","ref":"Scenic.Graph.html#modify/3","title":"Scenic.Graph.modify/3","type":"function"},{"doc":"Invokes action for each primitive in the graph with the accumulator.Iterates over all primitives in a graph, passing each into the callback function with an accumulator. The return value of the callback is the new accumulator.This is extremely similar in behaviour to Elixir's Enum.reduce function, except that it understands how to navigate the tree structure of a Graph.","ref":"Scenic.Graph.html#reduce/3","title":"Scenic.Graph.reduce/3","type":"function"},{"doc":"Invokes action for each primitive that matches an id in the graph with the accumulator.Iterates over all primitives that match a specified id, passing each into the callback function with an accumulator.This is extremely similar in behaviour to Elixir's Enum.reduce function, except that it understands how to navigate the tree structure of a Graph.","ref":"Scenic.Graph.html#reduce/4","title":"Scenic.Graph.reduce/4","type":"function"},{"doc":"","ref":"Scenic.Graph.html#t:deferred/0","title":"Scenic.Graph.deferred/0","type":"type"},{"doc":"","ref":"Scenic.Graph.html#t:key/0","title":"Scenic.Graph.key/0","type":"type"},{"doc":"","ref":"Scenic.Graph.html#t:t/0","title":"Scenic.Graph.t/0","type":"type"},{"doc":"A set of helper functions to make it easy to add to, or modify, a graph.In general, each helper function is of the formdef name_of_primitive( graph, data, opts \\\\ [] )ordef name_of_primitive_spec( data, opts \\\\ [] )The first form builds the primitive immediately and adds it to the graph that is passed in. The second form creates a specification for the primitive (basically, a data structure describing how to draw it). You then add this to a graph at some later time.Let's start by looking at the immediate versions.Immediate Primitive HelpersWhen adding primitives to a graph, each helper function accepts a graph as the first parameter and returns the transformed graph. This makes it very easy to build a complex graph by piping helper functions together.@graph Graph.build() |&gt; text( &quot;Hello World&quot; ) |&gt; rectangle( {100, 200} ) |&gt; line( {{10,20}, {100, 20}})When modifying a graph, you can again use the helpers by passing in the primitive to be modified. The transformed primitive will be returned.Graph.modify(graph, :rect, fn(p) -&gt; rectangle(p, {200, 300}) end) # or, more compactly... Graph.modify(graph, :rect, &amp;rectangle(&amp;1, {200, 300}) )In each case, the second parameter is a data term that is specific to the primitive being acted on. See the documentation below. If you pass in invalid data for the second parameter, an error will be thrown, along with some explanation of what it expected.The third parameter is a keyword list of options that are to be applied to the primitive. This includes setting the id, styles, transforms and such.@graph Graph.build() |&gt; text( &quot;Hello World&quot;, id: :hello, font_size: 24, rotate: 0.4 ) |&gt; rectangle( {100, 200}, translate: {10, 30}, fill: :yellow) |&gt; line( {{10,20}, {100, 20}}, id: :a_line, stroke: {4, :green})Deferred Primitive HelpersEach immediate primitive helper has a corresponding deferred helper. The deferred variant does not add the primitive to a graph. Instead, the deferred helper returns a function. You can then call that function, passing it a graph, and the primitive will be added to that graph.text = text_spec( &quot;Hello World&quot; ) rect = rectangle_spec( {100, 200} ) line = line_spec( {{10,20}, {100, 20}}) g = Graph.build() g = text.(g) g = rect.(g) g = line.(g)Written like this, the deferred helpers aren't compelling. But we could also writeitems = [ text_spec( &quot;Hello World&quot; ), rectangle_spec( {100, 200} ), line_spec( {{10,20}, {100, 20}}), ] g = items |&gt; Enum.reduce(Graph.build(), fn item, g -&gt; item.(g) end)Deferred helpers let us express primitives as data. This makes it easier to define display graphs at compile time, particularly when we use the group_spec/2 helper to express the grouping of components:@line {{0, 0}, {60, 60}} @lines [ line_spec(@line, stroke: {4, :red}), line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}), line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}), ] @text [ text_spec(&quot;Hello&quot;, translate: {0, 40}), text_spec(&quot;World&quot;, translate: {90, 40}, fill: :yellow), ] @drawing Graph.build() |&gt; add_specs_to_graph([ @lines, @text ])If you wanted to put the lines into one group and the text into another, simply interpose the group_spec/2 helper:@drawing Graph.build() |&gt; add_specs_to_graph([ group_spec(@lines, t: [100, 50]), group_spec(@text, t: [150, 50]) ])If you have a smaller graph or just like to see everything in one place, you might prefer using group_spec_r/2:@line {{0, 0}, {60, 60}} @drawing Graph.build() |&gt; add_specs_to_graph([ group_spec_r([t: {100, 50}], [ line_spec(@line, stroke: {4, :red}), line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}), line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}) ]), group_spec_r([t: {150, 50}], [ text_spec(&quot;Hello&quot;, translate: {0, 40}), text_spec(&quot;World&quot;, translate: {90, 40}, fill: :yellow), ]) ])These examples use add_specs_to_graph/2, a simple helper that converts specs into primitives and adds them to a graph.Style optionsStyle options affect the way primitives are drawn. They include options such as :fill, :stroke, :font and many more. See the Styles documentation for the full list. Style options are inherited down the graph. In other words, if you set a style on the root of the graph like this: Graph.build(font_size: 24), then all text items in all groups will be rendered with a point size of 24 unless they set a different size.Not every primitive accepts every style. For example, it doesn't make much sense to apply a font to a rectangle. If you try, the rectangle will ignore that value. See the documentation for each primitive for a list of what styles they pay attention to.Transforms that are applied to a Group are inherited by all primitives in that group's branch of the tree. Note that style inheritance does not cross SceneRef boundaries.Transform optionsTransform options affect the size, position and rotation of elements in the graph. Any transform you can express as a 4x4 matrix of floats, you can apply to any primitive in the graph, including groups and SceneRefs.Transform options are applied on the element they are specified on. If you specify a transform on a group, then it is applied to everything rendered in that branch of the graph tree.This is done mathematically as a &quot;stack&quot; of transforms. As the renderer traverses up and down the graph, transforms are pushed and popped from the matrix stack as appropriate. Transform inheritance does cross SceneRef boundaries.Draw OrderPrimitives will be drawn in the order you add them to the graph. For example, the graph below draws text on top of a filled rectangle. If the order of the text and rectangle were reversed, they would both still be rendered, but the text would not be visible because the rectangle would cover it up.@graph Graph.build( font: {:roboto, 20} ) |&gt; rect( {100, 200}, color: :blue ) |&gt; text( &quot;Hello World&quot;, id: :hello, translate: {10, 10} )SceneRef primitivesThe scene_ref/3 helper creates/modifies a SceneRef primitive. This is the other special case primitive. Instead of drawing anything directly, it says something like, &quot;render the graph from another scene here&quot;.The SceneRef allows you to compose together components made of other pre-made scenes, or independently supervised scenes, into a single image.The SceneRef follows the same style/transform inheritance as the Group.","ref":"Scenic.Primitives.html","title":"Scenic.Primitives","type":"module"},{"doc":"Given a graph and a list of deferred primitive specifications, run the specs in order, adding the primitives to the graph.Example:items = [ text_spec(&quot;hello &quot;), text_spec(&quot;world&quot;) ] graph = graph |&gt; add_specs_to_graph(items)If given a third parameter, the specs are wrapped in a group, and that parameter is used as the group's options.graph = graph |&gt; add_specs_to_graph(items, t: {100,100})","ref":"Scenic.Primitives.html#add_specs_to_graph/2","title":"Scenic.Primitives.add_specs_to_graph/2","type":"function"},{"doc":"","ref":"Scenic.Primitives.html#add_specs_to_graph/3","title":"Scenic.Primitives.add_specs_to_graph/3","type":"function"},{"doc":"Add an arc to a graphAn arc is the outer edge of a part of a circle or ellipse. It is the sort of thing you would use a compass to draw on a piece of paper. It has a radius, a start angle and an ending angle. The angles are specified in radians.Data:{radius, start, finish}If you want something that looks like a piece of pie (maybe for a pie chart??), then you want a Sector, not an Arc.To create an arc of an ellipse, create a normal arc, and apply a :scale transform with unequal x and y sizing.The following example will draw a simple arc with a radius of 100, starting straight out to the right, then going down 0.4 radians.graph |&gt; arc( {100, 0, 0.4} )StylesArcs honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, but optimized.:stroke - Draws the outline with the specified width and paint. The default if not set is {1, :white}.Example:graph |&gt; arc( {100, 0, 0.4}, stroke: {4, :blue} )","ref":"Scenic.Primitives.html#arc/3","title":"Scenic.Primitives.arc/3","type":"function"},{"doc":"Create the specification that adds an arc to a graph.See the documentation for arc/3 for details.Example:arc = arc_spec( {100, 0, 0.4}, stroke: {4, :blue} ) graph = arc.(graph)","ref":"Scenic.Primitives.html#arc_spec/2","title":"Scenic.Primitives.arc_spec/2","type":"function"},{"doc":"Add a Circle to a graph.Circles are defined by a radius.The following example will draw circle with radius 100.graph |&gt; circle( 100 )StylesCircles honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, but more optimized.:stroke - The width and paint to draw the outline with. If the stroke is not specified, the default stroke is {1, :white}.Example:graph |&gt; circle( 40, fill: :red, stroke: {3, :blue}, translate: {100, 200} )While you could apply a :rotate transform to a circle, it wouldn't do anything visible unless you also add a uneven :scale transform to make it into an ellipse.","ref":"Scenic.Primitives.html#circle/3","title":"Scenic.Primitives.circle/3","type":"function"},{"doc":"Create the specification that adds a circle to a graph.See the documentation for circle/3 for details.Example:circle = circle_spec( 40, stroke: {4, :blue} ) graph = circle.(graph)","ref":"Scenic.Primitives.html#circle_spec/2","title":"Scenic.Primitives.circle_spec/2","type":"function"},{"doc":"Add an Ellipse to a graph.Ellipses are defined by two radii.The following example will draw an ellipse.graph |&gt; ellipse( {100, 140} )If you want the ellipse to be on an angle, apply a :rotate transform.StylesEllipses honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, but optimized.:stroke - The width and paint to draw the outline with. If the stroke is not specified, the default stroke is {1, :white}Example:graph |&gt; ellipse( {40, 60}, fill: :red, stroke: {3, :blue}, rotate: 0.4 )","ref":"Scenic.Primitives.html#ellipse/3","title":"Scenic.Primitives.ellipse/3","type":"function"},{"doc":"Create the specification that adds an ellipse to a graph.See the documentation for ellipse/3 for details.Example:ellipse = ellipse_spec( { 40, 60 }, stroke: {4, :blue} ) graph = ellipse.(graph)","ref":"Scenic.Primitives.html#ellipse_spec/2","title":"Scenic.Primitives.ellipse_spec/2","type":"function"},{"doc":"Create a new branch in a Graph.The Group primitive creates a new branch in the Graph's tree. The data field you pass in is a function callback, which allows you to add more primitives inside the new group.The single parameter to your anonymous callback is a transformed graph that knows to add new primitives to the right branch in the tree.@graph Graph.build( ) |&gt; text( &quot;Hello World&quot; ) |&gt; group(fn(g) -&gt; g |&gt; text( &quot;I&#39;m in the Group&quot; ) end, translate: {40,200})NOTE: Unlike other primitives, group/3 currently only takes a graph and not an existing group primitive.StylesGroups will accept all styles. They don't use the styles directly, but any styles you set on a group become the new defaults for all primitives you add to that group's branch in the graph. Note: styles are not inherited across SceneRefs (see scene_ref/3).The :hidden style is particularly effective when applied to a group as it causes that entire branch to be drawn, or not.TransformsAny transforms you apply to a group are added into the render matrix stack and are applied to all items in that branch, including crossing SceneRefs.","ref":"Scenic.Primitives.html#group/3","title":"Scenic.Primitives.group/3","type":"function"},{"doc":"Bundle a list of specifications together, and return a function that, when called, will add those specs as a group to a graph.The options are the same as for group/3Example:line = {{0, 0}, {60, 60}} lines = [ line_spec(@line, stroke: {4, :red}), line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}), line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}), ] line_group = group_spec(lines, t: [ 100, 100 ]) graph = line_group.(graph)You can also pass in a single primitive spec:line = line_spec({{0, 0}, {60, 60}}, stroke: {4, :red}), line_group = group_spec(line, t: [ 100, 100 ]) graph = line_group.(graph)","ref":"Scenic.Primitives.html#group_spec/2","title":"Scenic.Primitives.group_spec/2","type":"function"},{"doc":"Bundle a list of specifications together, and return a function that, when called, will add those specs as a group to a graph.The options are the same as for group_spec/2, but reversed, making it suitable to use when declaring graph specs as big literals due to the increased readability.Example:line = {{0, 0}, {60, 60}} line_group = group_spec_r([t: {100, 100}], [ line_spec(@line, stroke: {4, :red}), line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}), line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}), ]) graph = line_group.(graph)You can also pass in a single primitive spec:line = line_spec({{0, 0}, {60, 60}}, stroke: {4, :red}), line_group = group_spec_r([t: {100, 100}], line) graph = line_group.(graph)","ref":"Scenic.Primitives.html#group_spec_r/2","title":"Scenic.Primitives.group_spec_r/2","type":"function"},{"doc":"Add a line to a graph.Lines are pretty simple. They start at one point and go to another.Data:{ {from_x, from_y}, {to_x,to_y} }The following example will draw a diagonal line from the upper left corner {0,0} to the point {100,200}, which is down and to the right.graph |&gt; line( {{0,0}, {100,200}} )StylesLines honor the following styles:hidden - If true, the line is skipped. If false, the line is rendered. Default: false.:stroke - The width and paint to draw the line with. If the stroke is not specified, the default stroke is {1, :white}.:cap - Specifies the shape of the ends of the line. Can be one of :round, :butt, or :square. If cap is not specified, then the default is :butt.Example:graph |&gt; line( {{0,0}, {100,200}}, stroke: {4, :blue}, cap: :round )","ref":"Scenic.Primitives.html#line/3","title":"Scenic.Primitives.line/3","type":"function"},{"doc":"Create the specification that adds a line to a graph.See the documentation for line/3 for details.Example:ellipse = ellipse_spec( { 40, 60 }, stroke: {4, :blue} ) graph = ellipse.(graph)","ref":"Scenic.Primitives.html#line_spec/2","title":"Scenic.Primitives.line_spec/2","type":"function"},{"doc":"Add custom, complex shape to a graph.A custom path is defined by a list of actions that the renderer can follow. This is about as close as Scenic gets to immediate mode rendering.See Scenic.Primitive.Path for details.graph |&gt; path( [ :begin, {:move_to, 10, 20}, {:line_to, 30, 40}, {:bezier_to, 10, 11, 20, 21, 30, 40}, {:quadratic_to, 10, 11, 50, 60}, {:arc_to, 70, 80, 90, 100, 20}, :close_path, ], stroke: {4, :blue}, cap: :round )","ref":"Scenic.Primitives.html#path/3","title":"Scenic.Primitives.path/3","type":"function"},{"doc":"Create the specification that adds a path to a graph.See the documentation for path/3 for details.Example:path = path_spec( [ :begin, {:move_to, 10, 20}, {:line_to, 30, 40}, {:bezier_to, 10, 11, 20, 21, 30, 40}, {:quadratic_to, 10, 11, 50, 60}, {:arc_to, 70, 80, 90, 100, 20}, :close_path, ], stroke: {4, :blue}, cap: :round ) graph = path.(graph)","ref":"Scenic.Primitives.html#path_spec/2","title":"Scenic.Primitives.path_spec/2","type":"function"},{"doc":"Add a Quadrilateral (quad) to a graph.Quads are defined by four points on the screen.Data:{ {x0,y0}, {x1,y1}, {x2,y2}, {x3,y3} }The following example will draw a quad.graph |&gt; quad( {{10,20}, {100,20}, {90, 120}, {15, 70}} )StylesQuads honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing.:stroke - The width and paint to draw the outline with. If the stroke is not specified then the default stroke is {1, :white}:join - Specifies how the lines are joined together where they meet. Can be one of :miter, :round, or :bevel. If join is not specified, then the default is :miter:miter_limit - Apply an optional miter limit to the joints. If the angle is very shallow, the pointy bit might extend out far beyond the joint. Specifying :miter_limit puts a limit on the joint and bevels it if it goes out too far.Example:graph |&gt; quad( {{10,20}, {100,20}, {90, 120}, {15, 70}}, fill: :red, stroke: {3, :blue}, join: :round )","ref":"Scenic.Primitives.html#quad/3","title":"Scenic.Primitives.quad/3","type":"function"},{"doc":"Create the specification that adds a quad to a graph.See the documentation for quad/3 for details.Example:quad = quad_spec( {{10,20}, {100,20}, {90, 120}, {15, 70}}, fill: :red, stroke: {3, :blue}, join: :round ) graph = quad.(graph)","ref":"Scenic.Primitives.html#quad_spec/2","title":"Scenic.Primitives.quad_spec/2","type":"function"},{"doc":"Shortcut to the rectangle/3 function.rect/3 is the same as calling rectangle/3","ref":"Scenic.Primitives.html#rect/3","title":"Scenic.Primitives.rect/3","type":"function"},{"doc":"Create the specification that adds a rectangle to a graph.See the documentation for rectangle/3 for details.Example:rect = rect_spec( {{10,20}, {100,20}}, fill: :red, stroke: {3, :blue}, join: :round ) graph = rect.(graph)","ref":"Scenic.Primitives.html#rect_spec/2","title":"Scenic.Primitives.rect_spec/2","type":"function"},{"doc":"Add a rectangle to a graph.Rectangles are defined by a width and height.Data:{ width, height }The following example will draw a rectangle.graph |&gt; rectangle( {100, 200} )StylesRectangles honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing.:stroke - The width and paint to draw the outline with. If the stroke is not specified then the default stroke is {1, :white}:join - Specifies how the lines are joined together where they meet. Can be one of :miter, :round, or :bevel. If join is not specified, then the default is :miter:miter_limit - Apply an optional miter limit to the joints. If the angle is very shallow, the pointy bit might extend out far beyond the joint. Specifying :miter_limit puts a limit on the joint and bevels it if it goes out too far.Example:graph |&gt; rectangle( {100, 200}, fill: :red, stroke: {3, :blue}, join: :round )","ref":"Scenic.Primitives.html#rectangle/3","title":"Scenic.Primitives.rectangle/3","type":"function"},{"doc":"Create the specification that adds a rectangle to a graph.See the documentation for rectangle/3 for details.Example:rect = rectangle_spec( {{10,20}, {100,20}}, fill: :red, stroke: {3, :blue}, join: :round ) graph = rect.(graph)","ref":"Scenic.Primitives.html#rectangle_spec/2","title":"Scenic.Primitives.rectangle_spec/2","type":"function"},{"doc":"Add a rounded rectangle to a graph.Rounded rectangles are defined by a width, height, and radius.Data:{ width, height, radius }The following example will draw a rounded rectangle.graph |&gt; rounded_rectangle( {100, 200, 8} )StylesRounded rectangles honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing.:stroke - The width and paint to draw the outline with. If the stroke is not specified then the default stroke is {1, :white}Example:graph |&gt; rounded_rectangle( {100, 200, 8}, fill: :red, stroke: {3, :blue} )","ref":"Scenic.Primitives.html#rounded_rectangle/3","title":"Scenic.Primitives.rounded_rectangle/3","type":"function"},{"doc":"Create the specification that adds a rounded rectangle to a graph.See the documentation for rounded_rectangle/3 for details.Example:rect = rounded_rectangle_spec( {{10,20}, {100,20}}, fill: :red, stroke: {3, :blue}, join: :round ) graph = rect.(graph)","ref":"Scenic.Primitives.html#rounded_rectangle_spec/2","title":"Scenic.Primitives.rounded_rectangle_spec/2","type":"function"},{"doc":"Shortcut to the rounded_rectangle/3 function.rrect/3 is the same as calling rounded_rectangle/3","ref":"Scenic.Primitives.html#rrect/3","title":"Scenic.Primitives.rrect/3","type":"function"},{"doc":"Create the specification that adds a rounded rectangle to a graph.See the documentation for rounded_rectangle/3 for details.Example:rect = rrect_spec( {{10,20}, {100,20}}, fill: :red, stroke: {3, :blue}, join: :round ) graph = rect.(graph)","ref":"Scenic.Primitives.html#rrect_spec/2","title":"Scenic.Primitives.rrect_spec/2","type":"function"},{"doc":"Reference another scene or graph from within a graph.The SceneRef allows you to nest other graphs inside a graph. This means you can build smaller components that you can compose into a larger image.Typically you do not specify SceneRefs yourself. These get added for you when you add components to your graph. Examples include Buttons, Sliders, checkboxes, and so on.Usually, the graph you reference is controlled by another scene, but it doesn't have to be. A single scene could create multiple graphs and reference them into each other.See Scenic.Primitive.SceneRef for details.Be careful not to create circular references. That won't work well.StylesThe only style that has any meaning on a SceneRef is :hidden. The rest are ignored and are not inherited across to the referenced scene.TransformsAny transforms you apply to a group are added into the render matrix stack and are applied to all items in that branch, including crossing SceneRefs.","ref":"Scenic.Primitives.html#scene_ref/3","title":"Scenic.Primitives.scene_ref/3","type":"function"},{"doc":"Create the specification that adds a scene ref to a graph.See the documentation for scene_ref/3 for details.Example:ref = scene_ref_spec(:my_scene) graph = ref.(graph)","ref":"Scenic.Primitives.html#scene_ref_spec/2","title":"Scenic.Primitives.scene_ref_spec/2","type":"function"},{"doc":"Add a sector to a graphA sector looks like a piece of pie. It is wedge shaped with a pointy bit on one side and a rounded bit on the other. It has a radius, a start angle and a finish angle. The angles are specified in radians.Data:{radius, start, finish}To create a sector of an ellipse, create a normal sector, and apply a :scale transform with unequal x and y sizing.The following example will draw a sector with a radius of 100, starting straight out to the right, then going down 0.4 radians.|&gt; sector( {100, 0, 0.4} )StylesSectors honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, except optimized out to do nothing.:stroke - Draws the outline with the specified width and paint. The default if not set is {1, :white}When you apply a stroke to a sector, it goes around the whole piece of pie. If you only want to stroke the curvy part, which is common in pie charts, overlay an Arc on top of the sector and stroke that.If you also put both the sector and the arc together in a Group, you can then apply transforms to the group to position both the primitives as a single unit.Example:graph |&gt; group(fn(g) -&gt; g |&gt; sector( {100, 0, 0.4}, fill: :red ) |&gt; arc( {100, 0, 0.4}, stroke: {4, :blue} ) end, translate: {30, 40})","ref":"Scenic.Primitives.html#sector/3","title":"Scenic.Primitives.sector/3","type":"function"},{"doc":"Create the specification that adds a sector ref to a graph.See the documentation for sector/3 for details.Example:sector = sector_spec( {100, 0, 0.4}, fill: :red ) graph = sector.(graph)","ref":"Scenic.Primitives.html#sector_spec/2","title":"Scenic.Primitives.sector_spec/2","type":"function"},{"doc":"Adds text to a graph.Text is pretty simple. Specify the string you would like drawn.The following example will draw some text on the screen.graph |&gt; text( &quot;Hello World&quot;, translate: {20, 20} )StylesText honors the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - The paint to color the text with. If not specified, the default is :white. Note: Text can only be filled with solid colors at this time.:font - Specifies font family to draw the text with. The built-in system fonts are :roboto and :roboto_mono. If not specified, the default is :roboto. You can also load your own font into the Scenic.Cache, then specify its key for the font.:font_blur - Draw the text with a blur effect. If you draw text with blur, then draw it again without blur, slightly offset, you get a nice drop shadow effect. The default is to draw with no blur.:text_align - Specify the alignment of the text you are drawing. You will usually specify one of: :left, :center, or :right. You can also specify vertical alignment. See Scenic.Primitive.Style.TextAlign for details.:text_height - Specify the vertical spacing between rows of text.Example:graph |&gt; text( &quot;Hello World&quot;, fill: :yellow, font: :roboto_mono font_blur: 2.0, text_align: :center )","ref":"Scenic.Primitives.html#text/3","title":"Scenic.Primitives.text/3","type":"function"},{"doc":"Create the specification that adds text to a graph.See the documentation for text/3 for details.Example:text = text_spec( &quot;a wombat is a marsupial&quot;, fill: :red ) graph = text.(graph)","ref":"Scenic.Primitives.html#text_spec/2","title":"Scenic.Primitives.text_spec/2","type":"function"},{"doc":"Add a Triangle to a graph.Triangles are defined by three points on the screen.Data:{ {x0,y0}, {x1,y1}, {x2,y2} }The following example will draw a triangle.graph |&gt; triangle( {{10,20}, {100,20}, {50, 120}} )StylesTriangles honor the following styles:hidden - If true, the outline is rendered. If false, it is skipped. Default: false.:fill - Fills in the interior with the specified paint. If not set, the default is to not draw anything in the interior. This is similar to specifying fill: :clear, but optimized.:stroke - The width and paint to draw the outline with. If the stroke is not specified, the default stroke is {1, :white}.:join - Specifies how the lines are joined together where they meet. Can be one of :miter, :round, or :bevel. If join is not specified, then the default is :miter.:miter_limit - Apply an optional miter limit to the joints. If the angle is very shallow, the pointy bit might extend out far beyond the joint. Specifying :miter_limit puts a limit on the joint and bevels it if it goes out too far.Example:graph |&gt; triangle( {{10,20}, {100,20}, {50, 120}}, fill: :red, stroke: {3, :blue}, join: :round )","ref":"Scenic.Primitives.html#triangle/3","title":"Scenic.Primitives.triangle/3","type":"function"},{"doc":"Create the specification that adds a triangle to a graph.See the documentation for triangle/3 for details.Example:triangle = triangle_spec({{10,20}, {100,20}, {50, 120}}, fill: :red ) graph = triangle.(graph)","ref":"Scenic.Primitives.html#triangle_spec/2","title":"Scenic.Primitives.triangle_spec/2","type":"function"},{"doc":"Update the options of a primitive without changing its data.This is not used during graph creation - only when modifying it later.All the primitive-specific helpers require you to specify the data for the primitive. If you only want to modify a transform or add a style, then use this function.Example:Graph.modify(graph, :rect, fn(p) -&gt; update_opts(p, rotate: 0.5) end) # or, more compactly... Graph.modify(graph, :rect, &amp;update_opts(&amp;1, rotate: 0.5) )","ref":"Scenic.Primitives.html#update_opts/2","title":"Scenic.Primitives.update_opts/2","type":"function"},{"doc":"OverviewScenes are the core of the UI model.A Scene has three jobs.Maintain any state specific to that part of your application.Build and maintain a graph of UI primitives that gets drawn to the screen.Handle input and events.A brief asideBefore saying anything else I want to emphasize that the rest of your application, meaning device control logic, sensor reading / writing, services, whatever, does not need to have anything to do with Scenes.In many cases I recommend treating those as separate GenServers in their own supervision trees that you maintain. Then your Scenes would query or send information to/from them via cast or call messages.Part of the point of using Elixir/Erlang/OTP is separating this sort of logic into independent trees. That way, an error in one part of your application does not mean the rest of it will fail.ScenesScenes are the core of the UI model. A scene consists of one or more graphs, and a set of event handlers and filters to deal with user input and other messages.Think of a scene as being a little like an HTML page. HTML pages have:Structure (the DOM)Logic (Javascript)Links to other pages.A Scene has:Structure (graphs),Logic (event handlers and filters)Transitions to other scenes. Well... it can request the ViewPort to go to a different scene.Your application is a collection of scenes that are in use at different times. There is only ever one scene showing in a ViewPort at a given time. However, scenes can reference other scenes, effectively embedding their graphs inside the main one. More on that below.GraphsEach scene should maintain at least one graph. You can build graphs at compile time, or dynamically while your scene is running. Building them at compile time has two advantagesPerformance: It is clearly faster to build the graph once during build time than to build it repeatedly during runtime.Error checking: If your graph has an error in it, it is much better to have it stop compilation than cause an error during runtime.Example of building a graph during compile time: @graph graph.build(font_size: 24) |&gt; button({&quot;Press Me&quot;, :button_id}, translate: {20, 20})Rather than having a single scene maintain a massive graph of UI, graphs can reference graphs in other scenes.On a typical screen of UI, there is one scene that is the root. Each control, is its own scene process with its own state. These child scenes can in turn contain other child scenes. This allows for strong code reuse, isolates knowledge and logic to just the pieces that need it, and keeps the size of any given graph to a reasonable size. For example, the handlers of a check-box scene don't need to know anything about how a slider works, even though they are both used in the same parent scene. At best, they only need to know that they both conform to the Component.Input behaviour, and can thus query or set each others value. Though it is usually the parent scene that does that.The application developer is responsible for building and maintaining the scene's graph. It only enters the world of the ViewPort when you call push_graph. Once you have called push_graph, that graph is sent to the drivers and is out of your immediate control. You update that graph by calling push_graph again.Note: The use of push_graph when returning from a scene update has been deprecated. The use of push: graph in the return value is preferred.This does mean you could maintain two separate graphs and rapidly switch back and forth between them via push_graph. I have not yet hit a good use case for that.Graph ID.This is an advanced feature...Each scene has a default graph id of nil. When you send a graph to the ViewPort by calling push_graph(graph), you are really sending it with a sub-id of nil. This encourages thinking that scenes and graphs have a 1:1 relationship. There are, however, times that you want a single scene to host multiple graphs that can refer to each other via sub-ids. You would push them like this: push_graph(graph, id). Where the id is any term you would like to use as a key.There are several use cases where this makes sense.You have a complex tree (perhaps a lot of text) that you want to animate. Rather than re-rendering the text (relatively expensive) every time you simply transform a rotation matrix, you could place the text into its own static sub-graph and then refer to it from the primary. This will save energy as you animate.Both the Remote and Recording clients make heavy use of sub-ids to make sense of the graph being replayed.The downside of using graph_ids comes with input handling. because you have a single scene handling the input events for multiple graphs, you will need to take extra care to correctly handle position-dependent events, which may not be projected into the coordinate space you think they are. The Remote and Recording clients deal with this by rendering a single, completely transparent rect above all the sub scenes. This invisible, yet present rect hits all the position dependent events and makes sure they are sent to the scene projected in to the main (id is nil) graph's coordinate space.CommunicationsScenes are specialized GenServers. As such, they communicate with each other (and the rest of your application) through messages. You can receive messages with the standard handle_info, handle_cast, handle_call callbacks just like any other scene.Scenes have two new event handling callbacks that you can optionally implement. These are about user input vs UI events.Input vs. EventsInput is data generated by the drivers and sent up to the scenes through the ViewPort. There is a limited set of input types and they are standardized so that the drivers can be built independently of the scenes. Input follows certain rules about which scene receives them.Events are messages that one scene generates for consumption by other scenes. For example, a Component.Button scene would generate a {:click, msg} event that is sent to its parent scene.You can generate any message you want, however, the standard component libraries follow certain patterns to keep things sensible.Input HandlingYou handle incoming input events by adding handle_input/3 functions to your scene. Each handle_input/3 call passes in the input message itself, an input context struct, and your scene's state. You can then take the appropriate actions, including generating events (below) in response.Under normal operation, input that is not position dependent (keys, window events, more...) is sent to the root scene. Input that does have a screen position (cursor_pos, cursor button presses, etc.) Is sent to the scene that contains the graph that was hit.Your scene can &quot;capture&quot; all input of a given type so that it is sent to itself instead of the default scene for that type. this is how a text input field receives the key input. First, the user selects that field by clicking on it. In response to the cursor input, the text field captures text input (and maybe transforms its graph to show that it is selected).Captured input types should be released when no longer needed so that normal operation can resume.The input messages are passed on to a scene's parent if not processed.Event FilteringIn response to input, (or anything else... a timer perhaps?), a scene can generate an event (any term), which is sent backwards up the tree of scenes that make up the current aggregate graph.In this way, a Component.Button scene can generate a{:click, msg} event that is sent to its parent. If the parent doesn't handle it, it is sent to that scene's parent. And so on until the event reaches the root scene. If the root scene also doesn't handle it then the event is dropped.To handle events, you add filter_event/3 functions to your scene. This function handles the event, and stops its progress backwards up the graph. It can handle it and allow it to continue up the graph. Or it can transform the event and pass the transformed version up the graph.You choose the behavior by returning either{:cont, msg, state}or{:halt, state}Parameters passed in to filter_event/3 are the event itself, a reference to the originating scene (which you can to communicate back to it), and your scene's state.A pattern I'm using is to handle an event at the filter and stop its progression. It also generates and sends a new event to its parent. I do this instead of transforming and continuing when I want to change the originating scene.No childrenThere is an optimization you can use. If you know for certain that your component will not attempt to use any components, you can set has_children to false like this.use Scenic.Component, has_children: falseSetting has_children to false this will do two things. First, it won't create a dynamic supervisor for this scene, which saves some resources.For example, the Button component sets has_children to false.","ref":"Scenic.Scene.html","title":"Scenic.Scene","type":"behaviour"},{"doc":"cast a message to a scene.","ref":"Scenic.Scene.html#cast/2","title":"Scenic.Scene.cast/2","type":"function"},{"doc":"","ref":"Scenic.Scene.html#cast_to_refs/2","title":"Scenic.Scene.cast_to_refs/2","type":"function"},{"doc":"Invoked when the Scene receives an event from another scene.Events are messages generated by a scene, that are passed backwards up the ViewPort's scene supervision tree. This is opposed to &quot;input&quot;, which comes directly from the drivers.When an event arrives at a scene, you can consume it, or pass it along to the scene above you in the ViewPort's supervision structure.To consume the input and have processing stop afterward, return either a {:halt, ...} or {:noreply, ...} value. They are effectively the same thing.To allow the scene's parent to process the input, return {:cont, event, state, ...}. Note that you can pass along the event unchanged or transform it in the process if you wish.The callback supports all the return values of the init callback in Genserver.In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport.This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:filter_event/3","title":"Scenic.Scene.filter_event/3","type":"callback"},{"doc":"","ref":"Scenic.Scene.html#handle_call/3","title":"Scenic.Scene.handle_call/3","type":"function"},{"doc":"Invoked to handle synchronous call/3 messages. call/3 will block until a reply is received.The callback supports all the return values of the handle_call callback in Genserver.In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport.This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_call/3","title":"Scenic.Scene.handle_call/3","type":"callback"},{"doc":"","ref":"Scenic.Scene.html#handle_cast/2","title":"Scenic.Scene.handle_cast/2","type":"function"},{"doc":"Invoked to handle asynchronous cast/2 messages.request is the request message sent by a cast/2 and state is the current state of the Scene.The callback supports all the return values of the handle_cast callback in Genserver.In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport.This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_cast/2","title":"Scenic.Scene.handle_cast/2","type":"callback"},{"doc":"Invoked to handle continue instructions.It is useful for performing work after initialization or for splitting the work in a callback in multiple steps, updating the process state along the way.The callback supports all the return values of the handle_continue callback in Genserver.In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport.This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_continue/2","title":"Scenic.Scene.handle_continue/2","type":"callback"},{"doc":"Invoked to handle all other messages.msg is the message and state is the current state of the Scene. When a timeout occurs the message is :timeout.Return values are the same as handle_cast/2.In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport.This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_info/2","title":"Scenic.Scene.handle_info/2","type":"callback"},{"doc":"Invoked when the Scene receives input from a driver.Input is messages sent directly from a driver, usually based on some action by the user. This is opposed to &quot;events&quot;, which are generated by other scenes.When input arrives at a scene, you can consume it, or pass it along to the scene above you in the ViewPort's supervision structure.To consume the input and have processing stop afterward, return either a {:halt, ...} or {:noreply, ...} value. They are effectively the same thing.To allow the scene's parent to process the input, return {:cont, input, state, ...}. Note that you can pass along the input unchanged or transform it in the process if you wish.The callback supports all the return values of the init callback in Genserver.In addition to the normal return values defined by GenServer, a Scene can add an optional {push: graph} term, which pushes the graph to the viewport.This has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_input/3","title":"Scenic.Scene.handle_input/3","type":"callback"},{"doc":"Invoked when the Scene is started.args is the argument term you passed in via config or ViewPort.set_root.options is a list of information giving you context about the environment the scene is running in. If an option is not in the list, then it should be treated as nil.:viewport - This is the pid of the ViewPort that is managing this dynamic scene. It will be not set, or nil, if you are managing the Scene in a static supervisor yourself.:styles - This is the map of styles that your scene can choose to inherit (or not) from its parent scene. This is typically used by a child control that wants to visually fit into its parent's look.:id - This is the :id term that the parent set a component when it was invoked.The callback supports all the return values of the init callback in Genserver.In addition to the normal return values defined by GenServer, a Scene can return two new ones that push a graph to the viewportReturning {:ok, state, push: graph} will push the indicated graph to the ViewPort. This is preferable to the old push_graph() function.","ref":"Scenic.Scene.html#c:init/2","title":"Scenic.Scene.init/2","type":"callback"},{"doc":"","ref":"Scenic.Scene.html#internal_push_graph/3","title":"Scenic.Scene.internal_push_graph/3","type":"function"},{"doc":"send a filterable event to a scene.This is very similar in feel to casting a message to a GenServer. However, This message will be handled by the Scene's filter_event/3 function. If the Scene returns {:continue, msg, state} from filter_event/3, then the event will also be sent to the scene's parent. This will continue until the message reaches the root scene or some other permanently supervised scene.Typically, when a scene wants to initiate an event, it will call send_event/1 which is a private function injected into the scene during use Scenic.SceneThis private version of send_event will take care of the housekeeping of tracking the parent's pid. It will, in turn, call this function on the main Scene module to send the event on its way.def handle_input( {:cursor_button, {:left, :release, _, _}}, _, %{msg: msg} = state ) do send_event( {:click, msg} ) {:noreply, state} endOn the other hand, if you know you want to send the event to a named scene that you supervise yourself, then you would use Scenic.Scene.send_event/2def handle_input( {:cursor_button, {:left, :release, _, _}}, _, %{msg: msg} = state ) do Scenic.Scene.send_event( :some_scene, {:click, msg} ) {:noreply, state} endBe aware that named scenes that your supervise yourself are unable to continue the event to their parent in the graph because they could be referenced by multiple graphs making the continuation ambiguous.","ref":"Scenic.Scene.html#send_event/2","title":"Scenic.Scene.send_event/2","type":"function"},{"doc":"","ref":"Scenic.Scene.html#terminate/2","title":"Scenic.Scene.terminate/2","type":"function"},{"doc":"Invoked when the Scene is about to exit. It should do any cleanup required.reason is the exit reason and state is the current state of the Scene. The return value is ignored.The callback is identical to the terminate callback in Genserver.","ref":"Scenic.Scene.html#c:terminate/2","title":"Scenic.Scene.terminate/2","type":"callback"},{"doc":"","ref":"Scenic.Scene.html#t:response_opts/0","title":"Scenic.Scene.response_opts/0","type":"type"},{"doc":"OverviewThe job of the ViewPort is to coordinate the flow of information between the scenes and the drivers. Scenes and Drivers should not know anything about each other. An app should work identically from its point of view no matter if there is one, multiple, or no drivers currently running.Drivers are all about rendering output and collecting input from a single source. Usually hardware, but can also be the network or files. Drivers only care about graphs and should not need to know anything about the logic or state encapsulated in Scenes.The goal is to isolate app data and logic from render data and logic. The ViewPort is the connection between them that makes sense of the flow of information.OUTPUTPractically speaking, the ViewPort is the owner of the ETS tables that carry the graphs (and any other necessary support info). If the ViewPort crashes, then all that information needs to be rebuilt. The ViewPort monitors all running scenes and does the appropriate cleanup when any of them goes DOWN.The scene is responsible for generating graphs and writing them to the graph ETS table. (Note: We also tried casting the graph to the ViewPort so that the table could be non-public, but that had issues)The drivers should only read from the graph tables.INPUTWhen user input happens, the drivers send it to the ViewPort. Input that does not depend on screen position (key presses, audio window events, etc.) is sent to the root scene unless some other scene has captured that type of input (see captured input below).If the input event does depend on position (cursor position, cursor button presses, scrolling, etc.) then the ViewPort needs to scan the hierarchical graph of graphs, to find the correct scene, and the item in that scene that was &quot;hit&quot;. The ViewPort then sends the event to that scene, with the position projected into the scene's local coordinate space (via the built-up stack of matrix transformations)CAPTURED INPUTA scene can request to &quot;capture&quot; all input events of a certain type. This means that all events of that type are sent to a certain scene process regardless of position or root. In this way, a text input scene nested deep in the tree can capture key presses. Or a button can capture cursor_pos events after it has been pressed.If a scene has &quot;captured&quot; a position dependent input type, that position is projected into the scene's coordinate space before sending the event. Note that instead of walking the graph of graphs, the transforms provided in the input &quot;context&quot; field are used. You could, in theory change that to something else before capturing, but I wouldn't really recommend it.Any scene can cancel the current capture. This would probably leave the scene that thinks it has &quot;captured&quot; the input in an inconsistent state, so this is not recommended.","ref":"Scenic.ViewPort.html","title":"Scenic.ViewPort","type":"module"},{"doc":"Capture one or more types of input.This must be called by a Scene process.","ref":"Scenic.ViewPort.html#capture_input/2","title":"Scenic.ViewPort.capture_input/2","type":"function"},{"doc":"Cast a message to all active drivers listening to a viewport.","ref":"Scenic.ViewPort.html#driver_cast/2","title":"Scenic.ViewPort.driver_cast/2","type":"function"},{"doc":"query the last recorded viewport status","ref":"Scenic.ViewPort.html#info/1","title":"Scenic.ViewPort.info/1","type":"function"},{"doc":"Send raw input to a viewport.This is used primarily by drivers to send raw user input to the viewport. Having said that, nothing stops a scene from using it to send input into the system. There are a few cases where that is useful.See the input docs for the input formats you can send.","ref":"Scenic.ViewPort.html#input/2","title":"Scenic.ViewPort.input/2","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#input/3","title":"Scenic.ViewPort.input/3","type":"function"},{"doc":"release an input capture.This is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.ViewPort.html#release_input/2","title":"Scenic.ViewPort.release_input/2","type":"function"},{"doc":"Request that a {:set_root, ...} message is sent to the caller.request_root is primarily used by drivers and is of little use to anything else.When a driver starts up, it will need to get the root scene of the viewport, which may already be up and running. By calling request_root, the driver can request that the viewport send it a {:set_root, ...} message as if the root scene had just changed.Params:viewport The viewport to request the message from.send_to The driver to send the message to. If send_to is nil, the message will be sent to the calling process.","ref":"Scenic.ViewPort.html#request_root/2","title":"Scenic.ViewPort.request_root/2","type":"function"},{"doc":"Reset a running viewportThis causes the viewport to rest the original scene as the root, with the original arguments were received with the ViewPort started.","ref":"Scenic.ViewPort.html#reset/1","title":"Scenic.ViewPort.reset/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#reshape/2","title":"Scenic.ViewPort.reshape/2","type":"function"},{"doc":"Set the root scene/graph of the ViewPort.","ref":"Scenic.ViewPort.html#set_root/3","title":"Scenic.ViewPort.set_root/3","type":"function"},{"doc":"Start a new viewport","ref":"Scenic.ViewPort.html#start/1","title":"Scenic.ViewPort.start/1","type":"function"},{"doc":"Stop a running viewport","ref":"Scenic.ViewPort.html#stop/1","title":"Scenic.ViewPort.stop/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#t:event/0","title":"Scenic.ViewPort.event/0","type":"type"},{"doc":"A Component is simply a Scene that is optimized to be referenced by another scene.All you need to do to create a Component is calluse Scenic.Componentinstead ofuse Scenic.SceneAt the top of your module definition.Standard ComponentsScenic includes a small number of standard components that you can simply reuse in your scenes. These were chosen to be in the main library because a) they are used frequently, and b) their use promotes a certain amount of &quot;common&quot; look and feel.All of these components are typically added/modified via the helper functions in the Scenic.Components module.Button a simple button.Checkbox a checkbox input field.Dropdown a dropdown / select input field.RadioGroup a group of radio button inputs.Slider a slider input.TextField a text / password input field.Toggle an on/off toggle input.Other ComponentsFor completeness, Scenic also includes the following standard components. They are used by the components above, although you are free to use them as well if they fit your needs.Caret the vertical, blinking, caret line in a text field.RadioButton a single radio button in a radio group.VerifiersOne of the main differences between a Component and a Scene is the two extra callbacks that are used to verify incoming data. Since Components are meant to be reused, you should do some basic validation that the data being set up is valid, then provide feedback if it isn't.Optional: Named ComponentWhether you override one or more message handlers, like handle_info/2, you might want to use registered name as Process.dest(). For this to be possible, you might pass name: keyword argument in a call to use Scenic.Component.use Scenic.Component, name: __MODULE__Once passed, it limits the usage of this particular component to a single instance, because two processes cannot be registered under the same name.Optional: No ChildrenThere is an optimization you can use. If you know for certain that your component will not attempt to use any components, you can set has_children to false like this.use Scenic.Component, has_children: falseSetting has_children to false this will do two things. First, it won't create a dynamic supervisor for this scene, which saves some resources.For example, the Button component sets has_children to false.This option is available for any Scene, not just components","ref":"Scenic.Component.html","title":"Scenic.Component","type":"behaviour"},{"doc":"Add this component to a Scenic.Graph","ref":"Scenic.Component.html#c:add_to_graph/3","title":"Scenic.Component.add_to_graph/3","type":"callback"},{"doc":"Provide an info string about what was wrong with the provided data.This string will typically be displayed in the terminal. Example implementation:def info(data) do &quot;&quot;&quot; \#{IO.ANSI.red()}Button data must be a binary \#{IO.ANSI.yellow()}Received: \#{inspect(data)} \#{IO.ANSI.default_color()} &quot;&quot;&quot; end","ref":"Scenic.Component.html#c:info/1","title":"Scenic.Component.info/1","type":"callback"},{"doc":"Verify that this the data for this component is valid.Return an {:ok, data} tuple if the data is valid and any other term if the data is not valid. Here is an example implementation that checks if the input is a valid binary:@impl Scenic.Component def verify(data) do if is_binary(data) do {:ok, data} else :invalid_data end end","ref":"Scenic.Component.html#c:verify/1","title":"Scenic.Component.verify/1","type":"callback"},{"doc":"Add a button to a graphA button is a small scene that is pretty much just some text drawn over a rounded rectangle. The button scene contains logic to detect when the button is pressed, tracks it as the pointer moves around, and when it is released.Datatitletitle - a bitstring describing the text to show in the buttonMessagesIf a button press is successful, it sends an event message to the host scene in the form of:{:click, id}These messages can be received and handled in your scene via Scenic.Scene.filter_event/3. For example:... @impl Scenic.Scene def init(_, _opts) do graph = Graph.build() |&gt; Scenic.Components.button(&quot;Sample Button&quot;, id: :sample_btn_id, t: {10, 10}) state = %{} {:ok, state, push: graph} end @impl Scenic.Scene def filter_event({:click, :sample_btn_id}, _from, state) do IO.puts(&quot;Sample button was clicked!&quot;) {:cont, event, state} endStylesButtons honor the following standard styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :primaryAdditional StylesButtons honor the following list of additional styles.:width - :auto (default) or pass in a number to set the width of the button:height - :auto (default) or pass in a number to set the height of the button.:radius - pass in a number to set the radius of the button's rounded rectangle.:alignment - set the alignment of the text inside the button. Can be one of :left, :right, :center. The default is :center.:button_font_size - the size of the font in the buttonButtons do not use the inherited :font_size style as they should look consistent regardless of what size the surrounding text is.ThemeButtons work well with the following predefined themes: :primary, :secondary, :success, :danger, :warning, :info, :text, :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text in the button:background - the normal background of the button:border - the border of the button:active - the background while the button is pressedUsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesThe following example creates a simple button and positions it on the screen.graph |&gt; button(&quot;Example&quot;, id: :button_id, translate: {20, 20})The next example makes the same button as before, but colors it as a warning button. See the options list above for more details.graph |&gt; button(&quot;Example&quot;, id: :button_id, translate: {20, 20}, theme: :warning)","ref":"Scenic.Component.Button.html","title":"Scenic.Component.Button","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Button.html#add_to_graph/3","title":"Scenic.Component.Button.add_to_graph/3","type":"function"},{"doc":"Add a blinking text-input caret to a graph.Data{height, color}height - integer greater than zerocolor - any valid color.UsageThe caret component is used by the TextField component and usually isn't accessed directly, although you are free to do so if it fits your needs. There is no short-cut helper function so you will need to add it to the graph manually.The following example adds a caret to a graph.graph |&gt; Caret.add_to_graph({height, theme.text}, id: :caret)","ref":"Scenic.Component.Input.Caret.html","title":"Scenic.Component.Input.Caret","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.Caret.html#add_to_graph/3","title":"Scenic.Component.Input.Caret.add_to_graph/3","type":"function"},{"doc":"Add a checkbox to a graphData{text, checked?}text - must be a bitstringchecked? - must be a boolean and indicates if the checkbox is set.MessagesWhen the state of the checkbox, it sends an event message to the host scene in the form of:{:value_changed, id, checked?}StylesButtons honor the following standard styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkThemeCheckboxes work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text in the button:background - the background of the box:border - the border of the box:active - the border of the box while the button is pressed:thumb - the color of the check mark itselfUsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesThe following example creates a checkbox and positions it on the screen.graph |&gt; checkbox({&quot;Example&quot;, true}, id: :checkbox_id, translate: {20, 20})","ref":"Scenic.Component.Input.Checkbox.html","title":"Scenic.Component.Input.Checkbox","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.Checkbox.html#add_to_graph/3","title":"Scenic.Component.Input.Checkbox.add_to_graph/3","type":"function"},{"doc":"Add a dropdown to a graphData{items, initial_item}items - must be a list of items, each of which is: {text, id}. See below...initial_item - the id of the initial selected item. It can be any term you want, however it must be an item_id in the items list. See below.Per item data:{text, item_id}text - a string that will be shown in the dropdown.item_id - any term you want. It will identify the item that is currently selected in the dropdown and will be passed back to you during event messages.MessagesWhen the state of the checkbox, it sends an event message to the host scene in the form of:{:value_changed, id, selected_item_id}OptionsDropdowns honor the following list of options.StylesButtons honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkAdditional StylesButtons honor the following list of additional styles.:width - pass in a number to set the width of the button.:height - pass in a number to set the height of the button.:direction - what direction should the menu drop. Can be either :down or :up. The default is :down.ThemeDropdowns work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text:background - the background of the component:border - the border of the component:active - the background of selected item in the dropdown list:thumb - the color of the item being hovered overUsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesThe following example creates a dropdown and positions it on the screen.graph |&gt; dropdown({[ {&quot;Dashboard&quot;, :dashboard}, {&quot;Controls&quot;, :controls}, {&quot;Primitives&quot;, :primitives} ], :controls}, id: :dropdown_id, translate: {20, 20})","ref":"Scenic.Component.Input.Dropdown.html","title":"Scenic.Component.Input.Dropdown","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.Dropdown.html#add_to_graph/3","title":"Scenic.Component.Input.Dropdown.add_to_graph/3","type":"function"},{"doc":"Add a single radio button to a graph.Data{text, id} {text, id, selected?}text - a bitstring of the text to displayid - any term. Identifies the radio button.selected? - boolean. true if selected. false if not. Default is false if this term is not provided.UsageThe RadioButton component is used by the RadioGroup component and usually isn't accessed directly, although you are free to do so if it fits your needs. There is no short-cut helper function so you will need to add it to the graph manually.The following example adds a caret to a graph.graph |&gt; RadioButton.add_to_graph({&quot;A button&quot;, :an_id, true})","ref":"Scenic.Component.Input.RadioButton.html","title":"Scenic.Component.Input.RadioButton","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.RadioButton.html#add_to_graph/3","title":"Scenic.Component.Input.RadioButton.add_to_graph/3","type":"function"},{"doc":"Add a radio group to a graphDataradio_buttonsradio_buttons must be a list of radio button data. See below.Radio button data:{text, radio_id, checked? \\\\ false}text - must be a bitstringbutton_id - can be any term you want. It will be passed back to you as the group's value.checked? - must be a boolean and indicates if the button is selected. checked? is not required and will default to false if not supplied.MessagesWhen the state of the radio group changes, it sends an event message to the host scene in the form of:{:value_changed, id, radio_id}OptionsRadio Buttons honor the following list of options.:theme - This sets the color scheme of the button. This can be one of pre-defined button schemes :light, :dark, or it can be a completely custom scheme like this: {text_color, box_background, border_color, pressed_color, checkmark_color}.StylesRadio Buttons honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkThemeRadio buttons work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text:background - the background of the component:border - the border of the component:active - the background of the circle while the button is pressed:thumb - the color of inner selected-markUsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesThe following example creates a radio group and positions it on the screen.graph |&gt; radio_group([ {&quot;Radio A&quot;, :radio_a}, {&quot;Radio B&quot;, :radio_b, true}, {&quot;Radio C&quot;, :radio_c}, ], id: :radio_group_id, translate: {20, 20})","ref":"Scenic.Component.Input.RadioGroup.html","title":"Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.RadioGroup.html#add_to_graph/3","title":"Scenic.Component.Input.RadioGroup.add_to_graph/3","type":"function"},{"doc":"Add a slider to a graphData{ extents, initial_value}extents gives the range of values. It can take several forms...{min, max} If min and max are integers, then the slider value will be an integer.{min, max} If min and max are floats, then the slider value will be an float.[a, b, c] A list of terms. The value will be one of the termsinitial_value Sets the initial value (and position) of the slider. It must make sense with the extents you passed in.MessagesWhen the state of the slider changes, it sends an event message to the host scene in the form of:{:value_changed, id, value}OptionsSliders honor the following list of options.StylesSliders honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkThemeSliders work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::border - the color of the slider line:thumb - the color of slider thumbUsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesThe following example creates a numeric slider and positions it on the screen.graph |&gt; slider({{0,100}, 0}, id: :num_slider, translate: {20,20})The following example creates a list slider and positions it on the screen.graph |&gt; slider({[ :white, :cornflower_blue, :green, :chartreuse ], :cornflower_blue}, id: :slider_id, translate: {20,20})","ref":"Scenic.Component.Input.Slider.html","title":"Scenic.Component.Input.Slider","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.Slider.html#add_to_graph/3","title":"Scenic.Component.Input.Slider.add_to_graph/3","type":"function"},{"doc":"Add a text field input to a graphDatainitial_valueinitial_value - is the string that will be the starting valueMessagesWhen the text in the field changes, it sends an event message to the host scene in the form of:{:value_changed, id, value}StylesText fields honor the following styles:hidden - If false the component is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkAdditional StylesText fields honor the following list of additional styles.:filter - Adding a filter option restricts which characters can be entered into the text_field component. The value of filter can be one of::all - Accept all characters. This is the default:number - Any characters from &quot;0123456789.,&quot;&quot;filter_string&quot; - Pass in a string containing all the characters you will acceptfunction/1 - Pass in an anonymous function. The single parameter will be the character to be filtered. Return true or false to keep or reject it.:hint - A string that will be shown (greyed out) when the entered value of the component is empty.:type - Can be one of the following options::all - Show all characters. This is the default.:password - Display a string of '*' characters instead of the value.:width - set the width of the control.ThemeText fields work well with the following predefined themes: :light, :darkTo pass in a custom theme, supply a map with at least the following entries::text - the color of the text:background - the background of the component:border - the border of the component:focus - the border while the component has focusUsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesgraph |&gt; text_field(&quot;Sample Text&quot;, id: :text_id, translate: {20,20}) graph |&gt; text_field( &quot;&quot;, id: :pass_id, type: :password, hint: &quot;Enter password&quot;, translate: {20,20} )","ref":"Scenic.Component.Input.TextField.html","title":"Scenic.Component.Input.TextField","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.TextField.html#add_to_graph/3","title":"Scenic.Component.Input.TextField.add_to_graph/3","type":"function"},{"doc":"Add toggle to a Scenic graph.Dataon?on? - true if the toggle is on, pass false if not.StylesToggles honor the following styles. The :light and :dark styles look nice. The other bundled themes...not so much. You can also supply your own theme.:hidden - If false the toggle is rendered. If true, it is skipped. The default is false.:theme - The color set used to draw. See below. The default is :darkAdditional StylesToggles also honor the following additional styles.:border_width - the border width. Defaults to 2.:padding - the space between the border and the thumb. Defaults to 2:thumb_radius - the radius of the thumb. This determines the size of the entire toggle. Defaults to 10.ThemeTo pass in a custom theme, supply a map with at least the following entries::border - the color of the border around the toggle:background - the color of the track when the toggle is off.:text - the color of the thumb.:thumb - the color of the track when the toggle is on.Optionally, you can supply the following entries::thumb_pressed - the color of the thumb when pressed. Defaults to :gainsboro.UsageYou should add/modify components via the helper functions in Scenic.ComponentsExamplesThe following example creates a toggle.graph |&gt; toggle(true, translate: {20, 20})The next example makes a larger toggle.graph |&gt; toggle(true, translate: {20, 20}, thumb_radius: 14)","ref":"Scenic.Component.Input.Toggle.html","title":"Scenic.Component.Input.Toggle","type":"module"},{"doc":"Callback implementation for Scenic.Component.add_to_graph/3.","ref":"Scenic.Component.Input.Toggle.html#add_to_graph/3","title":"Scenic.Component.Input.Toggle.add_to_graph/3","type":"function"},{"doc":"Please see Primitives Overview for a high-level description.What is a primitiveA primitive is the simplest thing Scenic knows how to draw on the screen. There is is only a small, fixed set of them, but they can be combined in a graph to draw very complicated images.In general, each Primitive type has a piece of data that it expects to operate on. For example, Primitive.Text requires a bitstring. Primitive.Circle requires a radius. Please see the documentation for each primitive for details.How to use primitivesBy far, the easiest way to use primitives is to import the helper functions in Scenic.Primitives. These helpers can both add primitives to a scene you are building and modify later as you react to events.Once you get a primitive out of a graph via functions such as Graph.modify, or Graph.get, You can use the generic helpers in this module to access or manipulate them.Standard primitivesThe set of primitives supported in Scenic is fixed in any given version. They have been chosen to provide the maximum flexibility when combined together, while still requiring the minimal amount of code and maintenance.If required, new primitives can be added in the future, but they will not work with older versions of the drivers.Arc draws an arc. This would be a line cut out of a part of the edge of a circle. If you want a shape that looks like a piece of pie, then you should use the Sector.Circle draws a circle.Ellipse draws an ellipse.Group doesn't draw anything. Instead, it creates a node in the graph that you can insert more primitives into. Any styles or transforms you apply to the Group are inherited by all the primitives below it.Line draws a line.Path is sort of an escape valve for complex shapes not covered by the other primitives. You supply a list of instructions, such as :move_to, :line_to, :bezier_to, etc. to generate a complex shape.Quad draws polygon with four sides.Rectangle draws a rectangle.RoundedRectangle draws a rectangle with the corners rounded by a given radius.SceneRef doesn't draw anything by itself. Instead it points to another scene/graph and tells the driver to draw that here.Sector draws a shape that looks like a piece of pie. If you want to stroke just the curved edge, then combine it with an Arc.Text draws a string of text.Triangle draws a triangle.","ref":"Scenic.Primitive.html","title":"Scenic.Primitive","type":"behaviour"},{"doc":"","ref":"Scenic.Primitive.html#c:add_to_graph/3","title":"Scenic.Primitive.add_to_graph/3","type":"callback"},{"doc":"Generic builder to create a new primitive.This function is used internally. You should almost always use the helpers in Scenic.Primitives instead.Parameters:module - The module of the primitive you are buildingdata - the primitive-specific data being set into the primitiveopts - a list of style and transform options to apply to the primitiveReturns the built primitive.","ref":"Scenic.Primitive.html#build/3","title":"Scenic.Primitive.build/3","type":"function"},{"doc":"Determines if a point is contained within a primitive.The supplied point must already be projected into the local coordinate space of the primitive. In other words, this test does NOT take into account any transforms that have been applied to the primitive.The input mechanism takes care of this for you by projecting incoming points by the inverse-matrix of a primitive before calling this function...Note that some primitives, such as Group, do not inherently have a notion of containing a point. In those cases, this function will always return false.Parameters:primitive - The primitivepoint - The point to testReturns true or false.","ref":"Scenic.Primitive.html#contains_point?/2","title":"Scenic.Primitive.contains_point?/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#c:contains_point?/2","title":"Scenic.Primitive.contains_point?/2","type":"callback"},{"doc":"","ref":"Scenic.Primitive.html#c:default_pin/1","title":"Scenic.Primitive.default_pin/1","type":"callback"},{"doc":"Deletes a specified style from a primitive.Does nothing if the style is not set.Parameters:primitive - The primitivetype - atom representing the style to delete.Returns the updated primitive.","ref":"Scenic.Primitive.html#delete_style/2","title":"Scenic.Primitive.delete_style/2","type":"function"},{"doc":"Deletes a specified transform from a primitive.Does nothing if the transform is not set.Parameters:primitive - The primitivetype - atom representing the transform to delete.Returns the updated primitive.","ref":"Scenic.Primitive.html#delete_transform/2","title":"Scenic.Primitive.delete_transform/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#do_put/2","title":"Scenic.Primitive.do_put/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#c:expand/1","title":"Scenic.Primitive.expand/1","type":"callback"},{"doc":"","ref":"Scenic.Primitive.html#c:filter_styles/1","title":"Scenic.Primitive.filter_styles/1","type":"callback"},{"doc":"Get the value of the primitive-specific data.Parameters:primitive - The primitiveReturns the value of the primitive-specific data.","ref":"Scenic.Primitive.html#get/1","title":"Scenic.Primitive.get/1","type":"function"},{"doc":"Get the value of a specific style set on the primitive.If the style is not set, it returns defaultParameters:primitive - The primitivetype - atom representing the style to get.default - default value to return if the style is not set.Returns the value of the style.","ref":"Scenic.Primitive.html#get_style/3","title":"Scenic.Primitive.get_style/3","type":"function"},{"doc":"Get the styles map from a primitive.Parameters:primitive - The primitiveReturns the map of styles set directly onto this primitive. This does not include any inherited styles.","ref":"Scenic.Primitive.html#get_styles/1","title":"Scenic.Primitive.get_styles/1","type":"function"},{"doc":"Get the value of a specific transform set on the primitive.If the transform is not set, it returns defaultParameters:primitive - The primitivetype - atom representing the transform to get.default - default value to return if the transform is not set.Returns the value of the transform.","ref":"Scenic.Primitive.html#get_transform/3","title":"Scenic.Primitive.get_transform/3","type":"function"},{"doc":"Get the transforms map from a primitive.Parameters:primitive - The primitiveReturns the map of transforms set directly onto this primitive. This does not include any inherited transforms.","ref":"Scenic.Primitive.html#get_transforms/1","title":"Scenic.Primitive.get_transforms/1","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#c:info/1","title":"Scenic.Primitive.info/1","type":"callback"},{"doc":"Merge an options-list of styles and transforms onto a primitive.This function might go through a name-change in the future. It is really more of a merge. The supplied list of styles and transformsParameters:primitive - The primitiveReturns the value of the primitive-specific data.","ref":"Scenic.Primitive.html#merge_opts/2","title":"Scenic.Primitive.merge_opts/2","type":"function"},{"doc":"Put primitive-specific data onto the primitive.Like many of the functions in the Scenic.Primitive module, you are usually better off using the helper functions in Scenic.Primitives instead.Parameters:primitive - The primitivedata - The data to setopts - A list of style/transform options to mergeReturns the updated primitive.","ref":"Scenic.Primitive.html#put/3","title":"Scenic.Primitive.put/3","type":"function"},{"doc":"Update the value of a specific style set on the primitive.Parameters:primitive - The primitivetype - atom representing the style to get.data - the value to set on the style.Returns the updated primitive.","ref":"Scenic.Primitive.html#put_style/3","title":"Scenic.Primitive.put_style/3","type":"function"},{"doc":"Update the styles map in a primitive.Parameters:primitive - The primitivestyles - The new styles mapReturns the primitive with the updated styles.","ref":"Scenic.Primitive.html#put_styles/2","title":"Scenic.Primitive.put_styles/2","type":"function"},{"doc":"Update the value of a specific transform set on the primitive.Parameters:primitive - The primitivetype - atom representing the transform to get.data - the value to set on the transform.Returns the updated primitive.","ref":"Scenic.Primitive.html#put_transform/3","title":"Scenic.Primitive.put_transform/3","type":"function"},{"doc":"Update the transforms map in a primitive.Parameters:primitive - The primitivetransforms - The new transforms mapReturns the primitive with the updated transforms.","ref":"Scenic.Primitive.html#put_transforms/2","title":"Scenic.Primitive.put_transforms/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#c:valid_styles/0","title":"Scenic.Primitive.valid_styles/0","type":"callback"},{"doc":"","ref":"Scenic.Primitive.html#c:verify/1","title":"Scenic.Primitive.verify/1","type":"callback"},{"doc":"","ref":"Scenic.Primitive.html#t:t/0","title":"Scenic.Primitive.t/0","type":"type"},{"doc":"Draw an arc on the screen.An arc is a segment that traces part of the outline of a circle. If you are looking for something shaped like a piece of pie, then you want a segment.Arcs are often drawn on top of a segment to get an affect where a piece of pie is filled in, but only the curvy edge is stroked.Note that you can fill an arc, but that will result in a shape that looks like a potato wedge.Data{radius, start, finish}The data for an arc is a three-tuple.radius - the radius of the arcstart - the starting angle in radiansfinish - end ending angle in radiansStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part. UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Arc.html","title":"Scenic.Primitive.Arc","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Arc.html#valid_styles/0","title":"Scenic.Primitive.Arc.valid_styles/0","type":"function"},{"doc":"Draw a circle on the screen.DataradiusThe data for an arc is a single number.radius - the radius of the arcStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Circle.html","title":"Scenic.Primitive.Circle","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Circle.html#valid_styles/0","title":"Scenic.Primitive.Circle.valid_styles/0","type":"function"},{"doc":"Draw an ellipse on the screen.Data{radius_1, radius_2}The data for an arc is a single number.radius_1 - the radius of the ellipse in one directionradius_2 - the radius of the ellipse in the other directionStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.Note: you can achieve the same effect with a Circle primitive by applying a :size transform to it with unequal values on the axesUsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Ellipse.html","title":"Scenic.Primitive.Ellipse","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Ellipse.html#valid_styles/0","title":"Scenic.Primitive.Ellipse.valid_styles/0","type":"function"},{"doc":"A container to hold other primitives.Any styles placed on a group will be inherited by the primitives in the group. Any transforms placed on a group will be multiplied into the transforms in the primitives in the group.DatauidsThe data for an arc is a list of internal uids for the primitives it containsStylesThe group is special in that it accepts all styles and transforms, even if they are non-standard. These are then inherited by any primitives, including SceneRefsUsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Group.html","title":"Scenic.Primitive.Group","type":"module"},{"doc":"","ref":"Scenic.Primitive.Group.html#delete/2","title":"Scenic.Primitive.Group.delete/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Group.html#increment/2","title":"Scenic.Primitive.Group.increment/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Group.html#insert_at/3","title":"Scenic.Primitive.Group.insert_at/3","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Group.html#valid_styles/0","title":"Scenic.Primitive.Group.valid_styles/0","type":"function"},{"doc":"Draw a line on the screen.Data{point_a, point_b}The data for a line is a tuple containing two points.point_a - position to start drawing frompoint_b - position to draw toStylesThis primitive recognizes the following styleshidden - show or hide the primitivecap - says how to draw the ends of the line.stroke - stroke the outline of the primitive. In this case, only the curvy part.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Line.html","title":"Scenic.Primitive.Line","type":"module"},{"doc":"Returns a the midpoint of the line. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.Line.html#centroid/1","title":"Scenic.Primitive.Line.centroid/1","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Line.html#valid_styles/0","title":"Scenic.Primitive.Line.valid_styles/0","type":"function"},{"doc":"Draw a complex path on the screen described by a list of actions.Datalist_of_commandsThe data for a path is a list of commands. They are interpreted in order when the path is drawn. See below for the commands it will accept.StylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.cap - says how to draw the ends of the line.join - control how segments are joined.miter_limit - control how segments are joined.Commands:begin - start a new path segment:close_path - draw a line back to the start of the current segment:solid - mark the current segment as something that will be filled:hole - mark the current segment as something that cut out of other segments{:move_to, x, y} - move the current draw position{:line_to, x, y} - draw a line from the current position to a new location.{:bezier_to, c1x, c1y, c2x, c2y, x, y} - draw a bezier curve from the current position to a new location.{:quadratic_to, cx, cy, x, y} - draw a quadratic curve from the current position to a new location.{:arc_to, x1, y1, x2, y2, radius} - draw an arc from the current position to a new location.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Path.html","title":"Scenic.Primitive.Path","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Path.html#valid_styles/0","title":"Scenic.Primitive.Path.valid_styles/0","type":"function"},{"doc":"Draw a quad on the screen.Data{point_a, point_b, point_c, point_d}The data for a line is a tuple containing four points.point_a - position to start drawing frompoint_b - position to draw topoint_c - position to draw topoint_d - position to draw toStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.join - control how segments are joined.miter_limit - control how segments are joined.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Quad.html","title":"Scenic.Primitive.Quad","type":"module"},{"doc":"","ref":"Scenic.Primitive.Quad.html#expand/2","title":"Scenic.Primitive.Quad.expand/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Quad.html#valid_styles/0","title":"Scenic.Primitive.Quad.valid_styles/0","type":"function"},{"doc":"Draw a rectangle on the screen.Data{width, height}The data for a line is a tuple containing two numbers.width - width of the rectangleheight - height of the rectangleStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.join - control how segments are joined.miter_limit - control how segments are joined.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Rectangle.html","title":"Scenic.Primitive.Rectangle","type":"module"},{"doc":"Returns the centroid of the rectangle. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.Rectangle.html#centroid/1","title":"Scenic.Primitive.Rectangle.centroid/1","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Rectangle.html#valid_styles/0","title":"Scenic.Primitive.Rectangle.valid_styles/0","type":"function"},{"doc":"Draw a rectangle with rounded corners on the screen.Data{width, height, radius}The data for a line is a tuple containing three numbers.width - width of the rectangleheight - height of the rectangleradius - radius of the cornersStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.RoundedRectangle.html","title":"Scenic.Primitive.RoundedRectangle","type":"module"},{"doc":"Returns a the centroid of the rectangle. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.RoundedRectangle.html#centroid/1","title":"Scenic.Primitive.RoundedRectangle.centroid/1","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.RoundedRectangle.html#valid_styles/0","title":"Scenic.Primitive.RoundedRectangle.valid_styles/0","type":"function"},{"doc":"A reference to another graph or component.When rendering a graph, the SceneRef primmitive causes the render to stop what it is doing, render another graph, then continue on where it left off.The SceneRef primitive is usually added for you when you use a Component via the Primitive.Components helpers.However, it can also be useful directly if you want to declare multiple graphs in a single scene and reference them from each other. This is done when you want to limit the data scanned and sent when just a portion of your graph is changing.Be careful not to create circular references!DataThe data for a SceneRef can take one of several forms.scene_name - an atom naming a scene you are managing yourself{scene_name, sub_id} - an atom naming a scene you are managing yourself and a sub-idpid - the pid of a running scene (rarely used){pid, sub_id} - the pid of a running scene and a sub_id (rarely used){:graph, scene, sub_id} - a full graph key - must already be in ViewPort.Tables{{module, data}, sub_id} - init data for a dynamic scene (very common)StylesThe SceneRef is special in that it accepts all styles and transforms, even if they are non-standard. These are then inherited by any dynamic scenes that get created.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.SceneRef.html","title":"Scenic.Primitive.SceneRef","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.SceneRef.html#valid_styles/0","title":"Scenic.Primitive.SceneRef.valid_styles/0","type":"function"},{"doc":"Draw an sector on the screen.An sector is a shape that looks like a piece of pie.Data{radius, start, finish}The data for a sector is a three-tuple.radius - the radius of the arcstart - the starting angle in radiansfinish - end ending angle in radiansStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Sector.html","title":"Scenic.Primitive.Sector","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Sector.html#valid_styles/0","title":"Scenic.Primitive.Sector.valid_styles/0","type":"function"},{"doc":"Draw text on the screen.DatatextThe data for a Text primitive is a bitstringtext - the text to drawStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the text. Only solid colors!font - name (or key) of font to usefont_size - point size of the fontfont_blur - option to blur the characterstext_align - alignment of lines of texttext_height - spacing between lines of textUsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Text.html","title":"Scenic.Primitive.Text","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Text.html#valid_styles/0","title":"Scenic.Primitive.Text.valid_styles/0","type":"function"},{"doc":"Draw a triangle on the screen.Data{point_a, point_b, point_c}The data for a line is a tuple containing three points.point_a - position to start drawing frompoint_b - position to draw topoint_c - position to draw toStylesThis primitive recognizes the following styleshidden - show or hide the primitivefill - fill in the area of the primitivestroke - stroke the outline of the primitive. In this case, only the curvy part.join - control how segments are joined.miter_limit - control how segments are joined.UsageYou should add/modify primitives via the helper functions in Scenic.Primitives","ref":"Scenic.Primitive.Triangle.html","title":"Scenic.Primitive.Triangle","type":"module"},{"doc":"Returns the centroid of the triangle. This is used as the default pin when applying rotate or scale transforms.","ref":"Scenic.Primitive.Triangle.html#centroid/1","title":"Scenic.Primitive.Triangle.centroid/1","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Triangle.html#valid_styles/0","title":"Scenic.Primitive.Triangle.valid_styles/0","type":"function"},{"doc":"Modify the look of a primitive by applying a Style.Styles are optional modifiers that you can put on any primitive. Each style does a specific thing and some only affect certain primitives.There is a fixed list of primitive styles which are understood by the drivers. Some Components may introduce their own optional styles, but the only ones sent down to the drivers for rendering are contained in the list below.In general, the primitive styles are each defined in their own module, but you apply them as options in a primitive's option list.For example, to use the style defined in the module Scenic.Primitive.Style.Font you would define an option on a text primitive like this:graph = Graph.build |&gt; text( &quot;Styled Text&quot;, font: :roboto )Primitive StylesCap sets how to draw the end of a line.ClearColor sets the background color. Fill fills in a primitive with a paint style.Font sets the font to use to draw text.FontBlur applies a blur effect to text.FontSize sets the point size text.Hidden a flag that sets if a primitive is drawn at all.Join sets how to render the intersection of two lines. Works on the intersections of other primitives as well.MiterLimit sets whether or not to miter a joint if the intersection of two lines is very sharp.Scissor defines a rectangle that drawing will be clipped to.Stroke defines how to draw the edge of a primitive. Specifies both a width and a paint style.TextAlign sets the alignment of text relative to the starting point. Examples: :left, :center, or :rightTheme a collection of default colors. Usually passed to components, telling them how to draw in your preferred color scheme.Primitive Paint StylesThe Fill and Stroke styles accept a paint type. This describes what to fill or stroke the the primitive with.There is a fixed set of paint types that the drivers know how to render.BoxGradient fills a primitive with a box gradient.Color fills a primitive with a solid color. Image fills a primitive with an image that is loaded into Scenic.Cache.LinearGradient fills a primitive with a linear gradient.RadialGradient fills a primitive with a radial gradient.Specifying PaintWhen you use either the Fill and Stroke you specify the paint in a tuple like this.graph = Graph.build |&gt; circle( 100, fill: {:color, :green}, stroke: {2, {:color, :blue}} )Each paint type has specific values it expects in order to draw. See the documentation for that paint type for details.Color PaintSpecifying a solid color to paint is very common, so has a shortcut. If you simply set a valid color as the paint type, it is assumed that you mean Color.graph = Graph.build |&gt; circle( 100, fill: :green, stroke: {2, :blue} ) # simple color |&gt; rect( {100, 200}, fill: {:green, 128} ) # color with alpha |&gt; rect( {100, 100}, fill: {10, 20, 30, 40} ) # red, green, blue, alpha","ref":"Scenic.Primitive.Style.html","title":"Scenic.Primitive.Style","type":"behaviour"},{"doc":"","ref":"Scenic.Primitive.Style.html#c:info/1","title":"Scenic.Primitive.Style.info/1","type":"callback"},{"doc":"","ref":"Scenic.Primitive.Style.html#c:verify/1","title":"Scenic.Primitive.Style.verify/1","type":"callback"},{"doc":"Set how to draw the end of a line.Example:graph |&gt; line({{0,0}, {100,100}}, cap: :round)Data:butt - End of the line is flat, passing through the end point.:round - End of the line is round, radiating from the end point.:square - End of the line is flat, but projecting a square around the end point.","ref":"Scenic.Primitive.Style.Cap.html","title":"Scenic.Primitive.Style.Cap","type":"module"},{"doc":"Set the background color of the entire window/screen.Note: Since the :clear_color affect is global, it will only be honored when set on the base of the root scene. In other words, it has no affect on groups or when set on Components.Example:@graph Graph.build( clear_color: :white )DataAny valid color.","ref":"Scenic.Primitive.Style.ClearColor.html","title":"Scenic.Primitive.Style.ClearColor","type":"module"},{"doc":"Fill primitives with the specified paint.Example:graph |&gt; rectangle({10, 20}, fill: :blue)DataAny valid paint.","ref":"Scenic.Primitive.Style.Fill.html","title":"Scenic.Primitive.Style.Fill","type":"module"},{"doc":"Set the font used to draw text.Example:graph |&gt; text(&quot;Hello World&quot;, font: :roboto)DataYou can choose one of the three named system fonts, or one you've loaded into the cache.:roboto - The standard Roboto sans-serif font.:roboto_mono - The standard Roboto Mono mono-spaced font.To use a font from the cache, set it's hash into the font style.Example:@my_font_path :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/fonts/my_font.ttf&quot;) @my_font_hash Scenic.Cache.Hash.file!( @my_font_path, :sha ) @graph Graph.build() |&gt; text(&quot;Hello World&quot;, font: @my_font_hash) def init(_, _opts) do # load the font into the cache Scenic.Cache.File.load(@my_font_path, @my_font_hash) {:ok, :some_state, push: @graph} endNote 1: The font renderer used by Scenic is the fantastic stb_truetype library. This renderer was developed for games, which is another way of saying it is not trying to be the all-renderer for all fonts. Don't be surprised if you find a TrueType font that doesn't work as expected.Note 2: Other font renderers might become available in the future. The named system fonts should keep working, but custom TrueType fonts might need to be ported.It is up to you to test your custom font choices to see if they work for your application.","ref":"Scenic.Primitive.Style.Font.html","title":"Scenic.Primitive.Style.Font","type":"module"},{"doc":"Apply a blur effect to text.Example:graph |&gt; text(&quot;Blurry&quot;, font_blur: 2.0)DataAny number greater than or equal to zero.The higher the number, the more it blurs.","ref":"Scenic.Primitive.Style.FontBlur.html","title":"Scenic.Primitive.Style.FontBlur","type":"module"},{"doc":"The point-size to draw text in.Example:graph |&gt; text(&quot;Small&quot;, font_size: 6) |&gt; text(&quot;Large&quot;, font_size: 64)DataAny number greater than or equal to 6.","ref":"Scenic.Primitive.Style.FontSize.html","title":"Scenic.Primitive.Style.FontSize","type":"module"},{"doc":"Flags whether or not to draw a primitive.Example:graph |&gt; rectangle({100, 200}, hidden: true)Datatrue - &quot;Hide&quot; the primitive. Drawing is skipped.false - &quot;Show&quot; the primitive. Drawing is run.Note: setting hidden: true on a group will hide all the primitives in the group. This is very efficient as it simply skips drawing the group and everything in it.","ref":"Scenic.Primitive.Style.Hidden.html","title":"Scenic.Primitive.Style.Hidden","type":"module"},{"doc":"Set how to connect two lines in a path.Works with primitives that have clear joints, such as Rectangle, Quad, Triangle, and Path.Example:graph |&gt; triangle( {{0,40},{40,40},{40,0}} join: :round, stroke: {2, :green} )Data:miter - Miter the pointy part of the joint.:round - Round the entire joint.:bevel - Bevel the joint.","ref":"Scenic.Primitive.Style.Join.html","title":"Scenic.Primitive.Style.Join","type":"module"},{"doc":"Automatically miter joints if they are too sharp.Example:graph |&gt; triangle( {{0,40},{40,40},{40,0}} miter_limit: 2, stroke: {2, :green} )DataA number greater than zero.","ref":"Scenic.Primitive.Style.MiterLimit.html","title":"Scenic.Primitive.Style.MiterLimit","type":"module"},{"doc":"Define a &quot;Scissor Rectangle&quot; that drawing will be clipped to.Example:graph |&gt; triangle( {{0,40},{40,40},{40,0}} miter_limit: 2, fill: :green, scissor: {20, 40} )Data{width, height}width - Width of the scissor rectangle.height - Height of the scissor rectangle.","ref":"Scenic.Primitive.Style.Scissor.html","title":"Scenic.Primitive.Style.Scissor","type":"module"},{"doc":"Draw an outline around a primitive with the given paint.Example:graph |&gt; triangle( {{0,40},{40,40},{40,0}} miter_limit: 2, stroke: {2, :green} )Data{width, paint}width - Width of the border being stroked.:paint - Any valid paint.","ref":"Scenic.Primitive.Style.Stroke.html","title":"Scenic.Primitive.Style.Stroke","type":"module"},{"doc":"Set the alignment of the text with regard to the start point.Example:graph |&gt; text( &quot;Some Text&quot;, text_align: :center_middle )DataalignmentThe alignment type can be any one of the followingleft - Left side horizontally. Base of the text vertically.:right - Right side horizontally. Base of the text vertically.:center - Centered horizontally. Base of the text vertically.left_top - Left side horizontally. Top of the text vertically.:right_top - Right side horizontally. Top of the text vertically.:center_top - Centered horizontally. Top of the text vertically.left_middle - Left side horizontally. Centered vertically.:right_middle - Right side horizontally. Centered vertically.:center_middle - Centered horizontally. Centered vertically.left_bottom - Left side horizontally. Bottom of the text vertically.:right_bottom - Right side horizontally. Bottom of the text vertically.:center_bottom - Centered horizontally. Bottom of the text vertically.","ref":"Scenic.Primitive.Style.TextAlign.html","title":"Scenic.Primitive.Style.TextAlign","type":"module"},{"doc":"Set the vertical spacing of lines of text in a single block.Example:graph |&gt; text(&quot;Some Text\\r\\nMore Text&quot;, text_height: 50)The natural vertical spacing of the font is used by default. Set this style if you want to override it.Dataspacingspacing - Vertical spacing from line to line.","ref":"Scenic.Primitive.Style.TextHeight.html","title":"Scenic.Primitive.Style.TextHeight","type":"module"},{"doc":"The theme style is a way to bundle up default colors that are intended to be used by dynamic components invoked by a scene.There is a set of pre-defined themes. You can also pass in a map of theme values.Unlike other styles, these are a guide to the components. Each component gets to pick, choose, or ignore any colors in a given style.Main Predefined Themes:dark - This is the default and most common. Use when the background is dark.:light - Use when the background is light colored.Specialty ThemesThe remaining themes are designed to color the standard components and don't really make much sense when applied to the root of a graph. You could, but it would be... interesting.The most obvious place to use them is with Button components.:primary - Blue background. This is the primary button type indicator.:secondary - Grey background. Not primary type indicator.:success - Green background.:danger - Red background. Use for irreversible or dangerous actions.:warning - Orange background.:info - Lightish blue background.:text - Transparent background.","ref":"Scenic.Primitive.Style.Theme.html","title":"Scenic.Primitive.Style.Theme","type":"module"},{"doc":"Paint is used to &quot;fill&quot; the area of primitives.When you apply the :fill style to a primitive, you must supply valid paint data.There are five types of paint.:color - Fill with a solid color. This is the most common and has shortcuts.:image - Fill with an image from the cache.:box_gradient - Fill with a box gradient.:linear_gradient - Fill with a linear gradient.:radial_gradient - Fill with a radial gradient.See the documentation for each type for details.Color ShortcutFilling with a color is so common, you can just declare any valid color in a fill, and it will figure out the right paint to use.Examples:graph |&gt; rect({100,200}, fill: :blue) |&gt; rect({60,120}, fill: {:blue, 128}) |&gt; rect({30,60}, fill: {10,20,30,40})","ref":"Scenic.Primitive.Style.Paint.html","title":"Scenic.Primitive.Style.Paint","type":"module"},{"doc":"Fill a primitive with a box gradientFull Format{:box_gradient, {x, y, width, height, feather, color_start, color_end}}","ref":"Scenic.Primitive.Style.Paint.BoxGradient.html","title":"Scenic.Primitive.Style.Paint.BoxGradient","type":"module"},{"doc":"Fill a primitive with a single colorThe color paint is used as the data for the :fill style.Full Format{:color, valid_color}The full format is a tuple with two parameters. The first is the :color atom indicating that this is color paint data. The second is any valid color (see below).Shortcut Formatvalid_colorBecause the color paint type is used so frequently, you can simply pass in any valid color and the :fill style will infer that it is to be used as paint.Example:graph |&gt; line({{0,0}, {100,100}}, fill: :blue)Valid ColorsThere are several ways to specify a color.Named ColorsThe simplest is to used a named color (see the table below). Named colors are simply referred to by an atom, which is their name. Named colors are opaque by default.Named Colors with Alpha / TransparencyIf you want a named color with a transparency, you can wrap it in a tuple and add a number between 0 and 255 (or 0x00 and 0xFF), to represent the alpha transparency.{:blue, 128}RGB ColorsAn RGB color directly specifies the three color channels as a tuple. It is opaque by default.{123, 231, 210} {0xA1, 0xB1, 0xC1}RGBA ColorsAn RGBA color directly specifies the three color channels and the alpha/transparecy as a tuple.{123, 231, 210, 128} {0xA1, 0xB1, 0xC1, 0x12}Named ColorsThe set of named colors is adapted from the formal named colors from html.NameValueExample:alice_blue{0xF0, 0xF8, 0xFF}&lt;div style=&quot;width=100%; background-color: AliceBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:antique_white{0xFA, 0xEB, 0xD7}&lt;div style=&quot;width=100%; background-color: AntiqueWhite;&quot;&gt;&amp;nbsp;&lt;/div&gt;:aqua{0x00, 0xFF, 0xFF}&lt;div style=&quot;width=100%; background-color: Aqua;&quot;&gt;&amp;nbsp;&lt;/div&gt;:aquamarine{0x7F, 0xFF, 0xD4}&lt;div style=&quot;width=100%; background-color: Aquamarine;&quot;&gt;&amp;nbsp;&lt;/div&gt;:azure{0xF0, 0xFF, 0xFF}&lt;div style=&quot;width=100%; background-color: Azure;&quot;&gt;&amp;nbsp;&lt;/div&gt;:beige{0xF5, 0xF5, 0xDC}&lt;div style=&quot;width=100%; background-color: Beige;&quot;&gt;&amp;nbsp;&lt;/div&gt;:bisque{0xFF, 0xE4, 0xC4}&lt;div style=&quot;width=100%; background-color: Bisque;&quot;&gt;&amp;nbsp;&lt;/div&gt;:black{0x00, 0x00, 0x00}&lt;div style=&quot;width=100%; background-color: Black;&quot;&gt;&amp;nbsp;&lt;/div&gt;:blanched_almond{0xFF, 0xEB, 0xCD}&lt;div style=&quot;width=100%; background-color: BlanchedAlmond;&quot;&gt;&amp;nbsp;&lt;/div&gt;:blue{0x00, 0x00, 0xFF}&lt;div style=&quot;width=100%; background-color: Blue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:blue_violet{0x8A, 0x2B, 0xE2}&lt;div style=&quot;width=100%; background-color: BlueViolet;&quot;&gt;&amp;nbsp;&lt;/div&gt;:brown{0xA5, 0x2A, 0x2A}&lt;div style=&quot;width=100%; background-color: Brown;&quot;&gt;&amp;nbsp;&lt;/div&gt;:burly_wood{0xDE, 0xB8, 0x87}&lt;div style=&quot;width=100%; background-color: BurlyWood;&quot;&gt;&amp;nbsp;&lt;/div&gt;:cadet_blue{0x5F, 0x9E, 0xA0}&lt;div style=&quot;width=100%; background-color: CadetBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:chartreuse{0x7F, 0xFF, 0x00}&lt;div style=&quot;width=100%; background-color: Chartreuse;&quot;&gt;&amp;nbsp;&lt;/div&gt;:chocolate{0xD2, 0x69, 0x1E}&lt;div style=&quot;width=100%; background-color: Chocolate;&quot;&gt;&amp;nbsp;&lt;/div&gt;:coral{0xFF, 0x7F, 0x50}&lt;div style=&quot;width=100%; background-color: Coral;&quot;&gt;&amp;nbsp;&lt;/div&gt;:cornflower_blue{0x64, 0x95, 0xED}&lt;div style=&quot;width=100%; background-color: CornflowerBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:cornsilk{0xFF, 0xF8, 0xDC}&lt;div style=&quot;width=100%; background-color: Cornsilk;&quot;&gt;&amp;nbsp;&lt;/div&gt;:crimson{0xDC, 0x14, 0x3C}&lt;div style=&quot;width=100%; background-color: Crimson;&quot;&gt;&amp;nbsp;&lt;/div&gt;:cyan{0x00, 0xFF, 0xFF}&lt;div style=&quot;width=100%; background-color: Cyan;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_blue{0x00, 0x00, 0x8B}&lt;div style=&quot;width=100%; background-color: DarkBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_cyan{0x00, 0x8B, 0x8B}&lt;div style=&quot;width=100%; background-color: DarkCyan;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_golden_rod{0xB8, 0x86, 0x0B}&lt;div style=&quot;width=100%; background-color: DarkGoldenRod;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_gray{0xA9, 0xA9, 0xA9}&lt;div style=&quot;width=100%; background-color: DarkGray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_grey{0xA9, 0xA9, 0xA9}&lt;div style=&quot;width=100%; background-color: DarkGrey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_green{0x00, 0x64, 0x00}&lt;div style=&quot;width=100%; background-color: DarkGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_khaki{0xBD, 0xB7, 0x6B}&lt;div style=&quot;width=100%; background-color: DarkKhaki;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_magenta{0x8B, 0x00, 0x8B}&lt;div style=&quot;width=100%; background-color: DarkMagenta;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_olive_green{0x55, 0x6B, 0x2F}&lt;div style=&quot;width=100%; background-color: DarkOliveGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_orange{0xFF, 0x8C, 0x00}&lt;div style=&quot;width=100%; background-color: DarkOrange;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_orchid{0x99, 0x32, 0xCC}&lt;div style=&quot;width=100%; background-color: DarkOrchid;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_red{0x8B, 0x00, 0x00}&lt;div style=&quot;width=100%; background-color: DarkRed;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_salmon{0xE9, 0x96, 0x7A}&lt;div style=&quot;width=100%; background-color: DarkSalmon;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_sea_green{0x8F, 0xBC, 0x8F}&lt;div style=&quot;width=100%; background-color: DarkSeaGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_slate_blue{0x48, 0x3D, 0x8B}&lt;div style=&quot;width=100%; background-color: DarkSlateBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_slate_gray{0x2F, 0x4F, 0x4F}&lt;div style=&quot;width=100%; background-color: DarkSlateGray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_slate_grey{0x2F, 0x4F, 0x4F}&lt;div style=&quot;width=100%; background-color: DarkSlateGrey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_turquoise{0x00, 0xCE, 0xD1}&lt;div style=&quot;width=100%; background-color: DarkTurquoise;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dark_violet{0x94, 0x00, 0xD3}&lt;div style=&quot;width=100%; background-color: DarkViolet;&quot;&gt;&amp;nbsp;&lt;/div&gt;:deep_pink{0xFF, 0x14, 0x93}&lt;div style=&quot;width=100%; background-color: DeepPink;&quot;&gt;&amp;nbsp;&lt;/div&gt;:deep_sky_blue{0x00, 0xBF, 0xFF}&lt;div style=&quot;width=100%; background-color: DeepSkyBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dim_gray{0x69, 0x69, 0x69}&lt;div style=&quot;width=100%; background-color: DimGray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dim_grey{0x69, 0x69, 0x69}&lt;div style=&quot;width=100%; background-color: DimGrey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:dodger_blue{0x1E, 0x90, 0xFF}&lt;div style=&quot;width=100%; background-color: DodgerBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:fire_brick{0xB2, 0x22, 0x22}&lt;div style=&quot;width=100%; background-color: FireBrick;&quot;&gt;&amp;nbsp;&lt;/div&gt;:floral_white{0xFF, 0xFA, 0xF0}&lt;div style=&quot;width=100%; background-color: FloralWhite;&quot;&gt;&amp;nbsp;&lt;/div&gt;:forest_green{0x22, 0x8B, 0x22}&lt;div style=&quot;width=100%; background-color: ForestGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:fuchsia{0xFF, 0x00, 0xFF}&lt;div style=&quot;width=100%; background-color: Fuchsia;&quot;&gt;&amp;nbsp;&lt;/div&gt;:gainsboro{0xDC, 0xDC, 0xDC}&lt;div style=&quot;width=100%; background-color: Gainsboro;&quot;&gt;&amp;nbsp;&lt;/div&gt;:ghost_white{0xF8, 0xF8, 0xFF}&lt;div style=&quot;width=100%; background-color: GhostWhite;&quot;&gt;&amp;nbsp;&lt;/div&gt;:gold{0xFF, 0xD7, 0x00}&lt;div style=&quot;width=100%; background-color: Gold;&quot;&gt;&amp;nbsp;&lt;/div&gt;:golden_rod{0xDA, 0xA5, 0x20}&lt;div style=&quot;width=100%; background-color: GoldenRod;&quot;&gt;&amp;nbsp;&lt;/div&gt;:gray{0x80, 0x80, 0x80}&lt;div style=&quot;width=100%; background-color: Gray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:grey{0x80, 0x80, 0x80}&lt;div style=&quot;width=100%; background-color: Grey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:green{0x00, 0x80, 0x00}&lt;div style=&quot;width=100%; background-color: Green;&quot;&gt;&amp;nbsp;&lt;/div&gt;:green_yellow{0xAD, 0xFF, 0x2F}&lt;div style=&quot;width=100%; background-color: GreenYellow;&quot;&gt;&amp;nbsp;&lt;/div&gt;:honey_dew{0xF0, 0xFF, 0xF0}&lt;div style=&quot;width=100%; background-color: HoneyDew;&quot;&gt;&amp;nbsp;&lt;/div&gt;:hot_pink{0xFF, 0x69, 0xB4}&lt;div style=&quot;width=100%; background-color: HotPink;&quot;&gt;&amp;nbsp;&lt;/div&gt;:indian_red{0xCD, 0x5C, 0x5C}&lt;div style=&quot;width=100%; background-color: IndianRed;&quot;&gt;&amp;nbsp;&lt;/div&gt;:indigo{0x4B, 0x00, 0x82}&lt;div style=&quot;width=100%; background-color: Indigo;&quot;&gt;&amp;nbsp;&lt;/div&gt;:ivory{0xFF, 0xFF, 0xF0}&lt;div style=&quot;width=100%; background-color: Ivory;&quot;&gt;&amp;nbsp;&lt;/div&gt;:khaki{0xF0, 0xE6, 0x8C}&lt;div style=&quot;width=100%; background-color: Khaki;&quot;&gt;&amp;nbsp;&lt;/div&gt;:lavender{0xE6, 0xE6, 0xFA}&lt;div style=&quot;width=100%; background-color: Lavender;&quot;&gt;&amp;nbsp;&lt;/div&gt;:lavender_blush{0xFF, 0xF0, 0xF5}&lt;div style=&quot;width=100%; background-color: LavenderBlush;&quot;&gt;&amp;nbsp;&lt;/div&gt;:lawn_green{0x7C, 0xFC, 0x00}&lt;div style=&quot;width=100%; background-color: LawnGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:lemon_chiffon{0xFF, 0xFA, 0xCD}&lt;div style=&quot;width=100%; background-color: LemonChiffon;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_blue{0xAD, 0xD8, 0xE6}&lt;div style=&quot;width=100%; background-color: LightBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_coral{0xF0, 0x80, 0x80}&lt;div style=&quot;width=100%; background-color: LightCoral;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_cyan{0xE0, 0xFF, 0xFF}&lt;div style=&quot;width=100%; background-color: LightCyan;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_golden_rod_yellow{0xFA, 0xFA, 0xD2}&lt;div style=&quot;width=100%; background-color: LightGoldenRodYellow;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_gray{0xD3, 0xD3, 0xD3}&lt;div style=&quot;width=100%; background-color: LightGray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_grey{0xD3, 0xD3, 0xD3}&lt;div style=&quot;width=100%; background-color: LightGrey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_green{0x90, 0xEE, 0x90}&lt;div style=&quot;width=100%; background-color: LightGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_pink{0xFF, 0xB6, 0xC1}&lt;div style=&quot;width=100%; background-color: LightPink;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_salmon{0xFF, 0xA0, 0x7A}&lt;div style=&quot;width=100%; background-color: LightSalmon;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_sea_green{0x20, 0xB2, 0xAA}&lt;div style=&quot;width=100%; background-color: LightSeaGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_sky_blue{0x87, 0xCE, 0xFA}&lt;div style=&quot;width=100%; background-color: LightSkyBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_slate_gray{0x77, 0x88, 0x99}&lt;div style=&quot;width=100%; background-color: LightSlateGray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_slate_grey{0x77, 0x88, 0x99}&lt;div style=&quot;width=100%; background-color: LightSlateGrey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_steel_blue{0xB0, 0xC4, 0xDE}&lt;div style=&quot;width=100%; background-color: LightSteelBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:light_yellow{0xFF, 0xFF, 0xE0}&lt;div style=&quot;width=100%; background-color: LightYellow;&quot;&gt;&amp;nbsp;&lt;/div&gt;:lime{0x00, 0xFF, 0x00}&lt;div style=&quot;width=100%; background-color: Lime;&quot;&gt;&amp;nbsp;&lt;/div&gt;:lime_green{0x32, 0xCD, 0x32}&lt;div style=&quot;width=100%; background-color: LimeGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:linen{0xFA, 0xF0, 0xE6}&lt;div style=&quot;width=100%; background-color: Linen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:magenta{0xFF, 0x00, 0xFF}&lt;div style=&quot;width=100%; background-color: Magenta;&quot;&gt;&amp;nbsp;&lt;/div&gt;:maroon{0x80, 0x00, 0x00}&lt;div style=&quot;width=100%; background-color: Maroon;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_aqua_marine{0x66, 0xCD, 0xAA}&lt;div style=&quot;width=100%; background-color: MediumAquaMarine;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_blue{0x00, 0x00, 0xCD}&lt;div style=&quot;width=100%; background-color: MediumBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_orchid{0xBA, 0x55, 0xD3}&lt;div style=&quot;width=100%; background-color: MediumOrchid;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_purple{0x93, 0x70, 0xDB}&lt;div style=&quot;width=100%; background-color: MediumPurple;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_sea_green{0x3C, 0xB3, 0x71}&lt;div style=&quot;width=100%; background-color: MediumSeaGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_slate_blue{0x7B, 0x68, 0xEE}&lt;div style=&quot;width=100%; background-color: MediumSlateBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_spring_green{0x00, 0xFA, 0x9A}&lt;div style=&quot;width=100%; background-color: MediumSpringGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_turquoise{0x48, 0xD1, 0xCC}&lt;div style=&quot;width=100%; background-color: MediumTurquoise;&quot;&gt;&amp;nbsp;&lt;/div&gt;:medium_violet_red{0xC7, 0x15, 0x85}&lt;div style=&quot;width=100%; background-color: MediumVioletRed;&quot;&gt;&amp;nbsp;&lt;/div&gt;:midnight_blue{0x19, 0x19, 0x70}&lt;div style=&quot;width=100%; background-color: MidnightBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:mint_cream{0xF5, 0xFF, 0xFA}&lt;div style=&quot;width=100%; background-color: MintCream;&quot;&gt;&amp;nbsp;&lt;/div&gt;:misty_rose{0xFF, 0xE4, 0xE1}&lt;div style=&quot;width=100%; background-color: MistyRose;&quot;&gt;&amp;nbsp;&lt;/div&gt;:moccasin{0xFF, 0xE4, 0xB5}&lt;div style=&quot;width=100%; background-color: Moccasin;&quot;&gt;&amp;nbsp;&lt;/div&gt;:navajo_white{0xFF, 0xDE, 0xAD}&lt;div style=&quot;width=100%; background-color: NavajoWhite;&quot;&gt;&amp;nbsp;&lt;/div&gt;:navy{0x00, 0x00, 0x80}&lt;div style=&quot;width=100%; background-color: Navy;&quot;&gt;&amp;nbsp;&lt;/div&gt;:old_lace{0xFD, 0xF5, 0xE6}&lt;div style=&quot;width=100%; background-color: OldLace;&quot;&gt;&amp;nbsp;&lt;/div&gt;:olive{0x80, 0x80, 0x00}&lt;div style=&quot;width=100%; background-color: Olive;&quot;&gt;&amp;nbsp;&lt;/div&gt;:olive_drab{0x6B, 0x8E, 0x23}&lt;div style=&quot;width=100%; background-color: OliveDrab;&quot;&gt;&amp;nbsp;&lt;/div&gt;:orange{0xFF, 0xA5, 0x00}&lt;div style=&quot;width=100%; background-color: Orange;&quot;&gt;&amp;nbsp;&lt;/div&gt;:orange_red{0xFF, 0x45, 0x00}&lt;div style=&quot;width=100%; background-color: OrangeRed;&quot;&gt;&amp;nbsp;&lt;/div&gt;:orchid{0xDA, 0x70, 0xD6}&lt;div style=&quot;width=100%; background-color: Orchid;&quot;&gt;&amp;nbsp;&lt;/div&gt;:pale_golden_rod{0xEE, 0xE8, 0xAA}&lt;div style=&quot;width=100%; background-color: PaleGoldenRod;&quot;&gt;&amp;nbsp;&lt;/div&gt;:pale_green{0x98, 0xFB, 0x98}&lt;div style=&quot;width=100%; background-color: PaleGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:pale_turquoise{0xAF, 0xEE, 0xEE}&lt;div style=&quot;width=100%; background-color: PaleTurquoise;&quot;&gt;&amp;nbsp;&lt;/div&gt;:pale_violet_red{0xDB, 0x70, 0x93}&lt;div style=&quot;width=100%; background-color: PaleVioletRed;&quot;&gt;&amp;nbsp;&lt;/div&gt;:papaya_whip{0xFF, 0xEF, 0xD5}&lt;div style=&quot;width=100%; background-color: PapayaWhip;&quot;&gt;&amp;nbsp;&lt;/div&gt;:peach_puff{0xFF, 0xDA, 0xB9}&lt;div style=&quot;width=100%; background-color: PeachPuff;&quot;&gt;&amp;nbsp;&lt;/div&gt;:peru{0xCD, 0x85, 0x3F}&lt;div style=&quot;width=100%; background-color: Peru;&quot;&gt;&amp;nbsp;&lt;/div&gt;:pink{0xFF, 0xC0, 0xCB}&lt;div style=&quot;width=100%; background-color: Pink;&quot;&gt;&amp;nbsp;&lt;/div&gt;:plum{0xDD, 0xA0, 0xDD}&lt;div style=&quot;width=100%; background-color: Plum;&quot;&gt;&amp;nbsp;&lt;/div&gt;:powder_blue{0xB0, 0xE0, 0xE6}&lt;div style=&quot;width=100%; background-color: PowderBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:purple{0x80, 0x00, 0x80}&lt;div style=&quot;width=100%; background-color: Purple;&quot;&gt;&amp;nbsp;&lt;/div&gt;:rebecca_purple{0x66, 0x33, 0x99}&lt;div style=&quot;width=100%; background-color: RebeccaPurple;&quot;&gt;&amp;nbsp;&lt;/div&gt;:red{0xFF, 0x00, 0x00}&lt;div style=&quot;width=100%; background-color: Red;&quot;&gt;&amp;nbsp;&lt;/div&gt;:rosy_brown{0xBC, 0x8F, 0x8F}&lt;div style=&quot;width=100%; background-color: RosyBrown;&quot;&gt;&amp;nbsp;&lt;/div&gt;:royal_blue{0x41, 0x69, 0xE1}&lt;div style=&quot;width=100%; background-color: RoyalBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:saddle_brown{0x8B, 0x45, 0x13}&lt;div style=&quot;width=100%; background-color: SaddleBrown;&quot;&gt;&amp;nbsp;&lt;/div&gt;:salmon{0xFA, 0x80, 0x72}&lt;div style=&quot;width=100%; background-color: Salmon;&quot;&gt;&amp;nbsp;&lt;/div&gt;:sandy_brown{0xF4, 0xA4, 0x60}&lt;div style=&quot;width=100%; background-color: SandyBrown;&quot;&gt;&amp;nbsp;&lt;/div&gt;:sea_green{0x2E, 0x8B, 0x57}&lt;div style=&quot;width=100%; background-color: SeaGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:sea_shell{0xFF, 0xF5, 0xEE}&lt;div style=&quot;width=100%; background-color: SeaShell;&quot;&gt;&amp;nbsp;&lt;/div&gt;:sienna{0xA0, 0x52, 0x2D}&lt;div style=&quot;width=100%; background-color: Sienna;&quot;&gt;&amp;nbsp;&lt;/div&gt;:silver{0xC0, 0xC0, 0xC0}&lt;div style=&quot;width=100%; background-color: Silver;&quot;&gt;&amp;nbsp;&lt;/div&gt;:sky_blue{0x87, 0xCE, 0xEB}&lt;div style=&quot;width=100%; background-color: SkyBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:slate_blue{0x6A, 0x5A, 0xCD}&lt;div style=&quot;width=100%; background-color: SlateBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:slate_gray{0x70, 0x80, 0x90}&lt;div style=&quot;width=100%; background-color: SlateGray;&quot;&gt;&amp;nbsp;&lt;/div&gt;:slate_grey{0x70, 0x80, 0x90}&lt;div style=&quot;width=100%; background-color: SlateGrey;&quot;&gt;&amp;nbsp;&lt;/div&gt;:snow{0xFF, 0xFA, 0xFA}&lt;div style=&quot;width=100%; background-color: Snow;&quot;&gt;&amp;nbsp;&lt;/div&gt;:spring_green{0x00, 0xFF, 0x7F}&lt;div style=&quot;width=100%; background-color: SpringGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;:steel_blue{0x46, 0x82, 0xB4}&lt;div style=&quot;width=100%; background-color: SteelBlue;&quot;&gt;&amp;nbsp;&lt;/div&gt;:tan{0xD2, 0xB4, 0x8C}&lt;div style=&quot;width=100%; background-color: Tan;&quot;&gt;&amp;nbsp;&lt;/div&gt;:teal{0x00, 0x80, 0x80}&lt;div style=&quot;width=100%; background-color: Teal;&quot;&gt;&amp;nbsp;&lt;/div&gt;:thistle{0xD8, 0xBF, 0xD8}&lt;div style=&quot;width=100%; background-color: Thistle;&quot;&gt;&amp;nbsp;&lt;/div&gt;:tomato{0xFF, 0x63, 0x47}&lt;div style=&quot;width=100%; background-color: Tomato;&quot;&gt;&amp;nbsp;&lt;/div&gt;:turquoise{0x40, 0xE0, 0xD0}&lt;div style=&quot;width=100%; background-color: Turquoise;&quot;&gt;&amp;nbsp;&lt;/div&gt;:violet{0xEE, 0x82, 0xEE}&lt;div style=&quot;width=100%; background-color: Violet;&quot;&gt;&amp;nbsp;&lt;/div&gt;:wheat{0xF5, 0xDE, 0xB3}&lt;div style=&quot;width=100%; background-color: Wheat;&quot;&gt;&amp;nbsp;&lt;/div&gt;:white{0xFF, 0xFF, 0xFF}&lt;div style=&quot;width=100%; background-color: White;&quot;&gt;&amp;nbsp;&lt;/div&gt;:white_smoke{0xF5, 0xF5, 0xF5}&lt;div style=&quot;width=100%; background-color: WhiteSmoke;&quot;&gt;&amp;nbsp;&lt;/div&gt;:yellow{0xFF, 0xFF, 0x00}&lt;div style=&quot;width=100%; background-color: Yellow;&quot;&gt;&amp;nbsp;&lt;/div&gt;:yellow_green{0x9A, 0xCD, 0x32}&lt;div style=&quot;width=100%; background-color: YellowGreen;&quot;&gt;&amp;nbsp;&lt;/div&gt;Additional Named ColorsNameValueExample:clear{0x80, 0x80, 0x80, 0x00}:transparent{0x80, 0x80, 0x80, 0x00}","ref":"Scenic.Primitive.Style.Paint.Color.html","title":"Scenic.Primitive.Style.Paint.Color","type":"module"},{"doc":"Convert a named color to RGB format","ref":"Scenic.Primitive.Style.Paint.Color.html#name_to_rgb/1","title":"Scenic.Primitive.Style.Paint.Color.name_to_rgb/1","type":"function"},{"doc":"Convert a named or RGB color to RGBA format","ref":"Scenic.Primitive.Style.Paint.Color.html#to_rgba/1","title":"Scenic.Primitive.Style.Paint.Color.to_rgba/1","type":"function"},{"doc":"Verify that a color is correctly described","ref":"Scenic.Primitive.Style.Paint.Color.html#verify/1","title":"Scenic.Primitive.Style.Paint.Color.verify/1","type":"function"},{"doc":"","ref":"Scenic.Primitive.Style.Paint.Color.html#t:rgb/0","title":"Scenic.Primitive.Style.Paint.Color.rgb/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Style.Paint.Color.html#t:rgba/0","title":"Scenic.Primitive.Style.Paint.Color.rgba/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Style.Paint.Color.html#t:t/0","title":"Scenic.Primitive.Style.Paint.Color.t/0","type":"type"},{"doc":"Fill a primitive with an image from Scenic.Cache.Dynamic.TextureFull FormatDynamic paint accepts several variations. In each case, the key is a key referencing an image that has been loaded into Scenic.Cache.Dynamic.Texture.{:dynamic, key} - Show the full image{:dynamic, {key, alpha}} - Show the full image with transparency{:dynamic, {key, start_x, start_y, end_x, end_y, angle, alpha}}","ref":"Scenic.Primitive.Style.Paint.Dynamic.html","title":"Scenic.Primitive.Style.Paint.Dynamic","type":"module"},{"doc":"Fill a primitive with an image from Scenic.Cache.Static.TextureFull FormatImage paint accepts several variations. In each case, the hash is a key referencing an image that has been loaded into Scenic.Cache.Static.Texture.{:image, hash} - Show the full image{:image, {hash, alpha}} - Show the full image with transparency{:image, {hash, start_x, start_y, end_x, end_y, angle, alpha}}","ref":"Scenic.Primitive.Style.Paint.Image.html","title":"Scenic.Primitive.Style.Paint.Image","type":"module"},{"doc":"Fill a primitive with a linear gradientFull Format{:linear, {start_x, start_y, end_x, end_y, color_start, color_end}}","ref":"Scenic.Primitive.Style.Paint.LinearGradient.html","title":"Scenic.Primitive.Style.Paint.LinearGradient","type":"module"},{"doc":"Fill a primitive with a radial gradientFull Format{:radial, {center_x, center_y, inner_radius, outer_radius, color_start, color_end}}","ref":"Scenic.Primitive.Style.Paint.RadialGradient.html","title":"Scenic.Primitive.Style.Paint.RadialGradient","type":"module"},{"doc":"Change the position, rotation, scale and more of a primitive.Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives.A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations.Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.Multiple transforms can be applied to any primitive. Transforms combine down the graph to create a very flexible way to manage your scene.There are a fixed set of transform helpers that create matrices for you.Matrix hand specify a matrix.Pin set a pin to rotate or scale around. Most primitives define a sensible default pin.Rotate rotate around the pin.Scale scale larger or smaller. Centered around the pin.Translate move/translate horizontally and veritcally.Specifying TransformsYou apply transforms to a primitive the same way you specify styles.graph = Graph.build |&gt; circle( 100, fill: {:color, :green}, translate: {200, 200} ) |&gt; ellipse( {40, 60, fill: {:color, :red}, rotate: 0.4, translate: {100, 100} )Don't worry about the order you apply transforms to a single object. Scenic will multiply them together in the correct way when it comes time to render them.","ref":"Scenic.Primitive.Transform.html","title":"Scenic.Primitive.Transform","type":"behaviour"},{"doc":"Given a Map describing the transforms on a primitive, calculate the combined matrix that should be applied.This is trickier than just multiplying them together. Rotations, translations and scale, need to be done in the right order, which is why this function is provided.You will not normally need to use this function. It is used internally by the input system.","ref":"Scenic.Primitive.Transform.html#calculate_local/1","title":"Scenic.Primitive.Transform.calculate_local/1","type":"function"},{"doc":"","ref":"Scenic.Primitive.Transform.html#c:info/1","title":"Scenic.Primitive.Transform.info/1","type":"callback"},{"doc":"","ref":"Scenic.Primitive.Transform.html#c:verify/1","title":"Scenic.Primitive.Transform.verify/1","type":"callback"},{"doc":"Apply an arbitrary matrix.Applies an arbitrary 4x4 matrix to a primitive. For now, only the 2-D part of the matrix actually does anything. Am using 4x4 though for future compatibility.Example:@matrix [ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 ] |&gt; Scenic.Math.Matrix.Matrix.Utils.to_binary() graph |&gt; text(&quot;Transformer!&quot;, matrix: @matrix)","ref":"Scenic.Primitive.Transform.Matrix.html","title":"Scenic.Primitive.Transform.Matrix","type":"module"},{"doc":"Set the pin for rotate and scale transforms.When rotating or scaling, you need to set the point that doesn't move. This is the pin. If you don't set one, Scenic will try to use a sensible default for whatever primitive you are transforming.Use the :pin option to set it explicitly{pin_x, pin_y } Example:graph |&gt; text(&quot;Rotated!&quot;, rotate: 1.2, pin: {10, 20})","ref":"Scenic.Primitive.Transform.Pin.html","title":"Scenic.Primitive.Transform.Pin","type":"module"},{"doc":"Apply a rotation matrix.Always rotates around the z-axis (coming out of the screen).The value is given in radians.Positive values rotate clockwise.The rotation is pinned to the sensible default for each primitive, or to the :pin that you assign explicitly.Example:graph |&gt; text(&quot;Rotated!&quot;, rotate: 1.2) |&gt; text(&quot;Rotated!&quot;, rotate: 1.2, pin: {10, 20})ShortcutRotation is common enough that you can use :r as a shortcut.Example:graph |&gt; text(&quot;Rotated!&quot;, r: 1.2)","ref":"Scenic.Primitive.Transform.Rotate.html","title":"Scenic.Primitive.Transform.Rotate","type":"module"},{"doc":"Apply a scale matrix.Increase or shrink by the provided multiplier. This can take two forms:multiplier - scale both x and y directions by the same multiplier{mul_x, mul_y} - scale x and y directions independentlyScaling is pinned to the sensible default for each primitive, or to the :pin that you assign explicitly.Example:graph |&gt; text(&quot;Scaled!&quot;, scale: 1.2) |&gt; text(&quot;Scaled!&quot;, scale: {1.0, 1.2}, pin: {10, 20})ShortcutScaling is common enough that you can use :s as a shortcut.Example:graph |&gt; text(&quot;Scaled!&quot;, s: 1.2)","ref":"Scenic.Primitive.Transform.Scale.html","title":"Scenic.Primitive.Transform.Scale","type":"module"},{"doc":"Apply a translation matrix.This is used to position primitives on the screen{x, y} - move the primitive by the given amountsExample:graph |&gt; text(&quot;Scaled!&quot;, translate: {10, 20})ShortcutTranslating is common enough that you can use :t as a shortcut.Example:graph |&gt; text(&quot;Scaled!&quot;, t: {10, 20})","ref":"Scenic.Primitive.Transform.Translate.html","title":"Scenic.Primitive.Transform.Translate","type":"module"},{"doc":"Helper functions that support Scenic mathematical operations.The math functions are fairly straightforward. When performance is needed some have been broken out into a NIF.The NIF functions are currently written for compatibility over top speed and as such, there is an opportunity to further improve them by calling out to CPU-specific vector instructions in the future.","ref":"Scenic.Math.html","title":"Scenic.Math","type":"module"},{"doc":"","ref":"Scenic.Math.html#t:line/0","title":"Scenic.Math.line/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:matrix/0","title":"Scenic.Math.matrix/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:matrix_list/0","title":"Scenic.Math.matrix_list/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:point/0","title":"Scenic.Math.point/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:quad/0","title":"Scenic.Math.quad/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:triangle/0","title":"Scenic.Math.triangle/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:vector_2/0","title":"Scenic.Math.vector_2/0","type":"type"},{"doc":"A collection of functions to work with lines.Lines are always two points in a tuple.{point_a, point_b} {{x0, y0}, {x1, y1}}","ref":"Scenic.Math.Line.html","title":"Scenic.Math.Line","type":"module"},{"doc":"Find the point of intersection between two lines.Parameters:line_a - A line defined by two points. {point_a, point_b}line_b - A line defined by two points. {point_a, point_b}Returns: A pointExamples iex&gt; Scenic.Math.Line.intersection({{1, 1}, {3, 3}}, {{3, 1}, {1, 3}}) {2.0, 2.0}","ref":"Scenic.Math.Line.html#intersection/2","title":"Scenic.Math.Line.intersection/2","type":"function"},{"doc":"Find a new line that is parallel to the given line and separated by the given distance.Parameters:line - A line defined by two points. {point_a, point_b}distance - The perpendicular distance to the new line.Returns: A lineExamplesiex&gt; Scenic.Math.Line.parallel({{1, 1}, {1, 2}}, 2) {{3.0, 1.0}, {3.0, 2.0}}","ref":"Scenic.Math.Line.html#parallel/2","title":"Scenic.Math.Line.parallel/2","type":"function"},{"doc":"Round the points that define a line so that they are made up of integers.Parameters:line - A line defined by two points. {point_a, point_b}Returns:A lineExamplesiex&gt; Scenic.Math.Line.round({{1.5, 1.6}, {2.1, 2.56}}) {{2, 2}, {2, 3}}","ref":"Scenic.Math.Line.html#round/1","title":"Scenic.Math.Line.round/1","type":"function"},{"doc":"Truncate the points that define a line so that they are made up of integers.Parameters:line - A line defined by two points. {point_a, point_b}Returns:A lineExamplesiex&gt; Scenic.Math.Line.trunc({{1.1, 1.1}, {2.0, 2.0}}) {{1, 1}, {2, 2}} iex&gt; Scenic.Math.Line.trunc({{-1, 1}, {-2.0, 2.0}}) {{-1, 1}, {-2, 2}}","ref":"Scenic.Math.Line.html#trunc/1","title":"Scenic.Math.Line.trunc/1","type":"function"},{"doc":"A collection of functions to work with matrices.All the matrix fucntions in this module work exclusively with the binary form of a matrix, which is a compact binary of 16 4-byte floats.If you would like to convert back and forth from the more human friendly list version, then please use the functions in Scenic.Math.Matrix.Utils","ref":"Scenic.Math.Matrix.html","title":"Scenic.Math.Matrix","type":"module"},{"doc":"Add two matrices together.This operation is implemented as a NIF for performance.Parameters:matrix_a: The first matrixmatrix_b: The second matrixReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#add/2","title":"Scenic.Math.Matrix.add/2","type":"function"},{"doc":"Calculate the adjugate of a matrixThis operation is implemented as a NIF for performance.Parameters:matrix: A matrixReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#adjugate/1","title":"Scenic.Math.Matrix.adjugate/1","type":"function"},{"doc":"Build a matrix that represents a 2D rotation around a point.Parameters:angle: the amount to rotate, in radianspin: position to pin the rotation aroundReturns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_rotate_around/2","title":"Scenic.Math.Matrix.build_rotate_around/2","type":"function"},{"doc":"Build a matrix that represents a 2D rotation around the origin.Parameters:angle: the amount to rotate, in radiansReturns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_rotation/1","title":"Scenic.Math.Matrix.build_rotation/1","type":"function"},{"doc":"Build a matrix that represents a scaling operation.Parameters:scale: the amount to scale by. Can be either a number or a vector_2Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_scale/1","title":"Scenic.Math.Matrix.build_scale/1","type":"function"},{"doc":"Build a matrix that represents a simple translation.Parameters:vector_2: the vector defining how much to translateReturns: A binary matrix","ref":"Scenic.Math.Matrix.html#build_translation/1","title":"Scenic.Math.Matrix.build_translation/1","type":"function"},{"doc":"Test if two matrices are close in value to each other.Parameters:matrix_a: The first matrixmatrix_b: The second matrixtolerance: Defines what close means. Defaults to: 0.000001Returns: A boolean","ref":"Scenic.Math.Matrix.html#close?/3","title":"Scenic.Math.Matrix.close?/3","type":"function"},{"doc":"Calculate the determinant of a matrixThis operation is implemented as a NIF for performance.Parameters:matrix: A matrixReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#determinant/1","title":"Scenic.Math.Matrix.determinant/1","type":"function"},{"doc":"Divide a matrix by a scalar.This operation is implemented as a NIF for performance.Parameters:matrix: A matrixdivisor: A number (scalar) to divide byReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#div/2","title":"Scenic.Math.Matrix.div/2","type":"function"},{"doc":"Get a single value out of a binary matrix.Parameters:matrix: The source matrixx: the column to pull the data fromy: the row to pull the data fromReturns: A number","ref":"Scenic.Math.Matrix.html#get/3","title":"Scenic.Math.Matrix.get/3","type":"function"},{"doc":"Extract the 2D vector represented by the matrix.Parameters:matrix: The source matrixReturns: A vector_2","ref":"Scenic.Math.Matrix.html#get_xy/1","title":"Scenic.Math.Matrix.get_xy/1","type":"function"},{"doc":"The identity matrix","ref":"Scenic.Math.Matrix.html#identity/0","title":"Scenic.Math.Matrix.identity/0","type":"function"},{"doc":"Inverte a matrix.This operation is implemented as a NIF for performance.Parameters:matrix: A matrixReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#invert/1","title":"Scenic.Math.Matrix.invert/1","type":"function"},{"doc":"Multiply a list of matrices together.This operation is implemented as a NIF for performance.Parameters:matrix_list: A list of matricesReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#mul/1","title":"Scenic.Math.Matrix.mul/1","type":"function"},{"doc":"Multiply a matrix by another matrix or a scalar.This operation is implemented as a NIF for performance.Parameters:matrix: A matrixmultiplier: A number (scalar) or a matrix to multiply byReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#mul/2","title":"Scenic.Math.Matrix.mul/2","type":"function"},{"doc":"Project a vector by a matrix.This operation is implemented as a NIF for performance.Parameters:matrix: A matrixvector: The vector to projectReturns: The projected vector","ref":"Scenic.Math.Matrix.html#project_vector/2","title":"Scenic.Math.Matrix.project_vector/2","type":"function"},{"doc":"Project a list of vectors by a matrix.This operation is implemented as a NIF for performance.Parameters:matrix: A matrixvectors: The list of vectors to projectReturns: A list of projected vectors","ref":"Scenic.Math.Matrix.html#project_vectors/2","title":"Scenic.Math.Matrix.project_vectors/2","type":"function"},{"doc":"Put a single value into a binary matrix.Parameters:matrix: The source matrixx: the column to pull the data fromy: the row to pull the data fromv: the value to put into the matrix. Must be a number.Returns: A number","ref":"Scenic.Math.Matrix.html#put/4","title":"Scenic.Math.Matrix.put/4","type":"function"},{"doc":"Multiply a matrix by a rotation.Parameters:matrix: The incoming source matrixangle: the amount to rotate, in radians or nil (which does nothingReturns: A binary matrix","ref":"Scenic.Math.Matrix.html#rotate/2","title":"Scenic.Math.Matrix.rotate/2","type":"function"},{"doc":"Multiply a matrix by a scale factor.Parameters:matrix: The incoming source matrixscale: the amount to scale by. Can be either a number, a vector, or nil (which does nothing)Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#scale/2","title":"Scenic.Math.Matrix.scale/2","type":"function"},{"doc":"Subtract one matrix from another.This operation is implemented as a NIF for performance.Parameters:matrix_a: The first matrixmatrix_b: The second matrix, which is subtracted from the firstReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#sub/2","title":"Scenic.Math.Matrix.sub/2","type":"function"},{"doc":"Multiply a matrix by a translation.Parameters:matrix: The incoming source matrixvector_2: the vector to translate by or nil (which does nothing)Returns: A binary matrix","ref":"Scenic.Math.Matrix.html#translate/2","title":"Scenic.Math.Matrix.translate/2","type":"function"},{"doc":"Transpose a matrixThis operation is implemented as a NIF for performance.Parameters:matrix: A matrixReturns: The resulting matrix","ref":"Scenic.Math.Matrix.html#transpose/1","title":"Scenic.Math.Matrix.transpose/1","type":"function"},{"doc":"A matrix where all the values are 0","ref":"Scenic.Math.Matrix.html#zero/0","title":"Scenic.Math.Matrix.zero/0","type":"function"},{"doc":"Helper functions for working with matrices.The matrix format for the main Scenic.Math.Matrix functions is a 64 byte binary blob containing 16 4-byte floats. This is great for doing the math in code, but not so great for reading or understanding the values by a human.These functions transform more readable/writable formats into the binary blob and vice versa.","ref":"Scenic.Math.Matrix.Utils.html","title":"Scenic.Math.Matrix.Utils","type":"module"},{"doc":"Convert a readable format into a binary blob.Parameters:matrix_list - a list of 16 numbersReturns: A binary matrix blob","ref":"Scenic.Math.Matrix.Utils.html#to_binary/1","title":"Scenic.Math.Matrix.Utils.to_binary/1","type":"function"},{"doc":"Convert a binary matrix into a list of 16 numbers.Parameters:matrix - a binary matrixReturns: A list of 16 numbers","ref":"Scenic.Math.Matrix.Utils.html#to_list/1","title":"Scenic.Math.Matrix.Utils.to_list/1","type":"function"},{"doc":"A collection of functions to work with 2D vectors.2D vectors are always two numbers in a tuple.{3, 4} {3.5, 4.7}","ref":"Scenic.Math.Vector2.html","title":"Scenic.Math.Vector2","type":"module"},{"doc":"Add two vectors together.Parameters:vector2_a - the first vector to be addedvector2_b - the second vector to be addedReturns: A new vector which is the result of the additionExamplesiex&gt; Scenic.Math.Vector2.add({1.0, 5.0}, {3.0, 3.0}) {4.0, 8.0}","ref":"Scenic.Math.Vector2.html#add/2","title":"Scenic.Math.Vector2.add/2","type":"function"},{"doc":"Clamp a vector to the space between two other vectors.Parameters:vector2 - the vector to be clampedmin - the vector defining the minimum boundarymax - the vector defining the maximum boundaryReturns: A vector derived from the space between two other vectors","ref":"Scenic.Math.Vector2.html#clamp/3","title":"Scenic.Math.Vector2.clamp/3","type":"function"},{"doc":"Calculates the cross product of two vectors.Parameters:vector2_a - the first vectorvector2_b - the second vectorReturns: A number which is the result of the cross product","ref":"Scenic.Math.Vector2.html#cross/2","title":"Scenic.Math.Vector2.cross/2","type":"function"},{"doc":"","ref":"Scenic.Math.Vector2.html#distance/2","title":"Scenic.Math.Vector2.distance/2","type":"function"},{"doc":"","ref":"Scenic.Math.Vector2.html#distance_squared/2","title":"Scenic.Math.Vector2.distance_squared/2","type":"function"},{"doc":"Divide a vector by a scalar.Parameters:vector2 - the vectorscalar - the scalar valueReturns: A new vector which is the result of the division","ref":"Scenic.Math.Vector2.html#div/2","title":"Scenic.Math.Vector2.div/2","type":"function"},{"doc":"Calculates the dot product of two vectors.Parameters:vector2_a - the first vectorvector2_b - the second vectorReturns: A number which is the result of the dot product","ref":"Scenic.Math.Vector2.html#dot/2","title":"Scenic.Math.Vector2.dot/2","type":"function"},{"doc":"A vector that points straight down by 1.","ref":"Scenic.Math.Vector2.html#down/0","title":"Scenic.Math.Vector2.down/0","type":"function"},{"doc":"Determine if a vector is in the bounds (or clamp space) between two other vectors.Parameters:vector2 - the vector to be testedbounds - a vector defining the boundaryReturns: true or false","ref":"Scenic.Math.Vector2.html#in_bounds?/2","title":"Scenic.Math.Vector2.in_bounds?/2","type":"function"},{"doc":"Determine if a vector is in the bounds (or clamp space) between two other vectors.Parameters:vector2 - the vector to be testedmin - the vector defining the minimum boundarymax - the vector defining the maximum boundaryReturns: A vector derived from the space between two other vectors","ref":"Scenic.Math.Vector2.html#in_bounds?/3","title":"Scenic.Math.Vector2.in_bounds?/3","type":"function"},{"doc":"Invert a vector.Parameters:vector_2 - the vector to be invertedReturns: The inverted vectorExamplesiex&gt; Scenic.Math.Vector2.invert({2, 2}) {-2, -2}","ref":"Scenic.Math.Vector2.html#invert/1","title":"Scenic.Math.Vector2.invert/1","type":"function"},{"doc":"A vector that points left by 1.","ref":"Scenic.Math.Vector2.html#left/0","title":"Scenic.Math.Vector2.left/0","type":"function"},{"doc":"Calculates the length of the vector.This is slower than calculating the squared length.Parameters:vector2 - the vectorReturns: A number which is the length","ref":"Scenic.Math.Vector2.html#length/1","title":"Scenic.Math.Vector2.length/1","type":"function"},{"doc":"Calculates the squared length of the vector.This is faster than calculating the length if all you want to do is compare the lengths of two vectors against each other.Parameters:vector2 - the vectorReturns: A number which is the square of the length","ref":"Scenic.Math.Vector2.html#length_squared/1","title":"Scenic.Math.Vector2.length_squared/1","type":"function"},{"doc":"Calculate the lerp of two vectors.See This explanation for more info.Parameters:vector_a - the first vectorvector_b - the second vectort - the &quot;t&quot; value (see link above). Must be between 0 and 1.Returns: A vector, which is the result of the lerp.","ref":"Scenic.Math.Vector2.html#lerp/3","title":"Scenic.Math.Vector2.lerp/3","type":"function"},{"doc":"Find a new vector derived from the highest x and y from two given vectors.Parameters:vector2_a - the first vectorvector2_b - the second vectorReturns: A vector derived from the highest x and y from two given vectors","ref":"Scenic.Math.Vector2.html#max/2","title":"Scenic.Math.Vector2.max/2","type":"function"},{"doc":"Find a new vector derived from the lowest x and y from two given vectors.Parameters:vector2_a - the first vectorvector2_b - the second vectorReturns: A vector derived from the lowest x and y from two given vectors","ref":"Scenic.Math.Vector2.html#min/2","title":"Scenic.Math.Vector2.min/2","type":"function"},{"doc":"Multiply a vector by a scalar.Parameters:vector2 - the vectorscalar - the scalar valueReturns: A new vector which is the result of the multiplication","ref":"Scenic.Math.Vector2.html#mul/2","title":"Scenic.Math.Vector2.mul/2","type":"function"},{"doc":"Calculate the nlerp (normalized lerp) of two vectors.See This explanation for more info.Parameters:vector_a - the first vectorvector_b - the second vectort - the &quot;t&quot; value (see link above). Must be between 0 and 1.Returns: A vector, which is the result of the nlerp.","ref":"Scenic.Math.Vector2.html#nlerp/3","title":"Scenic.Math.Vector2.nlerp/3","type":"function"},{"doc":"Normalize a vector so it has the same angle, but a length of 1.Parameters:vector2 - the vectorReturns: A vector with the same angle as the original, but a length of 1","ref":"Scenic.Math.Vector2.html#normalize/1","title":"Scenic.Math.Vector2.normalize/1","type":"function"},{"doc":"A vector that points to {1,1}.","ref":"Scenic.Math.Vector2.html#one/0","title":"Scenic.Math.Vector2.one/0","type":"function"},{"doc":"Project a vector into the space defined by a matrixParameters:vector - the vector, or a list of vectorsmatrix - the matrixReturns: A projected vector (or list of vectors)","ref":"Scenic.Math.Vector2.html#project/2","title":"Scenic.Math.Vector2.project/2","type":"function"},{"doc":"A vector that points right by 1.","ref":"Scenic.Math.Vector2.html#right/0","title":"Scenic.Math.Vector2.right/0","type":"function"},{"doc":"Round the values of a vector to the nearest integers.Parameters:vector_2 - the vector to be roundedReturns: The integer vectorExamplesiex&gt; Scenic.Math.Vector2.round({1.2, 1.56}) {1, 2}","ref":"Scenic.Math.Vector2.html#round/1","title":"Scenic.Math.Vector2.round/1","type":"function"},{"doc":"Subtract one vector from another.Parameters:vector2_a - the first vectorvector2_b - the second vector, which will be subtracted from the firstReturns: A new vector which is the result of the subtraction","ref":"Scenic.Math.Vector2.html#sub/2","title":"Scenic.Math.Vector2.sub/2","type":"function"},{"doc":"Truncate the values of a vector into integers.Parameters:vector_2 - the vector to be truncatedReturns: The integer vectorExamplesiex&gt; Scenic.Math.Vector2.trunc({1.6, 1.2}) {1, 1}","ref":"Scenic.Math.Vector2.html#trunc/1","title":"Scenic.Math.Vector2.trunc/1","type":"function"},{"doc":"A vector that points to {1,0}.","ref":"Scenic.Math.Vector2.html#unity_x/0","title":"Scenic.Math.Vector2.unity_x/0","type":"function"},{"doc":"A vector that points to {0,1}.","ref":"Scenic.Math.Vector2.html#unity_y/0","title":"Scenic.Math.Vector2.unity_y/0","type":"function"},{"doc":"A vector that points straight up by 1.","ref":"Scenic.Math.Vector2.html#up/0","title":"Scenic.Math.Vector2.up/0","type":"function"},{"doc":"A vector that points to the origin.","ref":"Scenic.Math.Vector2.html#zero/0","title":"Scenic.Math.Vector2.zero/0","type":"function"},{"doc":"Helper module for configuring Drivers during startup.","ref":"Scenic.ViewPort.Config.html","title":"Scenic.ViewPort.Config","type":"module"},{"doc":"Test if the config for a ViewPort is valid or not.returns :ok or raises an error","ref":"Scenic.ViewPort.Config.html#valid!/1","title":"Scenic.ViewPort.Config.valid!/1","type":"function"},{"doc":"Test if the config for a ViewPort is valid or not.returns true or false","ref":"Scenic.ViewPort.Config.html#valid?/1","title":"Scenic.ViewPort.Config.valid?/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Config.html#t:t/0","title":"Scenic.ViewPort.Config.t/0","type":"type"},{"doc":"The main helpers and organizers for input.Resizing is temporarily not supported.","ref":"Scenic.ViewPort.Input.html","title":"Scenic.ViewPort.Input","type":"module"},{"doc":"","ref":"Scenic.ViewPort.Input.html#handle_cast/2","title":"Scenic.ViewPort.Input.handle_cast/2","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Input.html#t:class/0","title":"Scenic.ViewPort.Input.class/0","type":"type"},{"doc":"","ref":"Scenic.ViewPort.Input.html#t:t/0","title":"Scenic.ViewPort.Input.t/0","type":"type"},{"doc":"The Tables processes is a critical piece of Scenic. It caches the graphs that have been pushed by the various scenes.","ref":"Scenic.ViewPort.Tables.html","title":"Scenic.ViewPort.Tables","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Scenic.ViewPort.Tables.html#child_spec/1","title":"Scenic.ViewPort.Tables.child_spec/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#delete_graph/1","title":"Scenic.ViewPort.Tables.delete_graph/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#get_graph/1","title":"Scenic.ViewPort.Tables.get_graph/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#get_graph_refs/1","title":"Scenic.ViewPort.Tables.get_graph_refs/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#get_refs/1","title":"Scenic.ViewPort.Tables.get_refs/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#insert_graph/4","title":"Scenic.ViewPort.Tables.insert_graph/4","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#subscribe/2","title":"Scenic.ViewPort.Tables.subscribe/2","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Tables.html#unsubscribe/2","title":"Scenic.ViewPort.Tables.unsubscribe/2","type":"function"},{"doc":"Drivers make up the bottom layer of the Scenic architectural stack. They draw everything on the screen and originate the raw user input. In general, different hardware platforms will need different drivers.Drivers deal with graphs and do not know anything about scenes. This means that they are pretty generic. Drivers don't really understand that a component is a separate thing either, other than the fact that it has a graph that needs to be drawn.","ref":"Scenic.ViewPort.Driver.html","title":"Scenic.ViewPort.Driver","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Scenic.ViewPort.Driver.html#child_spec/1","title":"Scenic.ViewPort.Driver.child_spec/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#c:handle_call/3","title":"Scenic.ViewPort.Driver.handle_call/3","type":"callback"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#c:handle_cast/2","title":"Scenic.ViewPort.Driver.handle_cast/2","type":"callback"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#c:handle_info/2","title":"Scenic.ViewPort.Driver.handle_info/2","type":"callback"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Scenic.ViewPort.Driver.html#init/1","title":"Scenic.ViewPort.Driver.init/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#c:init/3","title":"Scenic.ViewPort.Driver.init/3","type":"callback"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#start/2","title":"Scenic.ViewPort.Driver.start/2","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#start_link/1","title":"Scenic.ViewPort.Driver.start_link/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Driver.html#stop/1","title":"Scenic.ViewPort.Driver.stop/1","type":"function"},{"doc":"Helper module for configuring ViewPorts during startup","ref":"Scenic.ViewPort.Driver.Config.html","title":"Scenic.ViewPort.Driver.Config","type":"module"},{"doc":"Test if the config for a driver is valid or not.returns :ok or raises an error","ref":"Scenic.ViewPort.Driver.Config.html#valid!/1","title":"Scenic.ViewPort.Driver.Config.valid!/1","type":"function"},{"doc":"Test if the config for a driver is valid or not.returns true or false","ref":"Scenic.ViewPort.Driver.Config.html#valid?/1","title":"Scenic.ViewPort.Driver.Config.valid?/1","type":"function"},{"doc":"Helper module for configuring ViewPorts during startup","ref":"Scenic.ViewPort.Driver.Info.html","title":"Scenic.ViewPort.Driver.Info","type":"module"},{"doc":"Base module for static asset caches.This module is not intended to be used directly. To access items in the static cache, refer to the modules for the type of data you are interested in.Asset ClassModuleFontsScenic.Cache.Static.FontFont MetricsScenic.Cache.Static.FontMetricsTextures (images in a fill)Scenic.Cache.Static.TextureRaw Pixel MapsScenic.Cache.Dynamic.TextureSome of the Cache support modules have movedOld ModuleNew ModuleScenic.Cache.HashScenic.Cache.Support.HashScenic.Cache.FileScenic.Cache.Support.FileScenic.Cache.SupervisorScenic.Cache.Support.SupervisorOverviewStatic assets such as fonts, images and more tend to be relatively large compared to other data. These assets are often used across multiple scenes and may need to be shared with multiple drivers.These assets also tend to have a significant load cost. Fonts need to be rendered. Images interpreted into their final binary form, etc.GoalsGiven this situation, the Cache module has multiple goals.Reuse - assets used by multiple scenes should only be stored in memory onceLoad Time- loading cost should only be paid onceCopy time - assets are stored in ETS, so they don't need to be copied as they are usedPub/Sub - Consumers of static assets (drivers...) should be notified when an asset is loaded or changed. They should not poll the system.Security - Static assets can become an attack vector. Helper modules are provided to assist in verifying these files.ScopeWhen an asset is loaded into the cache, it is assigned a scope. The scope is used to determine how long to hold the asset in memory before it is unloaded. Scope is either the atom :global, or a pid.The typical flow is that a scene will load an asset into the cache. A scope is automatically defined that tracks the asset against the pid of the scene that loaded it. When the scene is closed, the scope becomes empty and the asset is unloaded.If, while that scene is loaded, another scene (or any process...) attempts to load the same asset into the cache, a second scope is added and the duplicate load is skipped. When the first scene closes, the asset stays in memory as long as the second scope remains valid.When a scene closes, it's scope stays valid for a short time in order to give the next scene a chance to load its assets (or claim a scope) and possibly re-use the already loaded assets.This is also useful in the event of a scene crashing and being restarted. The delay in unloading the scope means that the replacement scene will use already loaded assets instead of loading the same files again for no real benefit.When you load assets you can alternately provide your own scope instead of taking the default, which is your processes pid. If you provide :global, then the asset will stay in memory until you explicitly release it.KeysAt its simplest, accessing the cache is a key-value store. When inserting assets via the main Cache module, you can supply any term you want as the key. However, in most cases this is not recommended.The key for an item in the cache should almost always be a SHA hash of the item itself.Why? Read below...The main exception is dynamic assets, such as video frames coming from a camera.SecurityA lesson learned the hard way is that static assets (fonts, images, etc.) that your app loads out of storage can easily become attack vectors.These formats are complicated! There is no guarantee (on any system) that a malformed asset will not cause an error in the C code that interprets it. Again - these are complicated and the renderers need to be fast...The solution is to compute a SHA hash of these files during build-time of your and to store the result in your applications code itself. Then during run time, you compare then pre-computed hash against the run-time of the asset being loaded.Please take advantage of the helper modules Cache.File, Cache.Term, and Cache.Hash to do this for you. These modules load files and insert them into the cache while checking a precomputed hash.These scheme is much stronger when the application code itself is also signed and verified, but that is an exercise for the packaging tools.Full Example:defmodule MyApp.MyScene do use Scenic.Scene import Scenic.Primitives # build the path to the static asset file (compile time) @asset_path :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/images/asset.jpg&quot;) # pre-compute the hash (compile time) @asset_hash Scenic.Cache.Hash.file!( @asset_path, :sha ) # build a graph that uses the asset (compile time) @graph Scenic.Graph.build() |&gt; rect( {100, 100}, fill: {:image, @asset_hash} ) def init( _, _ ) do # load the asset into the cache (run time) Scenic.Cache.Static.Texture.load(@asset_path, @asset_hash) {:ok, :some_state, push: @graph} end endWhen assets are loaded this way, the @asset_hash term is also used as the key in the cache. This has the additional benefit of allowing you to pre-compute the graph itself, using the correct keys for the correct assets.Pub/SubDrivers (or any process...) listen to the Cache via a simple pub/sub api.Because the graph, may be computed during compile time and pushed at some other time than the assets are loaded, the drivers need to know when the assets become available.Whenever any asset is loaded into the cache, messages are sent to any subscribing processes along with the affected keys. This allows them to react in a loosely-coupled way to how the assets are managed in your scene.","ref":"Scenic.Cache.Base.html","title":"Scenic.Cache.Base","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Scenic.Cache.Base.html#child_spec/1","title":"Scenic.Cache.Base.child_spec/1","type":"function"},{"doc":"Add a scope to an existing asset in the cache.Claiming an asset in the cache adds a lifetime scope to it. This is essentially a refcount that is bound to a pid.Returns true if the item is loaded and the scope is added. Returns false if the asset is not loaded into the cache.","ref":"Scenic.Cache.Base.html#claim/3","title":"Scenic.Cache.Base.claim/3","type":"function"},{"doc":"Tests if a key is claimed by the scope.Pass in the service, hash, and scope.Returns true or false.","ref":"Scenic.Cache.Base.html#claimed?/3","title":"Scenic.Cache.Base.claimed?/3","type":"function"},{"doc":"Retrieve an item from the cache and wrap it in an {:ok, _} tuple.This function ideal if you need to pattern match on the result.","ref":"Scenic.Cache.Base.html#fetch/2","title":"Scenic.Cache.Base.fetch/2","type":"function"},{"doc":"Retrieve an item from the Cache.If there is no item in the Cache that corresponds to the hash the function will return either nil or the supplied default value","ref":"Scenic.Cache.Base.html#get/3","title":"Scenic.Cache.Base.get/3","type":"function"},{"doc":"Retrieve an item from the Cache and raise an error if it doesn't exist.If there is no item in the Cache that corresponds to the hash the function will raise an error.","ref":"Scenic.Cache.Base.html#get!/2","title":"Scenic.Cache.Base.get!/2","type":"function"},{"doc":"Returns a list of asset keys claimed by the given scope.Pass in the service and a scope.Returns a list of claimed keys.","ref":"Scenic.Cache.Base.html#keys/2","title":"Scenic.Cache.Base.keys/2","type":"function"},{"doc":"","ref":"Scenic.Cache.Base.html#c:load/3","title":"Scenic.Cache.Base.load/3","type":"callback"},{"doc":"","ref":"Scenic.Cache.Base.html#c:load!/3","title":"Scenic.Cache.Base.load!/3","type":"callback"},{"doc":"Tests if a key is claimed by any scope.Pass in the service and a hash.Returns true or false.","ref":"Scenic.Cache.Base.html#member?/2","title":"Scenic.Cache.Base.member?/2","type":"function"},{"doc":"Insert an item into the Cache. If it is already in the cache, then it overwrites the data {:ok, hash}Parameters:key - term to use as the retrieval key. Typically a hash of the data itself.data - term to use as the stored datascope - Optional scope to track the lifetime of this asset against. Can be :global but is usually nil, which defaults to the pid of the calling process.Examplesiex&gt; Scenic.Cache.get(&quot;test_key&quot;) nil iex&gt; :ets.insert(:scenic_cache_key_table, {&quot;test_key&quot;, 1, :test_data}) ...&gt; true ...&gt; Scenic.Cache.get(&quot;test_key&quot;) :test_data","ref":"Scenic.Cache.Base.html#put/4","title":"Scenic.Cache.Base.put/4","type":"function"},{"doc":"Release a scope claim on an asset.Usually the scope is released automatically when a process shuts down. However if you want to manually clean up, or unload an asset with the :global scope, then you should use release.Parameters:key - the key to release.options - options listOptions:scope - set to :global to release the global scope.delay - add a delay of n milliseconds before releasing. This allows starting processes a chance to claim a scope before it is unloaded.","ref":"Scenic.Cache.Base.html#release/3","title":"Scenic.Cache.Base.release/3","type":"function"},{"doc":"Get the current status of an asset in the cache.This is used to test if the current process has claimed a scope on an asset.Pass in the service, hash, and a scope.Returns one of:{:ok, hash} # it is claimed by the given scope {:ok, :global} # it is NOT claimed by the given scope, but is :global {:error, :not_found} # it is not in the cache at all","ref":"Scenic.Cache.Base.html#status/3","title":"Scenic.Cache.Base.status/3","type":"function"},{"doc":"Subscribe the calling process to cache messages.Parameterssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message typeshash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keys","ref":"Scenic.Cache.Base.html#subscribe/3","title":"Scenic.Cache.Base.subscribe/3","type":"function"},{"doc":"Unsubscribe the calling process from cache messages.Parameterssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message typeshash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keys","ref":"Scenic.Cache.Base.html#unsubscribe/3","title":"Scenic.Cache.Base.unsubscribe/3","type":"function"},{"doc":"","ref":"Scenic.Cache.Base.html#t:hash/0","title":"Scenic.Cache.Base.hash/0","type":"type"},{"doc":"","ref":"Scenic.Cache.Base.html#t:sub_types/0","title":"Scenic.Cache.Base.sub_types/0","type":"type"},{"doc":"In memory cache for static dynamic Image assets.In graphics-speak, an image that is being drawn to the screen is a &quot;Texture&quot;.Unlike Scenic.Cache.Static.Texture, this module assumes that the pixels to be rendered in the image are being generated on the at runtime and change, perhaps rapidly.The primary example is capturing an image off of a camera. This data is generated on the fly and needs to be presented to the video card with as little encoding being done as possible.So instead of using a hash of the data as a key (which doesn't make sense given that the data is changing...), you pick a unique string to represent the stream of data. It is up to you to make sure the names you choose are unique in your app.The only data the Scenic.Cache.Dynamic.Texture accepts is a raw pixel map. Please use the Scenic.Utilities.Texture module to help build and manage these data sets.GoalsGiven this situation, the dynamic Cache module has multiple goals.Reuse - assets used by multiple scenes should only be stored in memory onceCopy time - assets are stored in ETS, so they don't need to be copied as they are usedPub/Sub - Consumers of static assets (drivers...) should be notified when an asset is loaded or changed. They should not poll the system.ScopeWhen a texture term is loaded into the cache, it is assigned a scope. The scope is used to determine how long to hold the asset in memory before it is unloaded. Scope is either the atom :global, or a pid.The typical flow is that a scene will load a font into the cache. A scope is automatically defined that tracks the asset against the pid of the scene that loaded it. When the scene is closed, the scope becomes empty and the asset is unloaded.If, while that scene is loaded, another scene (or any process...) attempts to load the same asset into the cache, a second scope is added and the duplicate load is skipped. When the first scene closes, the asset stays in memory as long as the second scope remains valid.When a scene closes, it's scope stays valid for a short time in order to give the next scene a chance to load its assets (or claim a scope) and possibly re-use the already loaded assets.This is also useful in the event of a scene crashing and being restarted. The delay in unloading the scope means that the replacement scene will use already loaded assets instead of loading the same files again for no real benefit.When you load assets you can alternately provide your own scope instead of taking the default, which is your processes pid. If you provide :global, then the asset will stay in memory until you explicitly release it.Pub/SubDrivers (or any process...) listen to the font Cache via a simple pub/sub api.Because the graph, may be computed during compile time and pushed at some other time than the assets are loaded, the drivers need to know when the assets become available.Whenever any asset is loaded into the cache, messages are sent to any subscribing processes along with the affected keys. This allows them to react in a loosely-coupled way to how the assets are managed in your scene.","ref":"Scenic.Cache.Dynamic.Texture.html","title":"Scenic.Cache.Dynamic.Texture","type":"module"},{"doc":"Add a scope to an existing texture in the cache.Claiming an asset in the cache adds a lifetime scope to it. This is essentially a refcount that is bound to a pid.Returns true if the item is loaded and the scope is added. Returns false if the asset is not loaded into the cache.","ref":"Scenic.Cache.Dynamic.Texture.html#claim/2","title":"Scenic.Cache.Dynamic.Texture.claim/2","type":"function"},{"doc":"Tests if a key is claimed by the given scope.","ref":"Scenic.Cache.Dynamic.Texture.html#claimed?/2","title":"Scenic.Cache.Dynamic.Texture.claimed?/2","type":"function"},{"doc":"Retrieve a texture from the cache and wrap it in an {:ok, _} tuple.This function ideal if you need to pattern match on the result.Examplesiex&gt; Elixir.Scenic.Cache.Dynamic.Texture.fetch(&quot;missing_hash&quot;) ...&gt; {:error, :not_found} iex&gt; Elixir.Scenic.Cache.Dynamic.Texture.fetch(&quot;valid_hash&quot;) ...&gt; {:ok, :test_data}","ref":"Scenic.Cache.Dynamic.Texture.html#fetch/1","title":"Scenic.Cache.Dynamic.Texture.fetch/1","type":"function"},{"doc":"Retrieve a texture from the Cache.If there is no item in the Cache that corresponds to the hash the function will return either nil or the supplied default valueExamplesiex&gt; Elixir.Scenic.Cache.Dynamic.Texture.get(&quot;missing_hash&quot;) nil ...&gt; Elixir.Scenic.Cache.Dynamic.Texture.fetch(&quot;valid_hash&quot;) {:ok, :test_data}","ref":"Scenic.Cache.Dynamic.Texture.html#get/2","title":"Scenic.Cache.Dynamic.Texture.get/2","type":"function"},{"doc":"Retrieve a texture from the Cache and raise an error if it doesn't exist.If there is no item in the Cache that corresponds to the hash the function will raise an error.","ref":"Scenic.Cache.Dynamic.Texture.html#get!/1","title":"Scenic.Cache.Dynamic.Texture.get!/1","type":"function"},{"doc":"Returns a list of keys claimed by the given scope.","ref":"Scenic.Cache.Dynamic.Texture.html#keys/1","title":"Scenic.Cache.Dynamic.Texture.keys/1","type":"function"},{"doc":"Tests if a key is claimed by any scope.","ref":"Scenic.Cache.Dynamic.Texture.html#member?/1","title":"Scenic.Cache.Dynamic.Texture.member?/1","type":"function"},{"doc":"Insert texture into the Cache.If the texture is already in the cache, its data is overwritten.Parameters:hash - term to use as the retrieval key. Typically a hash of the data itself. It will be required to be a hash of the data in the future.data - term to use as the stored datascope - Optional scope to track the lifetime of this asset against. Can be :global but is usually nil, which defaults to the pid of the calling process.Returns: {:ok, hash}","ref":"Scenic.Cache.Dynamic.Texture.html#put/3","title":"Scenic.Cache.Dynamic.Texture.put/3","type":"function"},{"doc":"Insert a new texture into the Cache.If the texture is already in the cache, put_new does nothing and just returns {:ok, hash}Parameters:hash - term to use as the retrieval key. Typically a hash of the data itself. It will be required to be a hash of the data in the future.data - term to use as the stored datascope - Optional scope to track the lifetime of this asset against. Can be :global but is usually nil, which defaults to the pid of the calling process.Returns: {:ok, hash}","ref":"Scenic.Cache.Dynamic.Texture.html#put_new/3","title":"Scenic.Cache.Dynamic.Texture.put_new/3","type":"function"},{"doc":"Release a scope claim on an texture.Usually the scope is released automatically when a process shuts down. However if you want to manually clean up, or unload an asset with the :global scope, then you should use release.Parameters:key - the key to release.options - options listOptions:scope - set to :global to release the global scope.delay - add a delay of n milliseconds before releasing. This allows starting processes a chance to claim a scope before it is unloaded.","ref":"Scenic.Cache.Dynamic.Texture.html#release/2","title":"Scenic.Cache.Dynamic.Texture.release/2","type":"function"},{"doc":"Get the current status of a texture in the cache.This is used to test if the current process has claimed a scope on an asset.","ref":"Scenic.Cache.Dynamic.Texture.html#status/2","title":"Scenic.Cache.Dynamic.Texture.status/2","type":"function"},{"doc":"Subscribe the calling process to cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Dynamic.Texture.html#subscribe/2","title":"Scenic.Cache.Dynamic.Texture.subscribe/2","type":"function"},{"doc":"Unsubscribe the calling process from cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Dynamic.Texture.html#unsubscribe/2","title":"Scenic.Cache.Dynamic.Texture.unsubscribe/2","type":"function"},{"doc":"This module is deprecated and has moved Scenic.Cache.Support.HashPlease adjust accordingly as this module will be removed in a future version","ref":"Scenic.Cache.Hash.html","title":"Scenic.Cache.Hash","type":"module"},{"doc":"See Scenic.Cache.Support.Hash.binary/2.","ref":"Scenic.Cache.Hash.html#binary/2","title":"Scenic.Cache.Hash.binary/2","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.binary!/2.","ref":"Scenic.Cache.Hash.html#binary!/2","title":"Scenic.Cache.Hash.binary!/2","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.file/2.","ref":"Scenic.Cache.Hash.html#file/2","title":"Scenic.Cache.Hash.file/2","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.file!/2.","ref":"Scenic.Cache.Hash.html#file!/2","title":"Scenic.Cache.Hash.file!/2","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.verify/3.","ref":"Scenic.Cache.Hash.html#verify/3","title":"Scenic.Cache.Hash.verify/3","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.verify!/3.","ref":"Scenic.Cache.Hash.html#verify!/3","title":"Scenic.Cache.Hash.verify!/3","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.verify_file/3.","ref":"Scenic.Cache.Hash.html#verify_file/3","title":"Scenic.Cache.Hash.verify_file/3","type":"function"},{"doc":"See Scenic.Cache.Support.Hash.verify_file!/3.","ref":"Scenic.Cache.Hash.html#verify_file!/3","title":"Scenic.Cache.Hash.verify_file!/3","type":"function"},{"doc":"In memory cache for static font assets.Assets such as fonts tend to be relatively large compared to other data. These assets are often used across multiple scenes and may need to be shared with multiple drivers.These assets also tend to have a significant load cost. Fonts need to be rendered. Images interpreted into their final binary form, etc.GoalsGiven this situation, the Cache module has multiple goals.Reuse - assets used by multiple scenes should only be stored in memory onceLoad Time- loading cost should only be paid onceCopy time - assets are stored in ETS, so they don't need to be copied as they are usedPub/Sub - Consumers of static assets (drivers...) should be notified when an asset is loaded or changed. They should not poll the system.Security - Base assets can become an attack vector. Helper modules are provided to assist in verifying these files.LoadingNote that loading a font is slightly different than the other asset types. With the other assets you provide an explicit path to the file and a cache. For fonts, you provide a path to a single folder that you put all your fonts in. Something like &quot;/static/fonts&quot;, then the font file itself should have the :sha256 of it's content appended to its name.The reason this is set up like this is that you reference the fonts indirectly in your graph. The graph directly references a font_metrics file by hash. This is so that you can measure and position things without actually loading the font. The metrics file already contains the :sha256 of the font itself, which is then loaded by the driver.See the Custom Fonts guide for more information.ScopeWhen a font is loaded into the cache, it is assigned a scope. The scope is used to determine how long to hold the asset in memory before it is unloaded. Scope is either the atom :global, or a pid.The typical flow is that a scene will load a font into the cache. A scope is automatically defined that tracks the asset against the pid of the scene that loaded it. When the scene is closed, the scope becomes empty and the asset is unloaded.If, while that scene is loaded, another scene (or any process...) attempts to load the same asset into the cache, a second scope is added and the duplicate load is skipped. When the first scene closes, the asset stays in memory as long as the second scope remains valid.When a scene closes, it's scope stays valid for a short time in order to give the next scene a chance to load its assets (or claim a scope) and possibly re-use the already loaded assets.This is also useful in the event of a scene crashing and being restarted. The delay in unloading the scope means that the replacement scene will use already loaded assets instead of loading the same files again for no real benefit.When you load assets you can alternately provide your own scope instead of taking the default, which is your processes pid. If you provide :global, then the asset will stay in memory until you explicitly release it.HashesAt its simplest, accessing the cache is a key-value store. This cache is meant to be static in nature, so the key is be a hash of the data.Why? Read below...SecurityA lesson learned the hard way is that static assets (fonts, images, etc.) that your app loads out of storage can easily become attack vectors.These formats are complicated! There is no guarantee (on any system) that a malformed asset will not cause an error in the C code that interprets it. Again - these are complicated and the renderer needs to be fast...The solution is to compute a SHA hash of these files during build-time of your and to store the result in your applications code itself. Then during run time, you compare then pre-computed hash against the run-time of the asset being loaded.Please take advantage of the helper modules Cache.Support.File and Cache.Support.Hash to build the hashes. These scheme is much stronger when the application code itself is also signed and verified, but that is an exercise for the packaging tools.Full Example:defmodule MyApp.MyScene do use Scenic.Scene import Scenic.Primitives # build the path to the static asset file (compile time) @font_folder :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/fonts&quot;) @font_hash &quot;0IXAWqFTtjn6MKSgQOzxUgxNKGrmyhqz1e2d90PVHck&quot; def init( _, _ ) do # load the asset into the cache (run time) Scenic.Cache.Static.Font.load(@font_folder, @font_hash) {:ok, :some_state} end endPub/SubDrivers (or any process...) listen to the font Cache via a simple pub/sub api.Because the graph, may be computed during compile time and pushed at some other time than the assets are loaded, the drivers need to know when the assets become available.Whenever any asset is loaded into the cache, messages are sent to any subscribing processes along with the affected keys. This allows them to react in a loosely-coupled way to how the assets are managed in your scene.","ref":"Scenic.Cache.Static.Font.html","title":"Scenic.Cache.Static.Font","type":"module"},{"doc":"Add a scope to an existing font in the cache.Claiming an asset in the cache adds a lifetime scope to it. This is essentially a refcount that is bound to a pid.Returns true if the item is loaded and the scope is added. Returns false if the asset is not loaded into the cache.","ref":"Scenic.Cache.Static.Font.html#claim/2","title":"Scenic.Cache.Static.Font.claim/2","type":"function"},{"doc":"Tests if a key is claimed by the given scope.","ref":"Scenic.Cache.Static.Font.html#claimed?/2","title":"Scenic.Cache.Static.Font.claimed?/2","type":"function"},{"doc":"Retrieve a font from the cache and wrap it in an {:ok, _} tuple.This function ideal if you need to pattern match on the result.Examplesiex&gt; Elixir.Scenic.Cache.Static.Font.fetch(&quot;missing_hash&quot;) ...&gt; {:error, :not_found} iex&gt; Elixir.Scenic.Cache.Static.Font.fetch(&quot;valid_hash&quot;) ...&gt; {:ok, :test_data}","ref":"Scenic.Cache.Static.Font.html#fetch/1","title":"Scenic.Cache.Static.Font.fetch/1","type":"function"},{"doc":"Retrieve a font from the Cache.If there is no item in the Cache that corresponds to the hash the function will return either nil or the supplied default valueExamplesiex&gt; Elixir.Scenic.Cache.Static.Font.get(&quot;missing_hash&quot;) nil ...&gt; Elixir.Scenic.Cache.Static.Font.fetch(&quot;valid_hash&quot;) {:ok, :test_data}","ref":"Scenic.Cache.Static.Font.html#get/2","title":"Scenic.Cache.Static.Font.get/2","type":"function"},{"doc":"Retrieve a font from the Cache and raise an error if it doesn't exist.If there is no item in the Cache that corresponds to the hash the function will raise an error.","ref":"Scenic.Cache.Static.Font.html#get!/1","title":"Scenic.Cache.Static.Font.get!/1","type":"function"},{"doc":"Returns a list of keys claimed by the given scope.","ref":"Scenic.Cache.Static.Font.html#keys/1","title":"Scenic.Cache.Static.Font.keys/1","type":"function"},{"doc":"Callback implementation for Scenic.Cache.Base.load/3.","ref":"Scenic.Cache.Static.Font.html#load/3","title":"Scenic.Cache.Static.Font.load/3","type":"function"},{"doc":"Callback implementation for Scenic.Cache.Base.load!/3.","ref":"Scenic.Cache.Static.Font.html#load!/3","title":"Scenic.Cache.Static.Font.load!/3","type":"function"},{"doc":"Tests if a key is claimed by any scope.","ref":"Scenic.Cache.Static.Font.html#member?/1","title":"Scenic.Cache.Static.Font.member?/1","type":"function"},{"doc":"Insert a new font into the Cache.If the font is already in the cache, put_new does nothing and just returns {:ok, hash}Parameters:hash - term to use as the retrieval key. Typically a hash of the data itself. It will be required to be a hash of the data in the future.data - term to use as the stored datascope - Optional scope to track the lifetime of this asset against. Can be :global but is usually nil, which defaults to the pid of the calling process.Returns: {:ok, hash}","ref":"Scenic.Cache.Static.Font.html#put_new/3","title":"Scenic.Cache.Static.Font.put_new/3","type":"function"},{"doc":"Release a scope claim on an font.Usually the scope is released automatically when a process shuts down. However if you want to manually clean up, or unload an asset with the :global scope, then you should use release.Parameters:key - the key to release.options - options listOptions:scope - set to :global to release the global scope.delay - add a delay of n milliseconds before releasing. This allows starting processes a chance to claim a scope before it is unloaded.","ref":"Scenic.Cache.Static.Font.html#release/2","title":"Scenic.Cache.Static.Font.release/2","type":"function"},{"doc":"Get the current status of a font in the cache.This is used to test if the current process has claimed a scope on an asset.","ref":"Scenic.Cache.Static.Font.html#status/2","title":"Scenic.Cache.Static.Font.status/2","type":"function"},{"doc":"Subscribe the calling process to cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Static.Font.html#subscribe/2","title":"Scenic.Cache.Static.Font.subscribe/2","type":"function"},{"doc":"Unsubscribe the calling process from cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Static.Font.html#unsubscribe/2","title":"Scenic.Cache.Static.Font.unsubscribe/2","type":"function"},{"doc":"In memory cache for static font_metrics assets.Assets such as font_metrics tend to be relatively large compared to other data. These assets are often used across multiple scenes and may need to be shared with multiple drivers.GoalsGiven this situation, the Cache module has multiple goals.Reuse - assets used by multiple scenes should only be stored in memory onceLoad Time- loading cost should only be paid onceCopy time - assets are stored in ETS, so they don't need to be copied as they are usedPub/Sub - Consumers of static assets (drivers...) should be notified when an asset is loaded or changed. They should not poll the system.Security - Base assets can become an attack vector. Helper modules are provided to assist in verifying these files.ScopeWhen a font_metrics term is loaded into the cache, it is assigned a scope. The scope is used to determine how long to hold the asset in memory before it is unloaded. Scope is either the atom :global, or a pid.The typical flow is that a scene will load a font into the cache. A scope is automatically defined that tracks the asset against the pid of the scene that loaded it. When the scene is closed, the scope becomes empty and the asset is unloaded.If, while that scene is loaded, another scene (or any process...) attempts to load the same asset into the cache, a second scope is added and the duplicate load is skipped. When the first scene closes, the asset stays in memory as long as the second scope remains valid.When a scene closes, it's scope stays valid for a short time in order to give the next scene a chance to load its assets (or claim a scope) and possibly re-use the already loaded assets.This is also useful in the event of a scene crashing and being restarted. The delay in unloading the scope means that the replacement scene will use already loaded assets instead of loading the same files again for no real benefit.When you load assets you can alternately provide your own scope instead of taking the default, which is your processes pid. If you provide :global, then the asset will stay in memory until you explicitly release it.HashesAt its simplest, accessing the cache is a key-value store. This cache is meant to be static in nature, so the key is be a hash of the data.Why? Read below...SecurityA lesson learned the hard way is that static assets (fonts, images, etc.) that your app loads out of storage can easily become attack vectors.These formats are complicated! There is no guarantee (on any system) that a malformed asset will not cause an error in the C code that interprets it. Again - these are complicated and the renderer needs to be fast...The solution is to compute a SHA hash of these files during build-time of your and to store the result in your applications code itself. Then during run time, you compare then pre-computed hash against the run-time of the asset being loaded.Please take advantage of the helper modules Cache.Support.File and Cache.Support.Hash to build the hashes. These scheme is much stronger when the application code itself is also signed and verified, but that is an exercise for the packaging tools.Full Example:defmodule MyApp.MyScene do use Scenic.Scene import Scenic.Primitives # build the path to the static asset file (compile time) @font_metrics :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/fonts/my_font.ttf.metrics&quot;) @font_metrics_hash Scenic.Cache.Hash.file!( @font_metrics, :sha ) def init( _, _ ) do # load the asset into the cache (run time) Scenic.Cache.Static.FontMetrics.load(@font_metrics, @font_metrics_hash) {:ok, :some_state} end endPub/SubDrivers (or any process...) listen to the font Cache via a simple pub/sub api.Because the graph, may be computed during compile time and pushed at some other time than the assets are loaded, the drivers need to know when the assets become available.Whenever any asset is loaded into the cache, messages are sent to any subscribing processes along with the affected keys. This allows them to react in a loosely-coupled way to how the assets are managed in your scene.","ref":"Scenic.Cache.Static.FontMetrics.html","title":"Scenic.Cache.Static.FontMetrics","type":"module"},{"doc":"Add a scope to an existing font_metrics in the cache.Claiming an asset in the cache adds a lifetime scope to it. This is essentially a refcount that is bound to a pid.Returns true if the item is loaded and the scope is added. Returns false if the asset is not loaded into the cache.","ref":"Scenic.Cache.Static.FontMetrics.html#claim/2","title":"Scenic.Cache.Static.FontMetrics.claim/2","type":"function"},{"doc":"Tests if a key is claimed by the given scope.","ref":"Scenic.Cache.Static.FontMetrics.html#claimed?/2","title":"Scenic.Cache.Static.FontMetrics.claimed?/2","type":"function"},{"doc":"Retrieve a fontmetrics from the cache and wrap it in an `{:ok, }` tuple.This function ideal if you need to pattern match on the result.Examplesiex&gt; Elixir.Scenic.Cache.Static.FontMetrics.fetch(&quot;missing_hash&quot;) ...&gt; {:error, :not_found} iex&gt; Elixir.Scenic.Cache.Static.FontMetrics.fetch(&quot;valid_hash&quot;) ...&gt; {:ok, :test_data}","ref":"Scenic.Cache.Static.FontMetrics.html#fetch/1","title":"Scenic.Cache.Static.FontMetrics.fetch/1","type":"function"},{"doc":"Retrieve a font_metrics from the Cache.If there is no item in the Cache that corresponds to the hash the function will return either nil or the supplied default valueExamplesiex&gt; Elixir.Scenic.Cache.Static.FontMetrics.get(&quot;missing_hash&quot;) nil ...&gt; Elixir.Scenic.Cache.Static.FontMetrics.fetch(&quot;valid_hash&quot;) {:ok, :test_data}","ref":"Scenic.Cache.Static.FontMetrics.html#get/2","title":"Scenic.Cache.Static.FontMetrics.get/2","type":"function"},{"doc":"Retrieve a font_metrics from the Cache and raise an error if it doesn't exist.If there is no item in the Cache that corresponds to the hash the function will raise an error.","ref":"Scenic.Cache.Static.FontMetrics.html#get!/1","title":"Scenic.Cache.Static.FontMetrics.get!/1","type":"function"},{"doc":"Returns a list of keys claimed by the given scope.","ref":"Scenic.Cache.Static.FontMetrics.html#keys/1","title":"Scenic.Cache.Static.FontMetrics.keys/1","type":"function"},{"doc":"Callback implementation for Scenic.Cache.Base.load/3.","ref":"Scenic.Cache.Static.FontMetrics.html#load/3","title":"Scenic.Cache.Static.FontMetrics.load/3","type":"function"},{"doc":"Callback implementation for Scenic.Cache.Base.load!/3.","ref":"Scenic.Cache.Static.FontMetrics.html#load!/3","title":"Scenic.Cache.Static.FontMetrics.load!/3","type":"function"},{"doc":"Tests if a key is claimed by any scope.","ref":"Scenic.Cache.Static.FontMetrics.html#member?/1","title":"Scenic.Cache.Static.FontMetrics.member?/1","type":"function"},{"doc":"Insert a new font_metrics into the Cache.If the font_metrics is already in the cache, put_new does nothing and just returns {:ok, hash}Parameters:hash - term to use as the retrieval key. Typically a hash of the data itself. It will be required to be a hash of the data in the future.data - term to use as the stored datascope - Optional scope to track the lifetime of this asset against. Can be :global but is usually nil, which defaults to the pid of the calling process.Returns: {:ok, hash}","ref":"Scenic.Cache.Static.FontMetrics.html#put_new/3","title":"Scenic.Cache.Static.FontMetrics.put_new/3","type":"function"},{"doc":"Release a scope claim on an font_metrics.Usually the scope is released automatically when a process shuts down. However if you want to manually clean up, or unload an asset with the :global scope, then you should use release.Parameters:key - the key to release.options - options listOptions:scope - set to :global to release the global scope.delay - add a delay of n milliseconds before releasing. This allows starting processes a chance to claim a scope before it is unloaded.","ref":"Scenic.Cache.Static.FontMetrics.html#release/2","title":"Scenic.Cache.Static.FontMetrics.release/2","type":"function"},{"doc":"Get the current status of a font_metrics in the cache.This is used to test if the current process has claimed a scope on an asset.","ref":"Scenic.Cache.Static.FontMetrics.html#status/2","title":"Scenic.Cache.Static.FontMetrics.status/2","type":"function"},{"doc":"Subscribe the calling process to cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Static.FontMetrics.html#subscribe/2","title":"Scenic.Cache.Static.FontMetrics.subscribe/2","type":"function"},{"doc":"Unsubscribe the calling process from cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Static.FontMetrics.html#unsubscribe/2","title":"Scenic.Cache.Static.FontMetrics.unsubscribe/2","type":"function"},{"doc":"","ref":"Scenic.Cache.Static.FontMetrics.html#t:sys_fonts/0","title":"Scenic.Cache.Static.FontMetrics.sys_fonts/0","type":"type"},{"doc":"In memory cache for static static Image assets.In graphics-speak, an image that is being drawn to the screen is a &quot;Texture&quot;. It doesn't matter how the image was stored on the disk (jpg, png, etc.), they all end up as textures presented to the graphics card.Assets such as textures tend to be relatively large compared to other data. These assets are often used across multiple scenes and may need to be shared with multiple drivers.GoalsGiven this situation, the Cache module has multiple goals.Reuse - assets used by multiple scenes should only be stored in memory onceLoad Time- loading cost should only be paid onceCopy time - assets are stored in ETS, so they don't need to be copied as they are usedPub/Sub - Consumers of static assets (drivers...) should be notified when an asset is loaded or changed. They should not poll the system.Security - Base assets can become an attack vector. Helper modules are provided to assist in verifying these files.ScopeWhen a texture term is loaded into the cache, it is assigned a scope. The scope is used to determine how long to hold the asset in memory before it is unloaded. Scope is either the atom :global, or a pid.The typical flow is that a scene will load a font into the cache. A scope is automatically defined that tracks the asset against the pid of the scene that loaded it. When the scene is closed, the scope becomes empty and the asset is unloaded.If, while that scene is loaded, another scene (or any process...) attempts to load the same asset into the cache, a second scope is added and the duplicate load is skipped. When the first scene closes, the asset stays in memory as long as the second scope remains valid.When a scene closes, it's scope stays valid for a short time in order to give the next scene a chance to load its assets (or claim a scope) and possibly re-use the already loaded assets.This is also useful in the event of a scene crashing and being restarted. The delay in unloading the scope means that the replacement scene will use already loaded assets instead of loading the same files again for no real benefit.When you load assets you can alternately provide your own scope instead of taking the default, which is your processes pid. If you provide :global, then the asset will stay in memory until you explicitly release it.HashesAt its simplest, accessing the cache is a key-value store. This cache is meant to be static in nature, so the key is be a hash of the data.Why? Read below...SecurityA lesson learned the hard way is that static assets (fonts, images, etc.) that your app loads out of storage can easily become attack vectors.These formats are complicated! There is no guarantee (on any system) that a malformed asset will not cause an error in the C code that interprets it. Again - these are complicated and the renderer needs to be fast...The solution is to compute a SHA hash of these files during build-time of your and to store the result in your applications code itself. Then during run time, you compare then pre-computed hash against the run-time of the asset being loaded.Please take advantage of the helper modules Cache.Support.File and Cache.Support.Hash to build the hashes. These scheme is much stronger when the application code itself is also signed and verified, but that is an exercise for the packaging tools.Full Example:defmodule MyApp.MyScene do use Scenic.Scene import Scenic.Primitives # build the path to the static asset file (compile time) @image_path :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/images/my_image.jpg&quot;) @image_hash Scenic.Cache.Hash.file!( @image_path, :sha ) @graph Graph.build() |&gt; rect( {10, 20}, fill: {:image, @image_hash}) def init( _, _ ) do # load the asset into the cache (run time) Scenic.Cache.Static.Texture.load(@image_path, @image_hash) {:ok, :some_state, push: @graph} end endPub/SubDrivers (or any process...) listen to the font Cache via a simple pub/sub api.Because the graph, may be computed during compile time and pushed at some other time than the assets are loaded, the drivers need to know when the assets become available.Whenever any asset is loaded into the cache, messages are sent to any subscribing processes along with the affected keys. This allows them to react in a loosely-coupled way to how the assets are managed in your scene.","ref":"Scenic.Cache.Static.Texture.html","title":"Scenic.Cache.Static.Texture","type":"module"},{"doc":"Add a scope to an existing texture in the cache.Claiming an asset in the cache adds a lifetime scope to it. This is essentially a refcount that is bound to a pid.Returns true if the item is loaded and the scope is added. Returns false if the asset is not loaded into the cache.","ref":"Scenic.Cache.Static.Texture.html#claim/2","title":"Scenic.Cache.Static.Texture.claim/2","type":"function"},{"doc":"Tests if a key is claimed by the given scope.","ref":"Scenic.Cache.Static.Texture.html#claimed?/2","title":"Scenic.Cache.Static.Texture.claimed?/2","type":"function"},{"doc":"Retrieve a texture from the cache and wrap it in an {:ok, _} tuple.This function ideal if you need to pattern match on the result.Examplesiex&gt; Elixir.Scenic.Cache.Static.Texture.fetch(&quot;missing_hash&quot;) ...&gt; {:error, :not_found} iex&gt; Elixir.Scenic.Cache.Static.Texture.fetch(&quot;valid_hash&quot;) ...&gt; {:ok, :test_data}","ref":"Scenic.Cache.Static.Texture.html#fetch/1","title":"Scenic.Cache.Static.Texture.fetch/1","type":"function"},{"doc":"Retrieve a texture from the Cache.If there is no item in the Cache that corresponds to the hash the function will return either nil or the supplied default valueExamplesiex&gt; Elixir.Scenic.Cache.Static.Texture.get(&quot;missing_hash&quot;) nil ...&gt; Elixir.Scenic.Cache.Static.Texture.fetch(&quot;valid_hash&quot;) {:ok, :test_data}","ref":"Scenic.Cache.Static.Texture.html#get/2","title":"Scenic.Cache.Static.Texture.get/2","type":"function"},{"doc":"Retrieve a texture from the Cache and raise an error if it doesn't exist.If there is no item in the Cache that corresponds to the hash the function will raise an error.","ref":"Scenic.Cache.Static.Texture.html#get!/1","title":"Scenic.Cache.Static.Texture.get!/1","type":"function"},{"doc":"Returns a list of keys claimed by the given scope.","ref":"Scenic.Cache.Static.Texture.html#keys/1","title":"Scenic.Cache.Static.Texture.keys/1","type":"function"},{"doc":"Callback implementation for Scenic.Cache.Base.load/3.","ref":"Scenic.Cache.Static.Texture.html#load/3","title":"Scenic.Cache.Static.Texture.load/3","type":"function"},{"doc":"Callback implementation for Scenic.Cache.Base.load!/3.","ref":"Scenic.Cache.Static.Texture.html#load!/3","title":"Scenic.Cache.Static.Texture.load!/3","type":"function"},{"doc":"Tests if a key is claimed by any scope.","ref":"Scenic.Cache.Static.Texture.html#member?/1","title":"Scenic.Cache.Static.Texture.member?/1","type":"function"},{"doc":"Insert a new texture into the Cache.If the texture is already in the cache, put_new does nothing and just returns {:ok, hash}Parameters:hash - term to use as the retrieval key. Typically a hash of the data itself. It will be required to be a hash of the data in the future.data - term to use as the stored datascope - Optional scope to track the lifetime of this asset against. Can be :global but is usually nil, which defaults to the pid of the calling process.Returns: {:ok, hash}","ref":"Scenic.Cache.Static.Texture.html#put_new/3","title":"Scenic.Cache.Static.Texture.put_new/3","type":"function"},{"doc":"Release a scope claim on an texture.Usually the scope is released automatically when a process shuts down. However if you want to manually clean up, or unload an asset with the :global scope, then you should use release.Parameters:key - the key to release.options - options listOptions:scope - set to :global to release the global scope.delay - add a delay of n milliseconds before releasing. This allows starting processes a chance to claim a scope before it is unloaded.","ref":"Scenic.Cache.Static.Texture.html#release/2","title":"Scenic.Cache.Static.Texture.release/2","type":"function"},{"doc":"Get the current status of a texture in the cache.This is used to test if the current process has claimed a scope on an asset.","ref":"Scenic.Cache.Static.Texture.html#status/2","title":"Scenic.Cache.Static.Texture.status/2","type":"function"},{"doc":"Subscribe the calling process to cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Static.Texture.html#subscribe/2","title":"Scenic.Cache.Static.Texture.subscribe/2","type":"function"},{"doc":"Unsubscribe the calling process from cache messages.Parametershash - The hash key of the asset you want to listen to messages about. Pass in :all for messages about all keyssub_type - Pass in the type of messages you want to unsubscribe from.:put - sent when assets are put into the cache:delete - sent when assets are fully unloaded from the cache:claim - sent when a scope is claimed:release - sent when a scope is released:all - all of the above message types","ref":"Scenic.Cache.Static.Texture.html#unsubscribe/2","title":"Scenic.Cache.Static.Texture.unsubscribe/2","type":"function"},{"doc":"Helpers for reading files in a hash-secured manner.Static assets such as fonts and images are usually stored as files on the local storage device. These files need to be loaded into the cache in order to be used by the various parts of Scenic.Where to store your static file assetsYou can store your assets anywhere in your app's priv/ directory. This directory is special in the sense that the Elixir build system knows to copy its contents into the correct final build location. How you organize your assets inside of priv/ is up to you.my_app/ priv/ static/ images/ asset.jpgAt compile time you need to build the actual path of your asset by combining the build directory with the partial path inside of priv/Examplepath = :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/images/asset.jpg&quot;)You can do this at either compile time or runtime.SecurityA lesson learned the hard way is that static assets (fonts, images, etc.) that your app loads out of storage can easily become attack vectors.These formats are complicated! There is no guarantee (on any system) that a malformed asset will not cause an error in the C code that interprets it. Again - these are complicated and the renderers need to be fast...The solution is to compute a SHA hash of these files during build-time of your and to store the result in your applications code itself. Then during run time, you compare then pre-computed hash against the run-time of the asset being loaded.These scheme is much stronger when the application code itself is also signed and verified, but that is an exercise for the packaging tools.When assets are loaded this way, the @asset_hash term is also used as the key in the cache. This has the additional benefit of allowing you to pre-compute the graph itself, using the correct keys for the correct assets.Full exampledefmodule MyApp.MyScene do use Scenic.Scene # build the path to the static asset file (compile time) @asset_path :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/images/asset.jpg&quot;) # pre-compute the hash (compile time) @asset_hash Scenic.Cache.Hash.file!( @asset_path, :sha ) # build a graph that uses the asset (compile time) @graph Scenic.Graph.build() |&gt; rect( {100, 100}, fill: {:image, @asset_hash} ) def init( _, _ ) { # load the asset into the texture cache (at run time) Scenic.Cache.Static.Texture.load(@asset_path, @asset_hash) {:ok, :some_state, push: @graph} end end","ref":"Scenic.Cache.Support.File.html","title":"Scenic.Cache.Support.File","type":"module"},{"doc":"Read a file into memory.The reason you would use this instead of File.read is to verify the data against a pre-computed hash.Parameters:path - the path to the asset filehash - the pre-computed hash of the file.opts - a list of options. See below.Options:hash - format of the hash. Valid formats include :sha, :sha224, :sha256, :sha384, :sha512, :ripemd160. If the hash option is not set, it will use :sha by default.decompress - if true - decompress the data (zlib) after reading and verifying the hash.On success, returns {:ok, data}","ref":"Scenic.Cache.Support.File.html#read/3","title":"Scenic.Cache.Support.File.read/3","type":"function"},{"doc":"Read a file into memory.The reason you would use this instead of File.read is to verify the data against a pre-computed hash.read! is similar to read except that it raises if an error occurs and returns the data directlyParameters:path - the path to the asset filehash - the pre-computed hash of the fileopts - a list of options. See below.Options:hash - format of the hash. Valid formats include :sha, :sha224, :sha256, :sha384, :sha512, :ripemd160. If the hash option is not set, it will use :sha by default.decompress - if true - decompress the data (zlib) after reading and verifying the hash.On success, returns data","ref":"Scenic.Cache.Support.File.html#read!/3","title":"Scenic.Cache.Support.File.read!/3","type":"function"},{"doc":"Helper functions to work with hash signatures.Both the Cache.File and Cache.Term modules use cryptographic hash signatures to verify that files are valid before using the data they contain.This modules provides a collection of helper functions that make it easy to use, generate and validate these hashes.Any time one of these functions asks for a type of hash, the supported types are: :sha, :sha224, :sha256, :sha384, :sha512, and :ripemd160","ref":"Scenic.Cache.Support.Hash.html","title":"Scenic.Cache.Support.Hash","type":"module"},{"doc":"Calculate the hash of binary dataReturns the hash wrapped in a {:ok, hash} tuple.","ref":"Scenic.Cache.Support.Hash.html#binary/2","title":"Scenic.Cache.Support.Hash.binary/2","type":"function"},{"doc":"Calculate the hash of binary dataReturns the hash directly.","ref":"Scenic.Cache.Support.Hash.html#binary!/2","title":"Scenic.Cache.Support.Hash.binary!/2","type":"function"},{"doc":"Compute hash for the given file","ref":"Scenic.Cache.Support.Hash.html#compute_file/2","title":"Scenic.Cache.Support.Hash.compute_file/2","type":"function"},{"doc":"","ref":"Scenic.Cache.Support.Hash.html#file/2","title":"Scenic.Cache.Support.Hash.file/2","type":"function"},{"doc":"","ref":"Scenic.Cache.Support.Hash.html#file!/2","title":"Scenic.Cache.Support.Hash.file!/2","type":"function"},{"doc":"Verify that the given data conforms to the given hash.If the verification passes, returns {:ok, data} If it fails, returns {:error, :hash_failure}","ref":"Scenic.Cache.Support.Hash.html#verify/3","title":"Scenic.Cache.Support.Hash.verify/3","type":"function"},{"doc":"Verify that the given data conforms to the given hash.If the verification passes, returns the data unchanged. If it fails, raises an error","ref":"Scenic.Cache.Support.Hash.html#verify!/3","title":"Scenic.Cache.Support.Hash.verify!/3","type":"function"},{"doc":"Verify that the data in a file conforms to the given hash.If the verification passes, returns {:ok, hash} If it fails, returns {:error, :hash_failure}","ref":"Scenic.Cache.Support.Hash.html#verify_file/3","title":"Scenic.Cache.Support.Hash.verify_file/3","type":"function"},{"doc":"Verify that the data in a file conforms to the given hash.If the verification passes, returns the hash unchanged. If it fails, raises an error","ref":"Scenic.Cache.Support.Hash.html#verify_file!/3","title":"Scenic.Cache.Support.Hash.verify_file!/3","type":"function"},{"doc":"","ref":"Scenic.Cache.Support.Hash.html#t:hash_type/0","title":"Scenic.Cache.Support.Hash.hash_type/0","type":"type"},{"doc":"Supervisor that starts up and manages the asset caches","ref":"Scenic.Cache.Support.Supervisor.html","title":"Scenic.Cache.Support.Supervisor","type":"module"},{"doc":"","ref":"Scenic.Cache.Support.Supervisor.html#child_spec/0","title":"Scenic.Cache.Support.Supervisor.child_spec/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Scenic.Cache.Support.Supervisor.html#child_spec/1","title":"Scenic.Cache.Support.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Scenic.Cache.Support.Supervisor.html#start_link/1","title":"Scenic.Cache.Support.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Scenic.Utilities.Texture.html","title":"Scenic.Utilities.Texture","type":"module"},{"doc":"","ref":"Scenic.Utilities.Texture.html#build/4","title":"Scenic.Utilities.Texture.build/4","type":"function"},{"doc":"","ref":"Scenic.Utilities.Texture.html#build!/4","title":"Scenic.Utilities.Texture.build!/4","type":"function"},{"doc":"","ref":"Scenic.Utilities.Texture.html#clear!/2","title":"Scenic.Utilities.Texture.clear!/2","type":"function"},{"doc":"","ref":"Scenic.Utilities.Texture.html#get/3","title":"Scenic.Utilities.Texture.get/3","type":"function"},{"doc":"","ref":"Scenic.Utilities.Texture.html#put!/4","title":"Scenic.Utilities.Texture.put!/4","type":"function"},{"doc":"","ref":"Scenic.Utilities.Texture.html#to_rgba/1","title":"Scenic.Utilities.Texture.to_rgba/1","type":"function"},{"doc":"Defines the exception thrown by the CacheModule","ref":"Scenic.Cache.Base.Error.html","title":"Scenic.Cache.Base.Error","type":"exception"},{"doc":"","ref":"Scenic.Primitive.Style.FormatError.html","title":"Scenic.Primitive.Style.FormatError","type":"exception"},{"doc":"","ref":"Scenic.ViewPort.Driver.Error.html","title":"Scenic.ViewPort.Driver.Error","type":"exception"},{"doc":"Upgrading to v0.10Version 0.10 of Scenic contains breaking changes, which will need to be updated in your app in order to run. This is all good through as it enables goodness in the forms of proper font metrics and dynamic raw pixel textures.","ref":"upgrading_to_v0-10.html","title":"Upgrading to v0.10","type":"extras"},{"doc":"Version v0.10 contains two fairly major changes in how things work.Scenic.Cache has been reorganized into asset-specific caches. This is a breaking change.push_graph is deprecated and replaced with a more functional-style return value. This is not a breaking change, but it throws warnings as going forward, the new return values are the way to go.The changes to the cache are described first as they are breaking changes. The non-breaking push_graph deprecation will probably be more work to integrate, but you don't need to do it as immediately.","ref":"upgrading_to_v0-10.html#overview","title":"Upgrading to v0.10 - Overview","type":"extras"},{"doc":"The most important (and immediate) change you need to deal with is to the cache. In order to handle static items with different life-cycle requirements, the cache has been broken out into multiple smaller caches, each for a specific type of content.The module Scenic.Cache is gone and should be replace with the appropriate cache in your code.Asset TypeModuleStatic TexturesScenic.Cache.Static.TextureFontsScenic.Cache.Static.FontFont MetricsScenic.Cache.Static.FontMetricsDynamic TexturesScenic.Cache.Dynamic.Texture","ref":"upgrading_to_v0-10.html#changes-to-the-cache","title":"Upgrading to v0.10 - Changes to the Cache","type":"extras"},{"doc":"Note that caches are marked as either static or dynamic. Things that do not change and can be referred to by a hash of their content go into Static caches. This allows for future optimizations, such as caching these assets on a CDN.The Dynamic.Texture cache is for images that change over time. For example, this could be an image coming off of a camera, or something that you generate directly in your own code. Note that Dynamic caches are more expensive overall as they will not get the same level of optimization in the future.Custom FontsIf you have used custom fonts in your application, you need to use a new process to get them to load and render.Use the truetype_metrics tool in hex to generate a \\*.metrics file for your custom font. This will live in the same folder as your font.Make sure the name of the font file itself ends with the hash of its content. If you use the -d option in truetype_metrics, then that will be done for you.Load the font metrics file into the Scenic.Cache.Static.FontMetrics cache. The hash of this file is the hash that you will use to refer to the font in the graphs.Load the font itself into the Scenic.Cache.Static.Font","ref":"upgrading_to_v0-10.html#static-vs-dynamic-caches","title":"Upgrading to v0.10 - Static vs. Dynamic Caches","type":"extras"},{"doc":"The push-graph/1 function is now deprecated. It still works, but has been replaced with a much more functional-style {:push, graph} return value.This has several immediate benefits. The main advantage is that you can now use all the standard OTP 21+ callbacks, including handle_continue, timeouts and the like. If you call push_graph(), it sends a message back to the scene, so the timeouts will not work. The new form corrects this situation.It also lowers the overall draw latency a little bit. There is one less passed-message for rendering to serialize on.Changes to makeMaking the switch is fairly straight forward. A typical scene pattern with push_graph would look like thisdefmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives import Scenic.Components @graph Graph.build() |&gt; text(&quot;Hello World&quot;, id: :my_text, font_size: 22, translate: {20, 80}) |&gt; button({&quot;Do Something&quot;, :my_btn}, translate: {20, 180}) def init( _scene_args, _options ) do push_graph( @graph ) {:ok, {:could_be_any_state, @graph}} end def handle_event({:click, :my_btn}, _, {inner_state,graph}) do graph = Graph.modify(graph, :my_text, &amp;text(&amp;1, &quot;Hello Scene&quot;)) |&gt; push_graph() {:noreply, {inner_state,graph}} end end This same scene would now look like thisdefmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives import Scenic.Components @graph Graph.build() |&gt; text(&quot;Hello World&quot;, id: :my_text, font_size: 22, translate: {20, 80}) |&gt; button({&quot;Do Something&quot;, :my_btn}, translate: {20, 180}) def init( _scene_args, _options ) do {:ok, {:could_be_any_state, @graph}, push: @graph} end def handle_event({:click, :my_btn}, _, {inner_state,graph}) do graph = Graph.modify(graph, :my_text, &amp;text(&amp;1, &quot;Hello Scene&quot;)) {:noreply, {inner_state,graph}, push: graph} end endThis may not look like a very big change, but the impact is significant, and simpler under the covers.The key is that you indicate that you want to push a graph by returning a {:push, graph} option when you exit any scene handler function. This optional value can be combined with timeout or {:continue, term} options as well (although not both at the same time...)defmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives import Scenic.Components @graph Graph.build() |&gt; text(&quot;Hello World&quot;, id: :my_text, font_size: 22, translate: {20, 80}) |&gt; button({&quot;Do Something&quot;, :my_btn}, translate: {20, 180}) def init( _scene_args, _options ) do {:ok, {:could_be_any_state, @graph}, push: @graph, continue: :some_term} end def handle_event({:click, :my_btn}, _, {inner_state,graph}) do graph = Graph.modify(graph, :my_text, &amp;text(&amp;1, &quot;Hello Scene&quot;)) {:noreply, {inner_state,graph}, push: graph, timeout: 1000} end endThe callbacks section of the scene documentation is now properly filled out, so please refer to that for more information on each of the available return values.","ref":"upgrading_to_v0-10.html#deprecation-of-push_graph","title":"Upgrading to v0.10 - Deprecation of push_graph()","type":"extras"},{"doc":"ScenicScenic is an application framework written directly on the Elixir/Erlang/OTP stack. With it, you can build client-side applications that operate identically across all supported operating systems, including MacOS, Ubuntu, Nerves/Linux, and more.Scenic is primarily aimed at fixed screen connected devices (IoT), but can also be used to build portable applications.","ref":"welcome.html","title":"Scenic","type":"extras"},{"doc":"If you have used versions before v0.10, please see the Upgrading to v0.10 Guide.","ref":"welcome.html#upgrading-to-v0-10","title":"Scenic - Upgrading to v0.10","type":"extras"},{"doc":"If you are new to Scenic, then you should read the following guides.Install DependenciesGeneral OverviewGetting StartedGetting Started with Nerves (IoT)Structure of a SceneLife-cycle of a SceneGraph OverviewPrimitivesStandard ComponentsStylesTransformsContributingCode of ConductWIPViewPort OverviewDriver OverviewNerves","ref":"welcome.html#how-to-get-started","title":"Scenic - How to get started?","type":"extras"},{"doc":"Install DependenciesThe design of Scenic goes to great lengths to minimize its dependencies to just the minimum. Namely, it needs Erlang/Elixir and OpenGL.Rendering your application into a window on your local computer (MacOS, Ubuntu and others) is done by the scenic_driver_glfw driver. It uses the GLFW and GLEW libraries to connect to OpenGL.The instructions below assume you have already installed Elixir/Erlang. If you need to install Elixir/Erlang there are instructions on the elixir-lang website.","ref":"install_dependencies.html","title":"Install Dependencies","type":"extras"},{"doc":"The easiest way to install on MacOS is to use Homebrew. Just run the following in a terminal:brew update brew install glfw3 glew pkg-configOnce these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-macos","title":"Install Dependencies - On MacOS","type":"extras"},{"doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following:sudo apt-get update sudo apt-get install pkgconf libglfw3 libglfw3-dev libglew1.13 libglew-devOnce these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-ubuntu-16","title":"Install Dependencies - On Ubuntu 16","type":"extras"},{"doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following:sudo apt-get update sudo apt-get install pkgconf libglfw3 libglfw3-dev libglew2.0 libglew-devOnce these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-ubuntu-18","title":"Install Dependencies - On Ubuntu 18","type":"extras"},{"doc":"The easiest way to install on Fedora is to use dnf. Just run the following:dnf install glfw glfw-devel pkgconf glew glew-develOnce these components have been installed, you should be able to build the scenic_driver_glfw driver.","ref":"install_dependencies.html#on-fedora","title":"Install Dependencies - On Fedora","type":"extras"},{"doc":"The easiest way to install on Archlinux is to use pacman. Just run the following:sudo pacman -S glfw-x11 glewIf you're using wayland, you'll probably need glfw-wayland instead of glfw-x11 and glew-wayland instead of glew","ref":"install_dependencies.html#on-archlinux","title":"Install Dependencies - On Archlinux","type":"extras"},{"doc":"Next, you should read about General Overview.","ref":"install_dependencies.html#what-to-read-next","title":"Install Dependencies - What to read next?","type":"extras"},{"doc":"General OverviewScenic is a client application framework written directly on the Elixir/Erlang/OTP stack. With it, you can build applications that operate identically across all supported operating systems, including MacOS, Ubuntu, Nerves/Linux, and more.Scenic is primarily aimed at fixed screen connected devices (IoT), but can also be used to build portable applications.","ref":"overview_general.html","title":"General Overview","type":"extras"},{"doc":"Available: Scenic takes full advantage of OTP supervision trees to create applications that are fault-tolerant, self-healing, and highly available under adverse conditions.Small and Fast: The only core dependencies are Erlang/OTP and OpenGL.Self Contained: &quot;Never trust a device if you don't know where it keeps its brain.&quot; The logic to run a device should be on the device and it should remain operational even if the service it talks to becomes unavailable.Maintainable: Each device knows how to run itself. This lets teams focus on new products and only updating the old ones as the business needs.Remotable: Scenic devices know how to run themselves, but can still be accessed remotely. Remote traffic attempts to be as small so it can be used over the Internet, cellular modems, Bluetooth, etc.Reusable: Collections of UI can be packaged up for reuse with, and across applications. I expect to see Hex packages of controls, graphs, and more available for Scenic applications.Flexible: Scenic uses matrices similar to game development to position everything. This makes reuse, scale, positioning and more very flexible and simple.Secure: Scenic is designed with an eye towards security. For now, the main effort is to keep it simple. No browser, Javascript, and other complexity presenting vulnerabilities. There will be much more to say about security later.","ref":"overview_general.html#goals","title":"General Overview - Goals","type":"extras"},{"doc":"Browser: Scenic is not a web browser. It is aimed at a fixed screen devices and certain types of windowed apps. It knows nothing about HTML.3D: Scenic is a 2D UI framework. It uses techniques from game development (such as transform matrices), but it does not support 3D drawing at this time.Immediate Mode: In graphics speak, Scenic is a retained mode system. If you need immediate mode, then Scenic isn't for you. If you don't know what retained and immediate modes are, then you are probably just fine. For reference: HTML is a retained mode model.","ref":"overview_general.html#non-goals","title":"General Overview - Non-Goals","type":"extras"},{"doc":"Scenic is built as a three-layer architectural cake.Scene LayerAt the top is the Scene Layer, which encapsulates all application business logic. The developer will do most of their Scenic work in the Scene layer.ViewPort LayerIn the middle is the ViewPort Layer, which acts as a bridge between the Scenes and the Drivers. The ViewPort controls the scene life-cycle (More on that in Scene Overview), sends graphs down to the drivers, and routes user input up to the correct scene.Driver layerAt the bottom is the Driver layer, which is where knowledge of the graphics hardware and/or remote configuration lives. Drivers draw everything on the screen and originate the raw user input. Developers can write their own drivers, but that will be rare if at all. Dealing with Sensors and other hardware is a different problem space.","ref":"overview_general.html#architecture","title":"General Overview - Architecture","type":"extras"},{"doc":"Scenic is definitely not a browser and has nothing to do with HTML. However, its design attempts to draw analogies to web design so that a developer with experience building web pages will catch on very quickly.The following terms include HTML analogies as appropriate…","ref":"overview_general.html#mental-model","title":"General Overview - Mental Model","type":"extras"},{"doc":"SceneScenes are sort of like a web page. Each scene is a GenServer process that contains state and business logic to handle user input. As the device navigates to different screens, it is moving between scenes.GraphA Graph is a sort of like the DOM. It is a hierarchical set of data that describes things to draw on the screen. The Graph is immutable in the functional coding sense and is manipulated through transform functions.PrimitiveEach node in a Graph is a Primitive. There is relatively small, fixed set of primitives, but they can be combined to draw pretty much any UI you need.ComponentA component is a Scene, with added sugar so that it can be referenced/used by other Scenes. This allows you to build libraries of reusable components and isolates logic into sensible containers. Standard controls such as Button, RadioGroup, Slider and more are written as components.StyleStyles are sort of analogous to CSS styles. Styles are optional parameters you can add to any primitive in a graph. They are inherited down the graph.TransformAll positioning, rotation, scale and such is expressed by applying transform matrices to nodes in a Graph. Transforms are inherited down the graph. You will almost never interact directly with the matrices, as there are very easy helpers that manage them for you.ViewPortA ViewPort is a sort of like a tab in your browser. It manages the scene life-cycle, routes graphs to the drivers, and input back up to the scenes. If you want two windows in your app, you need to start two ViewPorts.DriverDrivers know nothing about scenes but are able to render Graphs to a specific device. That could be a graphics chip or the network… Drivers also collect raw user input and route it back up to the ViewPort.InputThere is a fixed set of user input data (mouse, keyboard, touch, etc.) that drivers generate and hand up to the ViewPort. The ViewPort, in turn, sends the input as a message to the appropriate Scene. Scenes handle raw user input via the handle_input/3 callback.EventIn response to user input (or timers or any other message), a component can generate an event that it sends up to its parent scene. Unlike user input, if the parent doesn't handle it, it is passed up again to that component's parent until it reaches the root scene. Scenes handle events that are bubbling up to the chain via the filter_event/3 callback. This is analogous to event bubbling on a web page.","ref":"overview_general.html#terms-and-definitions","title":"General Overview - Terms and Definitions","type":"extras"},{"doc":"If you are new to Scenic, you should read and follow the exercise in Getting Started.If you want to dig deeper into the structure of a Scene, then read the Scene Overview.","ref":"overview_general.html#what-to-read-next","title":"General Overview - What to read next?","type":"extras"},{"doc":"Getting StartedThis guide will walk you through installing the new project generator, then building your first Scenic application.","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"The Scenic Archive is the home of the scenic.new mix task, which lays out a starter application for you. This is the easiest way to set up a new Scenic project.Install the Scenic Archive like thismix archive.install hex scenic_new","ref":"getting_started.html#install-scenic-new","title":"Getting Started - Install scenic.new","type":"extras"},{"doc":"First, navigate the command-line to the directory where you want to create your new Scenic app. Then run the following commands: (change my_app to the name of your app...)mix scenic.new my_app cd my_app mix do deps.get, scenic.runIf you want to explore the more full-on example, then follow the instructions below.","ref":"getting_started.html#build-the-basic-app","title":"Getting Started - Build the Basic App","type":"extras"},{"doc":"First, navigate the command-line to the directory where you want to create your new Scenic app. Then run the following commands: (change my_app to the name of your app...)mix scenic.new.example my_app cd my_app mix do deps.get, scenic.run","ref":"getting_started.html#build-the-example-app","title":"Getting Started - Build the Example App","type":"extras"},{"doc":"In order to start Scenic, you should first build a configuration for one or more ViewPorts.These configuration maps will be passed in to the main Scenic supervisor. These configurations should live in your app's config.exs file.use Mix.Config # Configure the main viewport for the Scenic application config :my_app, :viewport, %{ name: :main_viewport, size: {700, 600}, default_scene: {MyApp.Scene.Example, nil}, drivers: [ %{ module: Scenic.Driver.Glfw, name: :glfw, opts: [resizeable: false, title: &quot;Example Application&quot;], } ] }Then use that config to start your supervisor with the Scenic supervisor.defmodule MyApp do # ... def start(_type, _args) do import Supervisor.Spec, warn: false # 1. Load the viewport configuration from config main_viewport_config = Application.get_env(:my_app, :viewport) # 2. Start the application with the viewport children = [ # ... supervisor(Scenic, [viewports: [main_viewport_config]]), ] Supervisor.start_link(children, strategy: :one_for_one) end endIn the ViewPort configuration you can do things like set a name for the ViewPort process, its size, the default scene and start one or more drivers.See the documentation for ViewPort Configuration to learn more about how to set the options on a viewport.Note that all the drivers are in separate Hex packages as you should choose the correct one for your application. For example, the Scenic.Driver.Glfw driver draws your scenes into a window under MacOS and Ubuntu. It should work on other OS's as well, such as other flavors of Unix or Windows, but I haven't worked on or tested those yet.","ref":"getting_started.html#configure-scenic","title":"Getting Started - Configure Scenic","type":"extras"},{"doc":"Once the app and its dependencies are set up, there are two main ways to run it.If you want to run your app under IEx so that you can debug it, simply runiex -S mixThis works just like any other Elixir application.If you want to run your app outside of iex, you should start it like this:mix scenic.run","ref":"getting_started.html#running-and-debugging","title":"Getting Started - Running and Debugging","type":"extras"},{"doc":"The starter app created by the generator above shows the basics of building a Scenic application. It has four scenes, two components, and a simulated sensor.Splash: The Splash scene is configured to run when the app is started in the config/config.exs file. It runs a simple animation, then transitions to the Sensor scene. It also shows how to intercept basic user input to exit the scene early.Sensor: The Sensor scene depicts a simulated temperature sensor. The sensor is always running and updates its data through the Scenic.SensorPubSub server.Primitives: The Primitives scenes displays an overview of the basic primitive types and some of the styles that can be applied to them.Components: The Components scene shows the basic components that come with Scenic. The crash button will cause a match error that will crash the scene, showing how the supervision tree restarts the scene. It also shows how to receive events from components.ComponentsNav: The nav bar at the top of the main scenes shows how to navigate between scenes and how to construct a simple component and pass a parameter to it. Note that it references a clock, creating a nested component. The clock is positioned by dynamically querying the width of the ViewPortNotes: The notes section at the bottom of each scene is very simple and also shows passing in custom data from the parent.The simulated temperature sensor doesn't collect any actual data, but does show how you would set up a real sensor and publish data from it into the Scenic.SensorPubSub service.","ref":"getting_started.html#the-starter-app","title":"Getting Started - The Starter App","type":"extras"},{"doc":"Next, you should read about the structure of a scene. This will explain the parts of a scene, how to send and receive messages and how to push the graph to the ViewPort.","ref":"getting_started.html#what-to-read-next","title":"Getting Started - What to read next?","type":"extras"},{"doc":"Getting Started with NervesNerves is a tool chain that builds your application into a minimal boot image that you can use to run on devices such as the Raspberry Pi, BeagleBone Black, and many more.Scenic has everything you need to run on in this environment. In fact, this is the type of system that Scenic was made for! When built with Nerves, the boot-image (this includes Linux, Erlang, Elixir, Scenic, several fonts, etc.) is on the order of 30Mb in size, which is a welcome relief.This guide assumes you have some familiarity with Nerves.","ref":"getting_started_nerves.html","title":"Getting Started with Nerves","type":"extras"},{"doc":"The Scenic Archive is the home of the scenic.new mix task, which lays out a starter application for you. This is the easiest way to set up a new Scenic project.Install the Scenic Archive like thismix archive.install hex scenic_new","ref":"getting_started_nerves.html#install-scenic-new","title":"Getting Started with Nerves - Install scenic.new","type":"extras"},{"doc":"First, navigate the command-line to the directory where you want to create your new Scenic app. Then run the following commands: (change my_app to the name of your app...)mix scenic.new.nerves my_app cd my_appAt this point you have a choice. Do you want to build it locally to run on your dev machine (device specific things won't be there or need to be emulated), or do you want to build a boot image","ref":"getting_started_nerves.html#create-the-basic-nerves-app","title":"Getting Started with Nerves - Create the Basic Nerves App","type":"extras"},{"doc":"The first time you build a nerves app, you need to set the MIX_TARGET, which tells it where you intend to run your app. Then you can install the dependencies. Do that on the command line like this:export MIX_TARGET=host mix deps.getThen you can run the app on your dev machine the same way you would a non-nerves app.mix scenic.run","ref":"getting_started_nerves.html#build-and-run-on-your-dev-machine","title":"Getting Started with Nerves - Build and Run on Your Dev Machine","type":"extras"},{"doc":"The first time you build a nerves app, you need to set the MIX_TARGET, which tells it where you intend to run your app. Then you can install the dependencies. When targeting an embedded device, you will also need to create a release file.Do that on the command line like this:export MIX_TARGET=rpi3 mix deps.get mix compile mix nerves.release.initThen you can build the boot image and burn it to your micro-SD card.mix firmware.burn","ref":"getting_started_nerves.html#build-and-run-on-a-raspberry-pi-3","title":"Getting Started with Nerves - Build and Run on a Raspberry Pi 3","type":"extras"},{"doc":"At the moment, the only supported devices are Raspberry Pis. In fact, the only one I've really tested is the Raspberry Pi 3, although it should work on the others.Support for the BeagleBone is coming, but isn't ready yet.","ref":"getting_started_nerves.html#supported-devices","title":"Getting Started with Nerves - Supported Devices","type":"extras"},{"doc":"Next, you should read about the structure of a scene. This will explain the parts of a scene, how to send and receive messages and how to push the graph to the ViewPort.","ref":"getting_started_nerves.html#what-to-read-next","title":"Getting Started with Nerves - What to read next?","type":"extras"},{"doc":"Structure of a SceneA Scenic.Scene is a GenServer process which creates and manages a Graph that gets drawn to the screen. Scenes also respond to user input and other events.Scenes can reference each other, creating a logical hierarchy that lives above the Graphs themselves. This allows scenes to be reusable, small, and simple. A properly designed scene should do one job, and do it well. Then it can be reused along with other simple scenes to create a complex screen of UI.Scenes that are specifically meant to be reused are called components. Components have sugar apis that make them very easy to use inside of a parent scene.For example, if you create a dashboard, it may have buttons, text input, sliders, or other input controls in it. Each of those controls is a component scene that is dynamically created when the dashboard scene is started. This collection of scenes forms a graph, which can be quite deep (scenes using scenes using scenes).All these scenes communicate with each other by generating events and passing them as messages. This is explained more below.The life-cycle of scenes (when they start, stop, etc.) is explained in the life-cycle of a scene guide.","ref":"overview_scene.html","title":"Structure of a Scene","type":"extras"},{"doc":"The most important state a Scene is responsible for is its Graph. The Graph defines what is to be drawn to the screen, any referenced components, and the overall draw order. When the Scene decides the graph is ready to be drawn to the screen, it pushes it to the ViewPort.In general, a graph is an immutable data structure that you manipulate through transform functions. In the example below Graph.build() creates an empty graph, which is piped into functions that add things to it. The text/3 function accepts a graph, adds some text to it, then applies a list of options to the text.The button/3 is similar to text/3. It accepts a graph, adds a button and applies a list of options to.Text is a Primitive, which can be drawn directly to the screen. The text/3 helper function is imported from the Scenic.Primitives module. Button is a component whose helper function is imported from the Scenic.Components module. defmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives import Scenic.Components @graph Graph.build() |&gt; text(&quot;Hello World&quot;, font_size: 22, translate: {20, 80}) |&gt; button(&quot;Do Something&quot;, translate: {20, 180}) def init( _scene_args, _options ) do {:ok, @graph, push: @graph} end ... endIf you can, build your graphs at compile time instead of at run time. This both reduces load/power use on the device and surfaces any errors early instead of when the device is in use. In the example above, the graph is built at compile time by assigning it to the module attribute @graph. You can read more about module attributes in Elixir's module attribute documentation.In the above example, the graph is pushed to the ViewPort during the init/2 callback function.There is more detail on how to build and manipulate Graph data in the Graph Overview.","ref":"overview_scene.html#the-graph","title":"Structure of a Scene - The Graph","type":"extras"},{"doc":"The only required callback a Scene must implement is init/2. This function is called when the scene is started and is where you should initialize your state. Pushing the graph here is optional, but recommended. If you wait too long to build and push your first graph, the user will see a blank space or screen until you are ready.def init( _scene_args, opts ) do state = %{ graph: @graph, viewport: opts[:viewport] } {:ok, state, push: @graph} endThe first argument, scene_args, is any term that you pass to your scene when you reference it or otherwise configure it in the ViewPort. Look at an example configuration of a ViewPort from the config.exs file... use Mix.Config # Configure the main viewport for the Scenic application config :my_app, :viewport, %{ name: :main_viewport, size: {700, 600}, default_scene: {MyApp.Scene.Example, :scene_init_data}, drivers: [ %{ module: Scenic.Driver.Glfw, name: :glfw, opts: [resizeable: false, title: &quot;Example Application&quot;], } ] }The line default_scene: {MyApp.Scene.Example, :scene_init_data} configures the ViewPort to always start the scene defined by the MyApp.Scene.Example module and to pass in :scene_init_data as the first argument of its init/2 function.That :scene_init_data term could be any data structure you want. It will be passed to the scene's init/2 function unchanged.The second parameter, opts is a Keyword list of contextual/optional data that is generated by the ViewPort and passed to your scene. The main options are:optiondescription:idIf this scene is a component, then the id that was assigned to its reference in the parent's graph is passed in as the :id option. Typically, controls that generate and send events to its parent scene use this id to identify themselves. If this is the root scene, the id will not be set.:stylesThis is the map of styles inherited from the parent graph. The scene can use these styles (or not) as makes sense for its needs.:viewportThis gives the pid of the viewport running this scene. It is very useful if you want to generate input or change the currently showing scene. If you are managing the scene in your own supervisor, it will not be set. See life-cycle of a scene for more information.","ref":"overview_scene.html#initialization","title":"Structure of a Scene - Initialization","type":"extras"},{"doc":"Previous to v0.10, the way to push a graph to the ViewPort was the magic push_graph/1 function, This has been deprecated in favor of a more functional return option. push_graph/1 was also interfering with the newer OTP 21+ continue callbacks and timeouts and such. Since this is only a deprecation push_graph/1 will continue to work, but will log a warning when used. push_graph/1 will be removed in a future release.The new, better way to push a graph is via a {:push, graph} option when you return from any scene callback.def init(_,_) do {:ok, :whatever_state_you_want, push: @graph} end def handle_info(:some_msg, your_state) do graph = Graph.modify( @graph, :some_id, &amp;text(&amp;1, &quot;modified text&quot;) ) {:noreply, your_state, push: graph} endAlmost all (except terminate...) of the callbacks accept a {:push, graph} option. Replacing the call of push_graph(graph) within a callback function depends slightly on the context in which it is used.in init/2:{:ok, state, [push: graph]}in filter_event/3:{:halt, state, [push: graph]}{:cont, event, state, [push: graph]}in handle_cast/2:{:noreply, state, [push: graph]}in handle_info/2:{:noreply, state, [push: graph]}in handle_call/3:{:reply, reply, state, [push: graph]}{:noreply, state, [push: graph]}in handle_continue/3:{:noreply, state, [push: graph]}See the documentation for scene callbacks for more information.","ref":"overview_scene.html#pushing-a-graph","title":"Structure of a Scene - Pushing a Graph","type":"extras"},{"doc":"A Scene also responds to messages. The two types of messages Scenic will send to the scene are user input and events.Input is usually comes from the driver, such as mouse clicks and key presses, it can be handled with Scenic.Scene.handle_input/3.Messages are generally sent from child components (such as a button) and can be handled with Scenic.Scene.filter_event/3.","ref":"overview_scene.html#user-input","title":"Structure of a Scene - User Input","type":"extras"},{"doc":"You are free to send your own messages to scenes just as you would with any other GenServer process. You can use the handle_info/2, handle_cast/2 and handle_call/3 callbacks as you would normally.","ref":"overview_scene.html#events","title":"Structure of a Scene - Events","type":"extras"},{"doc":"Components are simply scenes with a little extra sugar added to make them easy to use from within another scene. To make a component, call the use Scenic.Component macro instead of the Scene version.You will then need to add info/0 and verify/1 callbacks. The verify/1 accepts the scene_args parameter that will be passed to the init/2 function and verifies that it is correctly formatted. If it is correct, return {:ok, data}. If it is not ok, return :invalid_data.In the event that verify/1 returns :invalid_data, then the info/1 callback is called to get a bitstring describing useful information to the developer. This will be included in the error that gets raised. defmodule MyApp.MyComponent do use Scenic.Component import Scenic.Primitives, only: [{:text, 3}, {:update_opts, 2}] @graph Graph.build() |&gt; text(&quot;&quot;, text_align: :center, translate: {100, 200}, id: :text) def info( data ), do: &quot;&quot;&quot; \#{IO.ANSI.red()}\#{__MODULE__} data must be a bitstring \#{IO.ANSI.yellow()}Received: \#{inspect(data)} \#{IO.ANSI.default_color()} &quot;&quot;&quot; def verify( text ) when is_bitstring(text), do: {:ok, text} def verify( _ ), do: :invalid_data def init( text, opts ) do # modify the already built graph graph = @graph |&gt; Graph.modify(:_root_, &amp;update_opts(&amp;1, styles: opts[:styles]) ) |&gt; Graph.modify(:text, &amp;text(&amp;1, text) ) state = %{ graph: graph, text: text } {:ok, state, push: graph} end ... endOther than verifying the incoming information, Components work the same as any other scene.","ref":"overview_scene.html#components","title":"Structure of a Scene - Components","type":"extras"},{"doc":"You can add a component (like the one above) to a scene's graph via the add_to_graph/3 public function that is added to your component via the use Scenic.Component macro. defmodule MyApp.Scene.ExampleScene do @graph Graph.build() |&gt; MyApp.MyComponent.add_to_graph(:init_data, translate: {10, 20}) ... endThe first time this graph is submitted to the ViewPort via push_graph/1, that will trigger the life-cycle management of the MyApp.MyComponent scene process.If this is a component you intend to make available to other developers, then you should also create a helper function to make this more compact. Look at the source code for the Scenic.Components module for examples. This entire module is a collection of helper functions whose job is to provide sugary access to the basic components' add_to_graph/3 functions.With helper functions, the above graph would be re-written like this: @graph Graph.build() |&gt; my_component( :init_data, translate: {10, 20} )","ref":"overview_scene.html#adding-components-to-a-parent-scene","title":"Structure of a Scene - Adding Components to a Parent Scene","type":"extras"},{"doc":"Next, you should read about the life-cycle of a scene. This will explain how scenes get started, when they stop, and how they relate to each other.","ref":"overview_scene.html#what-to-read-next","title":"Structure of a Scene - What to read next?","type":"extras"},{"doc":"Life-cycle of a SceneA very important part of Scenic is the Scene life-cycle management. Most scenes' life-cycles will be managed automatically by their ViewPort. The ViewPort determines when to start and stop these dynamic scenes.In effect, when you create a graph and add components like button, checkbox and more, you are doing more than just saying, &quot;Draw a button here&quot;. You are instructing the ViewPort how and when to start and stop the processes that drive those components.","ref":"scene_lifecycle.html","title":"Life-cycle of a Scene","type":"extras"},{"doc":"This process starts when you set a root scene into the ViewPort. This is first done when you configure your ViewPort in config.exs config :my_app, :viewport, %{ name: :main_viewport, size: {700, 600}, default_scene: {MyApp.Scene.MyFancyScene, :some_init_data}, ... }In the above configuration, when Scenic first starts up, it will start the configured ViewPort. This ViewPort will, in turn, start up the scene defined in the module MyApp.Scene.MyFancyScene and pass in :some_init_data as the first parameter to its init/2 function.Afterwards, you can dynamically change the root scene by calling Scenic.ViewPort.set_root/3. Both ways of setting the root scene effectively do the same thing.","ref":"scene_lifecycle.html#the-root-scene","title":"Life-cycle of a Scene - The Root Scene","type":"extras"},{"doc":"As MyApp.Scene.MyFancyScene initializes, it eventually calls its push_graph/1 function.When a scene calls push_graph/1, the primitives in the graph are sent out for rendering and the components in the graph are started or stopped as needed.To say it another way, when you reference components like button, checkbox and the others, you are programming the supervision tree for your scene.Your scene has an internal DynamicSupervisor, which supervises these dynamic scenes that you asked for in your graph. Each of these can also have a dynamic supervisor and spin up more scenes in a nested tree.At some point, depending on your target processor, you will start to have performance issues if you nest too many components too deeply.The good news is that as you switch away to different root scenes, all the old components are automatically cleaned up for you.","ref":"scene_lifecycle.html#dynamically-supervised-scenes","title":"Life-cycle of a Scene - Dynamically Supervised Scenes","type":"extras"},{"doc":"If you have a component scene that is used by may other scenes, or even in multiple ViewPorts at the same time, you can save memory and reduce load by supervising those scenes yourself.To do this, create a supervisor in your application and start one or more scenes under it. You can give these scenes names, which is how you will reference them from your graphs.defmodule MyApp.Scene.Supervisor do use Supervisor def start_link() do Supervisor.start_link(__MODULE__, :ok) end def init(:ok) do children = [ {MyApp.Scene.AppScene, {:some_init_data, [name: :app_scene]}}, {Scenic.Clock.Digital, {[], [name: :clock]}} ] Supervisor.init(children, strategy: :one_for_one) end endWhen you build your graphs, you can now use this statically supervised scene directly through the scene_ref/3 helper in Scenic.Primitives.@graph Graph.build() |&gt; scene_ref(:app_scene, translate: {300, 300}) |&gt; scene_ref(:clock, translate: {400, 20})The main trade-off you make when you supervise a scene yourself is that the scene no longer knows which ViewPort it is running in. It could be several at the same time! You will not be able to use functions like ViewPort.set_root from these scenes.The second trade-off is that if the root scene doesn't reference a scene you are supervising yourself, then that scene is still taking up memory in both the scene and the driver even though it isn't being drawn.","ref":"scene_lifecycle.html#app-supervised-scenes","title":"Life-cycle of a Scene - App Supervised Scenes","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the Graph Overview next.","ref":"scene_lifecycle.html#what-to-read-next","title":"Life-cycle of a Scene - What to read next?","type":"extras"},{"doc":"Graph OverviewThe most important state a Scene is responsible for is its Graph. The Graph defines what is to be drawn to the screen, any referenced components, and the overall draw order. When a Scene decides the graph is ready to be drawn to the screen, it pushes it to the ViewPort.Graphs are made out of a handful of primitives, each of which knows how to draw one thing. When multiple primitives are put together, almost any standard UI can be drawn.For example, the graph below shows the words &quot;Hello World&quot; around them.@graph Graph.build(font: :roboto, font_size: 24) |&gt; text(&quot;Hello World&quot;, text_align: :center, translate: {300, 300}) |&gt; circle(100, stroke: {2, :green}, translate: {300, 300})In the example above, the first line creates a new graph and assigns two font styles to its root. The next two lines form a pipeline that adds primitives to the root node of the new graph. Each of these primitives also assigns styles.","ref":"overview_graph.html","title":"Graph Overview","type":"extras"},{"doc":"There is a fixed set of primitives that Scenic knows how to draw. These form the base set of things that you can do. While they seem simple, when combined you draw pretty much any 2D UI that you need.Read more about the primitives here.In general, each primitive renders one thing to the screen. The Group primitive is sort of like a &lt;div&gt; tag in html in that it creates a new node in the graph hierarchy that more primitives can be organized beneath.Each primitive can also be assigned styles and transforms, which affect how (or whether) they are drawn and where.","ref":"overview_graph.html#primitives","title":"Graph Overview - Primitives","type":"extras"},{"doc":"In addition to the fixed set of primitives, there is also a fixed set of primitive styles. (Some components support more styles, but they really get boiled down to the primitive styles when it is time to render)Read more about the styles here.Styles are inherited down the graph hierarchy. This means that if you set a style on the root of a graph, or in a group, then any primitives below that node inherit those styles without needing to explicitly set them on every single primitive.For example, in the following graph, the font and font_size styles are set at the root. Both text primitives inherit those values, although the second one overrides the size with something bigger.@graph Graph.build(font: :roboto, font_size: 24) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, translate: {400, 300})","ref":"overview_graph.html#styles","title":"Graph Overview - Styles","type":"extras"},{"doc":"The final type of primitive control is transforms. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives.A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations.Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.You can read about the transform types here.Transforms are inherited down the graph hierarchy. This means that if you place a rotation transform at the root of a graph, then all the primitives will be rotated around a common point.If you want to zoom in, scroll, or rotate a UI, or just pieces of the UI, you can do that very easily by applying transforms.In the example below, the first text line is translated, and the second is scaled bigger, and the whole graph rotated 0.4 radians.@graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, scale: 1.5)","ref":"overview_graph.html#transforms","title":"Graph Overview - Transforms","type":"extras"},{"doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data.As such, once you make a graph, it stays in memory unchanged - until you change it via Graph.modify/3. Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it.Graph.modify/3 is the single Graph function that you will use the most.For example, lets go back to our graph with the two text items in it.@graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}, id: :small_text) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, scale: 1.5, id: :big_text)This time, we've assigned ids to both of the text primitives. This makes it easy to find and modify that primitive in the graph.graph = @graph |&gt; Graph.modify( :small_text, &amp;text(&amp;1, &quot;Smaller Hello&quot;, font_size: 16)) |&gt; Graph.modify( :big_text, &amp;text(&amp;1, &quot;Bigger Hello&quot;, font_size: 60))Notice that the graph is modified multiple times in the pipeline.","ref":"overview_graph.html#modifying-a-graph","title":"Graph Overview - Modifying a graph","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the Primitives Overview next.","ref":"overview_graph.html#what-to-read-next","title":"Graph Overview - What to read next?","type":"extras"},{"doc":"ViewPort OverviewGive an overview of a viewport hereComing soon","ref":"overview_viewport.html","title":"ViewPort Overview","type":"extras"},{"doc":"Driver OverviewGive an overview of a scene hereComing soon","ref":"overview_driver.html","title":"Driver Overview","type":"extras"},{"doc":"Styles OverviewStyles are optional modifiers that you can put on any primitive. Each style does a specific thing and some only affect certain primitives.There is a fixed list of primitive styles which are understood by the drivers. Some Components may introduce their own optional styles, but the only ones sent down to the drivers for rendering are contained in the list below.In general, the primitive styles are each defined in their own module, but you apply them as options in a primitive's option list.For example, to use the style defined in the module Scenic.Primitive.Style.Font you would define an option on a text primitive like this:graph = Graph.build |&gt; text( &quot;Styled Text&quot;, font: :roboto_slab )","ref":"overview_styles.html","title":"Styles Overview","type":"extras"},{"doc":"Cap sets how to draw the end of a line.ClearColor sets the background color. Fill fills in a primitive with a paint style.Font sets the font to use to draw text.FontBlur applies a blur effect to text.FontSize sets the point size text.Hidden a flag that sets if a primitive is drawn at all.Join sets how to render the intersection of two lines. Works on the intersections of other primitives as well.MiterLimit sets whether or not to miter a joint if the intersection of two lines is very sharp.Scissor defines a rectangle that drawing will be clipped to.Stroke defines how to draw the edge of a primitive. Specifies both a width and a paint style.TextAlign sets the alignment of text relative to the starting point. Examples: :left, :center, or :rightTheme a collection of default colors. Usually passed to components, telling them how to draw in your preferred color scheme.","ref":"overview_styles.html#primitive-styles","title":"Styles Overview - Primitive Styles","type":"extras"},{"doc":"The Fill and Stroke styles accept a paint type. This describes what to fill or stroke the primitive with.There is a fixed set of paint types that the drivers know how to render.BoxGradient fills a primitive with a box gradient.Color fills a primitive with a solid color. Image fills a primitive with an image that is loaded into Scenic.Cache.LinearGradient fills a primitive with a linear gradient.RadialGradient fills a primitive with a radial gradient.Specifying PaintWhen you use either the Fill and Stroke you specify the paint in a tuple like this.graph = Graph.build |&gt; circle( 100, fill: {:color, :green}, stroke: {2, {:color, :blue}} )Each paint type has specific values it expects in order to draw. See the documentation for that paint type for details.Color PaintSpecifying a solid color to paint is very common, so has a shortcut. If you simply set a valid color as the paint type, it is assumed that you mean Color.graph = Graph.build |&gt; circle( 100, fill: :green, stroke: {2, :blue} ) # simple color |&gt; rect( {100, 200}, fill: {:green, 128} ) # color with alpha |&gt; rect( {100, 100}, fill: {10, 20, 30, 40} ) # red, green, blue, alpha","ref":"overview_styles.html#primitive-paint-styles","title":"Styles Overview - Primitive Paint Styles","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the Transforms Overview next.","ref":"overview_styles.html#what-to-read-next","title":"Styles Overview - What to read next?","type":"extras"},{"doc":"Transforms OverviewUnlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives.A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations.Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.Multiple transforms can be applied to any primitive. Transforms combine down the graph to create a very flexible way to manage your scene.There are a fixed set of transform helpers that create matrices for you.Matrix hand specify a matrix.Pin set a pin to rotate or scale around. Most primitives define a sensible default pin.Rotate rotate around the pin.Scale scale larger or smaller. Centered around the pin.Translate move/translate horizontally and vertically.Specifying TransformsYou apply transforms to a primitive the same way you specify styles.graph = Graph.build |&gt; circle( 100, fill: {:color, :green}, translate: {200, 200} ) |&gt; ellipse( {40, 60, fill: {:color, :red}, rotate: 0.4, translate: {100, 100} )Don't worry about the order you apply transforms to a single object. Scenic will multiply them together in the correct way when it comes time to render them.","ref":"overview_transforms.html","title":"Transforms Overview","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the ViewPort Overview next.","ref":"overview_transforms.html#what-to-read-next","title":"Transforms Overview - What to read next?","type":"extras"},{"doc":"Primitives OverviewPrimitives are the simplest thing that Scenic know how to draw to the screen. Everything that you see in a Scenic application is drawn by combining multiple primitives together to make complex UIs.There is a fixed set of primitives. This simplifies the internals of Scenic, particularly when it comes to communicating to the drivers. New primitives may be added in the future, but those require serious thought and coordination.Arc draws an arc. This would be a line cut out of a part of the edge of a circle. If you want a shape that looks like a piece of pie, then you should use the Sector.Circle draws a circle. Ellipse draws an ellipse.Group doesn't draw anything. Instead, it creates a node in the graph that you can insert more primitives into. Any styles or transforms you apply to the Group are inherited by all the primitives below it.Line draws a line.Path is sort of an escape valve for complex shapes not covered by the other primitives. You supply a list of instructions, such as :move_to, :line_to, :bezier_to, etc. to generate a complex shape.Quad draws polygon with four sides.Rectangle draws a rectangle.RoundedRectangle draws a rectangle with the corners rounded by a given radius.SceneRef doesn't draw anything by itself. Instead it points to another scene/graph and tells the driver to draw that here.Sector draws a shape that looks like a piece of pie. If you want to stroke just the curved edge, then combine it with an Arc.Text draws a string of text.Triangle draws a triangle.","ref":"overview_primitives.html","title":"Primitives Overview","type":"extras"},{"doc":"The easiest way to insert primitives into your graph is to import the functions in Scenic.Primitives into your scene module. This adds a helper function for each primitive that you can use in a pipeline to build a graph. defmodule MyApp.Scene.Example do use Scenic.Scene alias Scenic.Graph import Scenic.Primitives @graph Graph.build(font: :roboto, font_size: 22) |&gt; text(&quot;Hello World&quot;, text_align: :center, translate: {300, 350}) |&gt; circle(150, fill: :green, translate: {300, 350}) ... endIn the example above, the scene calls import Scenic.Primitives, which imports helpers for all the primitives. Since the graph only uses text and circle, you could save a tiny bit of memory by just importing what you need. import Scenic.Primitives, only: [{:text,3}, {:circle, 3}]Once the helpers are imported, you call each call appends a primitive to the graph.","ref":"overview_primitives.html#using-primitives","title":"Primitives Overview - Using Primitives","type":"extras"},{"doc":"In addition to the fixed set of primitives, there is also a fixed set of primitive styles. (Some components support more styles, but they really get boiled down to the primitive styles when it is time to render)Read more about the styles here.Styles are inherited down the graph hierarchy. This means that if you set a style on the root of a graph, or in a group, then any primitives below that node inherit those styles without needing to explicitly set them on every single primitive.For example, in the following graph, the font and font_size styles are set at the root. Both text primitives inherit those values, although the second one overrides the size with something bigger.@graph Graph.build(font: :roboto, font_size: 24) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, translate: {400, 300})","ref":"overview_primitives.html#styles","title":"Primitives Overview - Styles","type":"extras"},{"doc":"The final type of primitive control is transforms. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix based transforms. This is common in video games and provides powerful control of your primitives.A matrix is an array of numbers that can be used to change the positions, rotations, scale and more of locations.Don't worry! You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.You can read about the transform types here.Transforms are inherited down the graph hierarchy. This means that if you place a rotation transform at the root of a graph, then all the primitives will be rotated around a common point.If you want to zoom in, scroll, or rotate a UI, or just pieces of the UI, you can do that very easily by applying transforms.In the example below, the first text line is translated, and the second is scaled bigger, and the whole graph rotated 0.4 radians.@graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, scale: 1.5)","ref":"overview_primitives.html#transforms","title":"Primitives Overview - Transforms","type":"extras"},{"doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data.As such, once you make a graph, it stays in memory unchanged - until you change it via Graph.modify/3. Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it.@graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4) |&gt; text(&quot;Hello World&quot;, translate: {300, 300}, id: :small_text) |&gt; text(&quot;Bigger Hello&quot;, font_size: 40, scale: 1.5, id: :big_text)In the above graph, we've assigned :id values to both primitives. This makes it easy to find and modify that primitive in the graph. Graph.modify/3 is very fast at finding primitives marked with an :id. If you marked multiple primitives withe id: :small_text, then they would all be modified by the call to Graph.modify/3graph = @graph |&gt; Graph.modify( :small_text, &amp;text(&amp;1, &quot;Smaller Hello&quot;, font_size: 16)) |&gt; Graph.modify( :big_text, &amp;text(&amp;1, &quot;Bigger Hello&quot;, font_size: 60))Notice that the graph is modified multiple times in the pipeline.The last parameter to Graph.modify/3 is a pointer to a function that receives a primitive and returns the new primitive that should be inserted in its place.The following is the same as one of the calls above, but in expanded form to make it easier to see what is going ongraph = Graph.modify( graph, :small_text, fn(primitive) -&gt; text(primitive, &quot;Smaller Hello&quot;, font_size: 16) end)","ref":"overview_primitives.html#modifying-a-primitive","title":"Primitives Overview - Modifying a Primitive","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the Styles Overview next.","ref":"overview_primitives.html#what-to-read-next","title":"Primitives Overview - What to read next?","type":"extras"},{"doc":"Cache OverviewOften, scenes will need to use assets, such as an image, or a custom font when being rendered. These assets are often large, static, and used in multiple scenes. In order to handle these assets effectively, Scenic has a built-in cache for them.The goals of the cache are as follows:Only load assets once into memory even though they may be used by multiple scenes and drivers.Facilitate fast caching of static assets across computers.Allow drivers to monitor assets in the cache to optimize their resource usage.","ref":"overview_cache.html","title":"Cache Overview","type":"extras"},{"doc":"There are different types of assets in Scenic. Each have their own rules for loading, verification, and life-cycle. This is managed by launching a light weight cache process for each asset type. Examples of this are:Scenic.Cache.Static.Texture # for image fills (static images) Scenic.Cache.Static.FontMetrics # font metrics for working with strings Scenic.Cache.Static.Font # custom fonts you may want to use Scenic.Cache.Dynamic.Texture # for image fills (changing images)If you wish to add your own cache types, you can create a custom cache. See below.Note: versions 0.9 and below of Scenic used a single cache for all types of assets. Version 0.10 and above use a cache-per-type in order to better handle the different life-cycles and rules of these items.","ref":"overview_cache.html#asset-types","title":"Cache Overview - Asset Types","type":"extras"},{"doc":"As you look at the asset types, take special note that they are static or dynamic in nature.The static assets require and enforce a hash as the key to the asset. This is both protects the contents against unwanted change, and allows for a very efficient way to reference these items both within a single machine and across the Internet.The dynamic assets can have any string you desire as the key and are not cached across machines as they changing in nature. If you are capturing images from a camera and displaying it in a scene, you will want to put it in the dynamic texture cache.","ref":"overview_cache.html#static-vs-dynamic-assets","title":"Cache Overview - Static vs. Dynamic assets","type":"extras"},{"doc":"You can create your own custom asset caches. Please look at the code for Scenic.Cache.Static.Texture or Scenic.Cache.Dynamic.Texture as an example. You will need to start your custom cache in a Supervisor that you set up.When you create your cache, you have a few options to fill out to set.defmodule Scenic.Cache.Static.Texture do use Scenic.Cache.Base, name: &quot;texture&quot;, static: true ... endThe :static option is very important. If set to true, the asset will be cache-able across machines, but not changeable after it is loaded. The key should always be a hash of the content, although you need to enforce that in your load function.The :name option should be a dev-friendly name for the asset that will appear in the generated documentation for your new cache.","ref":"overview_cache.html#custom-asset-types","title":"Cache Overview - Custom Asset Types","type":"extras"},{"doc":"If you would like to add a custom font to use in your Scenic application, you will need to generate a FontMetrics file for it and load that into the cache.Please see the custom font guide for more information.","ref":"overview_cache.html#adding-custom-fonts","title":"Cache Overview - Adding Custom Fonts","type":"extras"},{"doc":"Using Custom FontsScenic ships standard with support for the Roboto and Roboto_Mono fonts. The Roboto_Slab font is no longer standard in Scenic.You can, however, add the RobotoSlab font, and most any other TrueType font you want to use into Scenic.To do this you will need do the following steps.Download the font you want to use and add it to the static files of your priv/ folder in your application. Please be aware of font licenses and make good choices.Use the truetype_metrics hex package to generate a *.metrics file, which you also add to your priv/ folder. This tool will also change the name of your font so that a hash of the data is included in the file name.Load the *.metrics file into the Scenic.Cache.Static.FontMetrics cache.Refer to the font by the key to the metrics file in the graph where you want to use it.These steps are descried in detail below","ref":"custom_fonts.html","title":"Using Custom Fonts","type":"extras"},{"doc":"Download your custom font and place it into your static assets folder. A typical static assets layout would look like this...priv/ static/ fonts/ Roboto_Slab/ LICENSE.txt RobotoSlab-Regular.ttf","ref":"custom_fonts.html#add-the-custom-font-file","title":"Using Custom Fonts - Add the custom font file","type":"extras"},{"doc":"Use the truetype_metrics tool to generate a font metrics file. This tool is not included in Scenic because this code is complicated (don't get me started on the TrueType format) and only needs to be used once when you set up your project.This tool will do two things. It will create a \\*.metrics file and decorate the name of the font itself with a hash of its contents.You may need to install the tool as an archive firstmix archive.install hex truetype_metricsThen you can run the tool, pointing at your font directorymix truetype_metrics -d priv/static/fonts/Roboto_SlabWhen you are done, static folder will look something like thispriv/ static/ fonts/ Roboto_Slab/ LICENSE.txt RobotoSlab-Regular.ttf.0IXAWqFTtjn6MKSgQOzxUgxNKGrmyhqz1e2d90PVHck RobotoSlab-Regular.ttf.metricsRead the truetype_metrics documentation to learn how to recurse font folders, control the font name decoration and force the file to be re-generated.","ref":"custom_fonts.html#generate-the-metrics-file","title":"Using Custom Fonts - Generate the \\*.metrics file","type":"extras"},{"doc":"In your scene, you need to make load both the \\*.metrics file into the Scenic.Cache.Static.FontMetrics cache and the font itself into the Scenic.Cache.Static.Font cache.@custom_font_hash &quot;0IXAWqFTtjn6MKSgQOzxUgxNKGrmyhqz1e2d90PVHck&quot; @custom_metrics_path :code.priv_dir(:scenic_example) |&gt; Path.join(&quot;/static/fonts/Roboto_Slab/RobotoSlab-Regular.ttf.metrics&quot;) @custom_metrics_hash Scenic.Cache.Support.Hash.file!(@custom_metrics_path, :sha) def init(_, _opts) do # load the custom font font_folder = :code.priv_dir(:my_app) |&gt; Path.join(&quot;/static/fonts&quot;) custom_metrics_path = :code.priv_dir(:scenic_example) |&gt; Path.join(&quot;/static/fonts/Roboto_Slab/RobotoSlab-Regular.ttf.metrics&quot;) Cache.Static.Font.load(font_folder, @custom_font_hash) Cache.Static.FontMetrics.load(custom_metrics_path, @custom_metrics_hash) # no need to put the graph into state as we won&#39;t be using it again {:ok, nil, push: @graph} endNote that if you use this font everywhere, you may want to load it once during app startup with the :global scope. Then you can just refer to it without having to load it in every scene.Cache.Static.Font.load(@font_folder, @custom_font_hash, scope: :global) Cache.Static.FontMetrics.load(@custom_metrics_path, @custom_metrics_hash, scope: :global)","ref":"custom_fonts.html#load-the-metrics-file-and-the-font-into-the-cache","title":"Using Custom Fonts - Load the \\*.metrics file and the font into the cache","type":"extras"},{"doc":"Finally, you use the key to refer to the font metrics in the graph. The font itself will be loaded and used automatically as needed. The metrics file already contains the hash of the font itself.text_spec(&quot;Font Test&quot;, translate: {0, 40}, font_size: 60, font: @custom_metrics_hash)","ref":"custom_fonts.html#refer-to-the-font-by-the-metrics-key","title":"Using Custom Fonts - Refer to the font by the metrics key","type":"extras"},{"doc":"Contributor Code of ConductAs contributors and maintainers of this project, and in the interest of fostering an open and welcoming community, we pledge to respect all people who contribute through reporting issues, posting feature requests, updating documentation, submitting pull requests or patches, and other activities.We are committed to making participation in this project a harassment-free experience for everyone, regardless of the level of experience, gender, gender identity and expression, sexual orientation, disability, personal appearance, body size, race, ethnicity, age, religion, or nationality.Examples of unacceptable behavior by participants include:The use of sexualized language or imageryPersonal attacksTrolling or insulting/derogatory commentsPublic or private harassmentPublishing other's private information, such as physical or electronic addresses, without explicit permissionOther unethical or unprofessional conduct.Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct. By adopting this Code of Conduct, project maintainers commit themselves to fairly and consistently applying these principles to every aspect of managing this project. Project maintainers who do not follow or enforce the Code of Conduct may be permanently removed from the project team.This code of conduct applies both within project spaces and in public spaces when an individual is representing the project or its community.Instances of abusive, harassing or otherwise unacceptable behavior may be reported by opening an issue or contacting one or more of the project maintainers.This Code of Conduct is adapted from the Contributor Covenant, version 1.2.0, available at http://contributor-covenant.org/version/1/2/0/","ref":"code_of_conduct.html","title":"Contributor Code of Conduct","type":"extras"},{"doc":"Contributing to ScenicPlease take a moment to review this document in order to make the contribution process easy and effective for everyone involved! Also, make sure you read our Code of Conduct that outlines our commitment towards an open and welcoming environment.","ref":"contributing.html","title":"Contributing to Scenic","type":"extras"},{"doc":"There are many components that could be written and shared with the community. Only a few really core ones should be in the Scenic package itself. If you have ideas for components, I would love the see the community supply optional packages of them for developers to use.Each component package should have the component models themselves, and a &quot;Components&quot; module that contains helper functions to make adding the new components very simple.See the code for Scenic.Components for example helper functions.","ref":"contributing.html#components","title":"Contributing to Scenic - Components","type":"extras"},{"doc":"Use the issues tracker for:Bug ReportsSubmitting Pull RequestsPlease do not use the issue tracker for personal support requests nor feature requests. Support requests should be sent to:Still working on this bit...For now, please play around with it. I would gladly accept help documenting it.Over the coming weeks, I'll set up discussion mailing lists and whatever. Simply haven't gotten there yet.We do our best to keep the issue tracker tidy and organized, making it useful for everyone. For example, we classify open issues per perceived difficulty, making it easier for developers to contribute to Scenic.","ref":"contributing.html#using-the-issue-tracker","title":"Contributing to Scenic - Using the issue tracker","type":"extras"},{"doc":"A bug is either a demonstrable problem that is caused by the code in the repository or indicate missing, unclear, or misleading documentation. Good bug reports are extremely helpful - thank you!Guidelines for bug reports:Use the GitHub issue search &amp;mdash; check if the issue has already been reported.Check if the issue has been fixed &amp;mdash; try to reproduce it using the master branch in the repository.Isolate and report the problem &amp;mdash; ideally, create a reduced test case.Please try to be as detailed as possible in your report. Include information about your Operating System, as well as your Erlang, Elixir and Scenic versions. Please provide steps to reproduce the issue as well as the outcome you were expecting! All these details will help developers to fix any potential bugs.Example:Short and descriptive example bug report title A summary of the issue and the environment in which it occurs. If suitable, include the steps required to reproduce the bug. 1. This is the first step 2. This is the second step 3. Further steps, etc. `&lt;url&gt;` - a link to the reduced test case (e.g. a GitHub Gist) Any other information you want to share that is relevant to the issue being reported. This might include the lines of code that you have identified as causing the bug, and potential solutions (and your opinions on their merits).","ref":"contributing.html#bug-reports","title":"Contributing to Scenic - Bug reports","type":"extras"},{"doc":"Feature requests are welcome and should be currently be discussed as an issue in github. This will change to either a topic in Elixir forum or a mail-list soon.Before you make a request however, please take a moment to find out whether your idea fits with the scope and aims of the project. It's up to you to make a strong case to convince the community of the merits of this feature. Please provide as much detail and context as possible.","ref":"contributing.html#feature-requests","title":"Contributing to Scenic - Feature requests","type":"extras"},{"doc":"Code documentation (@doc, @moduledoc, @typedoc) has a special convention: the first paragraph is considered to be a short summary.For functions, macros and callbacks say what it will do. For example write, something like:@doc &quot;&quot;&quot; Marks the given value as HTML safe. &quot;&quot;&quot; def safe({:safe, value}), do: {:safe, value}For modules, protocols and types say what it is. For example, write something like:defmodule MyModule.HTML do @moduledoc &quot;&quot;&quot; Conveniences for working HTML strings and templates. ... &quot;&quot;&quot;Keep in mind that the first paragraph might show up in a summary somewhere, long texts in the first paragraph create very ugly summaries. As a rule of thumb, anything longer than 80 characters is too long.Try to keep unnecessary details out of the first paragraph, it's only there to give a user a quick idea of what the documented &quot;thing&quot; does/is. The rest of the documentation string can contain the details, for example when a value and when nil is returned.If possible include examples, preferably in a form that works with doctests. This makes it easy to test the examples so that they don't go stale and examples are often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation","title":"Contributing to Scenic - Contributing Documentation","type":"extras"},{"doc":"Good pull requests - patches, improvements, new features - are a fantastic help. They should remain focused in scope and avoid containing unrelated commits.IMPORTANT: By submitting a patch, you agree that your work will be licensed under the license used by the project.If you have any large pull request in mind (e.g. implementing features, refactoring code, etc.), please ask first otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project.Please adhere to the coding conventions in the project (indentation, accurate comments, etc.) and don't forget to add your own tests and documentation. When working with git, we recommend the following process in order to craft an excellent pull request:Fork the project, clone your fork, and configure the remotes:# Clone your fork of the repo into the current directory git clone https://github.com/&lt;your-username&gt;/scenic # Navigate to the newly cloned directory cd scenic # Assign the original repo to a remote called &quot;upstream&quot; git remote add upstream https://github.com/boydm/scenicIf you cloned a while ago, get the latest changes from upstream, and update your fork:git checkout master git pull upstream master git pushCreate a new topic branch (off of master) to contain your feature, change, or fix.IMPORTANT: Making changes in master is discouraged. You should always keep your local master in sync with upstream master and make your changes in topic branches.git checkout -b &lt;topic-branch-name&gt;Commit your changes in logical chunks. Keep your commit messages organized, with a short description in the first line and more detailed information on the following lines. Feel free to use Git's interactive rebase feature to tidy up your commits before making them public.Make sure all the tests are still passing.mix testPush your topic branch up to your fork:git push origin &lt;topic-branch-name&gt;Open a Pull Request with a clear title and description.If you haven't updated your pull request for a while, you should consider rebasing on master and resolving any conflicts.IMPORTANT: Never ever merge upstream master into your branches. You should always git rebase on master to bring your changes up to date when necessary.git checkout master git pull upstream master git checkout &lt;your-topic-branch&gt; git rebase masterThank you for your contributions!","ref":"contributing.html#pull-requests","title":"Contributing to Scenic - Pull requests","type":"extras"},{"doc":"These Guides aim to be inclusive. We use &quot;we&quot; and &quot;our&quot; instead of &quot;you&quot; and &quot;your&quot; to foster this sense of inclusion.Ideally, there is something for everybody in each guide, from beginner to expert. This is hard, maybe impossible. When we need to compromise, we do so on behalf of beginning users because expert users have more tools at their disposal to help themselves.The general pattern we use for presenting information is to first introduce a small, discreet topic, then write a small amount of code to demonstrate the concept, then verifies that the code worked.In this way, we build from small, easily digestible concepts into more complex ones. The shorter this cycle is, as long as the information is still clear and complete, the better.For formatting the guides:We use the &quot;elixir&quot; code fence for all module code.We use the &quot;console&quot; code fence for iex and shell commands.We use backticks for filenames and directory paths.We use backticks for module names, function names, and variable names.This contribution guide is adapted from the Phoenix contribution guide.","ref":"contributing.html#guides","title":"Contributing to Scenic - Guides","type":"extras"}]